;; glog.el: BBS log browser under GNU Emacs.           -*-Emacs-Lisp-*-
;; Copyright (C) 1993-95 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
(defconst glog "$Header: glog.elv  5.74  95/09/02 00:43:20  Nam  Exp $")

;; What is this?:
;;
;;   `GLOG' is a very simple BBS log file browser, under GNU Emacs.
;; It's looks like `GNUS', because I love it and want to use for browsing
;; BBS's log.  So, I try to make this.
;; 

;; How to install:
;;
;; (1) First, remove GLOG related old `*.elc' files (May be `glog*.elc')
;; (2) Copy `glog*.el' to emacs-lisp directory.
;; (3) Byte-compile a file `glog*.el'.
;; (4) Define autoload entries in `.emacs' file as follows:
;;     (autoload 'glog                  "glog" "View BBS log mode." t)
;;     (autoload 'glog-view-file-mode   "glog" "view file as BBS log." t)
;;     (autoload 'glog-view-buffer-mode "glog" "view buffer as BBS log." t)

;; How to use:
;;
;; (1) Type `M-x glog'
;; (2) Select a log file which you want to read it.
;; (3) You can read it, as like use `GNUS'

;; For easy operation:
;;
;; (1) Append your startup file (may be `.emacs'), this line.
;;     (global-set-key "\M-L" 'glog)
;;     (global-set-key "\M-R" 'glog-resume)
;; (2) Type `\M-L' to viewing log file.
;;     ...
;; (3) If BOSS has come, type `!' (Delete all windows about GLOG.)
;; (4) BOSS gone, type `\M-R' (Resume windows.)


;; TO DO:
;;
;; (1) Make incomplete functions, and refine stupidity codes.
;; (2) Make `glog_xxx.el' to read other BBS's log.
;; (3) Copy this and distribution as many as possible.

;; WARNING:
;;
;; (1) Everyone is granted permission to copy, modify and redistribute,
;;     but WITHOUT ANY WARRANTY.
;;     (It under the terms of the GNU General Public License as published
;;      by the Free Software Foundation.)
;; (2) If you have any trouble with this software, please mail to me.
;;     I will try to fix your problems in the next release. (may be ^^;)



;; CAUTION:
;;
;;   This file (and other `glog*.el') wrote under `Shift-JIS' code.
;; Japanese string follows...

(defvar glog-config-file (if (eq system-type 'ms-dos) "~/_glogrc" "~/.glogrc")
  "*GLOGNɑ݂Γǂݍސݒt@C.
(Aemacs-lisp`łKvL.)")

(defvar glog-last-file  (if (eq system-type 'ms-dos) "~/_bbsrc" "~/.bbsrc")
  "*GLOGIɃZ[u関Ǐt@C
Ή")

(defvar glog-signature-file
  (if (eq system-type 'ms-dos) "~/_signatr" "~/.signature")
  "*Postt@C̖ɕt鏐̃t@C.
̒lnil͎w肳ꂽt@Cǂݍ߂Ȃꍇ͕tȂ.")

(defvar glog-log-directory nil
  "*LOGt@Cvisitۂ̃JgfBNg.  ex. \"~/log/\"")

(defvar glog-post-directory nil
  "*Postt@CZ[uۂ̃JgfBNg.  ex.\"~/post/\"")

(defvar glog-save-directory nil
  "*ArticleZ[uۂ̃JgfBNg  ex.\"~/news/\"")


(defvar glog-quote-string "!"
  "*non-nil̏ꍇ,`f'̍ۂɓǂݍ܂錳L̊esɈpƂĕt.
L͂̕ꂼΉ錳L̓eɒu.

  `#MESNO#'->ԍ, `#COMNO#' ->Rgԍ, `#TITLE#'->^Cg
  `#ID#'   ->id, `#AUTHOR#'->Җ
  `#MESID#'->`MessageId:'tB[h
  `#IDATE#'->`Date:'tB[h


  Ȃ݂`my-glog-quote-header'ƌ֐_glogrcœo^
super-citeCNȃwb_鎖ł. (ȉQ)

  ̏ꍇ`glog-current-subject[݂̃{[h]'̑ɁAȉlocalϐ
XR[vƂČ̂ŎQƉ\.
(mesno[ԍ],title,id,author[nh],com-no[Rg],date,
 mesid[bZ[WID],replyto[Reply-To:tB[h],idate[Date:tB[h],
 kind[:'board/'mail/'inews/'imail])

--
  ex. SUPER-CITE

In article <777:sscience.vZSƎZ@>  قق wrote:

  (defun my-glog-quote-header ()
    (if (eq kind 'board)
        (if (and mesno glog-current-subject)
            (insert (format \"In article <%d:%s>  \"
                            mesno glog-current-subject)))
      (if mesid (insert (format \"In article %s \" mesid))))
    (insert (format \"%s wrote:\\n\\n\"
                    (if (> (length author) 0) author id))))")

(defvar glog-ruler-string
  (let ((tmp (concat
	      "[POST]...1....:....2....:....3....:....4"
	      "....:....5....:....6....:....7....:....8"
	      "....:....9....:...10....:...11....:...12"
	      "....:...13....:...14....:...15....:...16"
	      "....:...17....:...18....:...19....:...20")))
    (concat (substring tmp 0 (- fill-column 1)) "@"
	    (substring tmp fill-column)))
  "*`C-c=' Postobt@̃[hCɕ\K̕.
(default ł fill-column ̈ʒu`@'\Ă.)")


(defvar glog-use-full-window t
  "*NconsolesplitĂĂSconsolegp(t)/Ȃ(nil)")

(defvar glog-quiet-mode nil
  "*ɗ͕\ƂȂ(t)/Ȃ(nil)")

(defvar glog-hide-headers nil
  "*L\Ƀwb_\Ȃ(t)/(nil)")

(defvar glog-auto-select-first t
  "*{[hIɋL\(t)/Ȃ(nil)")

(defvar glog-auto-select-next t
  "*{[hǗ[SPC]([n])Ŏ̃{[h\(t)/Ȃ(nil)")

(defvar glog-auto-center-subject t
  "*subjectIɎZ^O(t)/Ȃ(nil)")

(defvar glog-subject-indent-level 4
  "*subject list̃Cfg")

(defvar glog-interactive-post-name nil
  "*postۂ̃t@Cŏɓ͂(t)/Z[uɓ͂(nil)")

(defvar glog-sort-subject nil
  "*group-listsubject\[g(t)/Ȃ(nil)")

(defvar glog-sort-article 'glog-lessp-subject-by-date
  "*subjectarticletŃ\[g/Ȃ(nil)
ȉ̃\[gi.
'glog-lessp-subject-by-no     :ԍ̑召݂̂Ń\[g
'glog-lessp-subject-by-id     :idŃ\[g
'glog-lessp-subject-by-author :Җ(nh)Ń\[g
'glog-lessp-subject-by-subject:^CgŃ\[g
'glog-lessp-subject-by-date   :œ̔r(default)
'glog-lessp-subject-by-lines  :sŃ\[g")

(defvar glog-emphasize-match-hook
  (if (string< "19" emacs-version)
      ;; Mule-2.x
      '(lambda ()
	 (put-text-property (match-beginning 0) (match-end 0)
			    'face 'highlight ))
    ;; Mule-1.x
    '(lambda () (attribute-on-region 'inverse
				     (match-beginning 0) (match-end 0) )))
  "̋ݒ肷֐. `string-match'Ŏw肵[Wɑ΂
s悤ɋLq邱.
*Muleł̂ݗL*
*MuleVersionɈˑ̂Œ*")

(defvar glog-handle-list nil
  "*subject-bufferŎQƂhandle-list. LOG擾nhD.
ȉɎl, BBSPʂlistappend. (`C-ch'Ŏo^)

   (list 'BBS
         '(\"ID\" . \"nh\")
                 V
       )")

(defvar glog-purge-id-list nil
  "*subject-bufferŎQƂ\id-list.
ȉɎl, BBSPʂlistappend. (`C-cC-h'Ŏo^)

   (list 'BBS
         '(\"ID\" . \"nh\")
                 V
       )")

(defvar glog-purge-subject-list nil
  "*group-bufferŎQƂ\{[hlist.
Ƃ肠͓ǂ܂Ȃ{[ho^ƕ֗m܂.
ȉɎl, BBSPʂlistappend. (`u'Ŏo^)

   (list 'BBS
         '(\"{[h\" . \"Rg\")
                 V
       )")

(defvar glog-savearticle-list nil
  "*group-bufferŎQƂZ[ulist.
{[hɃt@Cw肵ĂƁA`o'ŋLZ[u鎞̃ftHg
t@CƂĎQƂ. (ML؂蕪ׂɍ쐬. '95.5.9)
ȉɎl, BBSPʂlistappend. (`C-co'Ŏo^)

   (list 'BBS
         '(\"{[h\" . \"t@C\")
                 V
       )")

(defvar glog-ML-list nil
  "*`glog-Group-make-group'ŎQƂid-list. mail̓œo^ꂽid
newsgroupƂĕ\ׂɎgp. (ML؂蕪ׂɍ쐬. '95.5.9)
ȉɎl, BBSPʂlistappend. (`C-cm'Ŏo^)

   (list 'BBS
         '(\"ID\" . \"^Cg\")
                 V
       )")

(defvar glog-bbs-search-limit 8000
  "*BBSʂ𔻒肷ۂ̌limit()")


(defvar glog-window-configuration
  '((SelectNewsgroup       (0  1  0  0))
    (ExitNewsgroup         (1  0  0  0))
    (SelectArticle         (0  3 10  0))
    (PostNews              (0  0  3  5))
    (PostNewsWithReference (0  1  3  5))
    (PostNewsNoReference   (0  0  0  1))
    (ExpandSubject         (0  1  0  0)))
  "*eEBhDTCY̐ݒ. GNUSɏ,(ACTION (G S A P))̃Xg.
G,S,A,P͂ꂼGroup,Subject,Article,PostEBhD̍.")


;;
;;  LOCAL MACROS
;;

(defmacro inc (var)
  "ϐ()̒l+1܂.

  (setq a 1)
  >1
  (inc a)
  >2"
  (list 'setq var (list '1+ var)))

(defmacro glog-set-buffer (buf)
  "w̃obt@set-buffer܂. obt@nilԂ܂.

  (glog-set-buffer \"*scratch*\")
  >#<buffer *scratch*>
  (glog-set-buffer \"foo\")
  >nil"
  (list 'if (list 'get-buffer buf)
      (list 'set-buffer buf)
      'nil))

(defmacro glog-article-info-no (article)
  "^ꂽLXg甭ԍԂ.

  (setq mes-no (glog-article-info-no article))
  >800"
  (list 'car article))

(defmacro glog-article-info-unread (article)
  "^ꂽLXg疢/ǃtOԂ.

  (setq unread (glog-article-info-unread article))
  >\100"
  (list 'elt article '1))

(defmacro glog-article-info-title (article)
  "^ꂽLXg^CgԂ.

  (setq title (glog-article-info-title article))
  >\"m΂Ɍ̉buAbV[v!\""
  (list 'elt article '2))

(defmacro glog-article-info-id (article)
  "^ꂽLXgidԂ.

  (setq id-string (glog-article-info-id article))
  >\"CAF58901\""
  (list 'elt article '3))

(defmacro glog-article-info-author (article)
  "^ꂽLXg璘ҖԂ.

  (setq author (glog-article-info-author article))
  >\"Nam\""
  (list 'elt article '4))

(defmacro glog-article-info-date (article)
  "^ꂽLXgtԂ.

  (setq date (glog-article-info-date article))
  >\"1999/07/07 00:00\""
  (list 'elt article '5))

(defmacro glog-article-info-comno (article)
  "^ꂽLXgRgԍ(int)Ԃ.

  (setq comment-no (glog-article-info-comno article))
  >799"
  (list 'elt article '6))

(defmacro glog-article-info-pos (article)
  "^ꂽLXgLJnʒu(point)Ԃ.

  (setq position (glog-article-info-pos article))
  >32767"
  (list 'elt article '7))

(defmacro glog-article-info-lines (article)
  "^ꂽLXgLs(int)Ԃ.

  (setq lines (glog-article-info-lines article))
  >200"
  (list 'elt article '8))

(defmacro glog-article-info-headlines (article)
  "^ꂽLXgwb_̍s(number)Ԃ.(0Ԃ)

  (setq hl (glog-article-info-headlines article))
  >10"
  (list 'elt article '9))

(defmacro glog-article-info-kind (article)
  "^ꂽLXgLʂԂ.
ʂ 'board/'mail/'inews/'imail ̎l.(nilԂ)

  (setq kind (glog-article-info-kind article))
  >inetnews"
  (list 'elt article '10))

(defmacro glog-article-info-mesid (article)
  "^ꂽLXg甭id(str)Ԃ.
(INETNEWŜ. nilԂ)

  (setq message-id (glog-article-info-mesid article))
  >\"<12345@towns.pcvan.or.jp>\""
  (list 'elt article '11))

(defmacro glog-article-info-replyto (article)
  "^ꂽLXgԐM(str)Ԃ.
(INETNEWŜ. nilԂ)

  (setq reply-to (glog-article-info-replyto article))
  >\"<12345@towns.pcvan.or.jp>\""
  (list 'elt article '12))

(defmacro glog-article-info-idate (article)
  "^ꂽLXg`Date:'tB[h(str)Ԃ.
(INETNEWŜ. nilԂ)

  (setq idate (glog-article-info-idate article))
  >\"Wed, 15 Feb 1995 03:51:52 GMT\""
  (list 'elt article '13))

(defmacro glog-article-set-unread (article flag)
  "^ꂽLXgɖ/ǃtOZbg.

  (glog-article-set-unread article ?d)
  >(800 \\100 \"Title\" \"CAF58901\" \"Nam\" \"10/05 00:00\" 799 32767 200)"
  (list 'setcdr article (list 'cons flag (list 'nthcdr '2 article))))

(defmacro glog-message (str)
  ;; "bZ[W\(`glog-quiet-mode'tȂ\Ȃ).
  (` (or (, glog-quiet-mode) (message (, str)))) )


;;
;;  BBS config
;;

(defvar glog-bbs-list
  (list
   
   ;; PC-VAN
   (list 'pcvan
	 "PC-VAN"
	 (concat "\\(" "^ԍ܂̓R}h[<=(]"
		 "\\|"	;; FORUM MSG
		 "^Cg ([ 0-9A-Z]+)  [ 0-9/]+  [ 0-9:]+  ([ 0-9]+)$"
		 "\\|"	;; MAIL
		 "^#[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]"
		 "         [0-9][0-9]/[01][0-9]/[0-3][0-9]"
		 "    [012][0-9]:[0-5][0-9]:[0-6][0-9]$"
		 "\\|"  ;; VINETNEWS`
		 "^Article [0-9]+ ([0-9]+/[0-9]+) in [^ ]+:$"
		 "\\|"  ;; INETNEWS`
		 "^[0-9a-z\\.]+j[XO[v \\[LF[ 0-9]+\\]$"
		 "\\)")
	 (function view-pcvan-mode)
	 "glog_pc"
	 (function glog-pcvan-version))

   ;; Nifty-Serve
   (list 'nifty
	 "Nifty-Serve"
	 (concat "\\(" "^悤NIFTY-Serve$" "\\|" "^CCS([PN])>"
	 	 "\\|" "^ԍ܂̓R}h (sŃgbvj[)$"
;;		 "\\|" "^.+ +[A-Z][0-9A-Z]+$" ;; CUG͐擪FƂ͌Ȃ
		 "\\|"	;; FORUM MSG
		 "^[0-9]+/[0-9]+ +[A-Z*][A-Z*][A-Z*]"
		 "[0-9*][0-9*][0-9*][0-9*][0-9*]  "
		 "\\|"	;; HP MSG
		 "^[0-9][0-9][0-9]  \\[[0-9][0-9]/"
		 "[01][0-9]/[0-3][0-9] [012][0-9]:[0-5][0-9]\\]  "
		 "[A-Z*][A-Z*][A-Z*][0-9*][0-9*][0-9*][0-9*][0-9*]  "
		 "\\|"	;; MAIL
		 "^[ 0-9][0-9] [ #].*"
		 "[A-Z][A-Z][A-Z][0-9][0-9][0-9][0-9][0-9]  "
		 "[ 0-9/]*[01][0-9]/[0-3][0-9] [012][0-9]:[0-5][0-9]$"
		 "\\)")
	 (function view-nifty-mode)
	 "glog_nif"
	 (function glog-nifty-version))

   ;; Sunday-Net
   (list 'sunday
	 "Sunday-Net"
	 (concat "\\(" "^@.+CTf[lbgւ悤I$"
		 "\\|" "^BBS-[^ ]+ "
		 "\\|" "^[ 0-9][ 0-9][ 0-9][0-9] "
		 "[a-z][a-z][a-z][0-9][0-9][0-9][0-9] .+"
		 " [0-9][0-9]/[0-9][0-9]/[0-9][0-9] "
		 "[0-9][0-9]:[0-9][0-9] .+ [0-9]+$"
		 "\\|" "^< f̃Xg >$"
		 "\\|" "^ [ *][ 0-9]+ [a-z][a-z][a-z][0-9][0-9][0-9][0-9] .+"
		 " [0-9][0-9]/[01][0-9]/[0123][0-9] "
		 "[012][0-9]:[01-5][0-9]:[0-6][0-9] .+$"
		 "\\)")
	 (function view-sunday-mode)
	 "glog_sun"
	 (function glog-sunday-version))

   ;; oMix
   (list 'mix
	 "Nikkei-Mix"
	 (concat "\\(" "^c^ȉ         VbZ[W$"
		 "\\|"	;; FORUM OPM
		 "^'[0-9a-z.]+'\\( cA\\|/\\)'[0-9a-z.]+' "
		 "\\(\\|ȉ\\)Q܂B"
		 "^̕ȉɎQ\\(܂\\|Ă܂\\)B$"
		 "\\|"	;; FORUM MSG
		 "^[0-9a-z.]+/[0-9a-z.]+ [0-9]+, "
		 "[0-9A-Za-z.]+ , [0-9]+ , "
		 "[SMTWF][a-z][a-z] [A-Z][a-z][a-z] [ 0-3][0-9] "
		 "[012][0-9]:[0-5][0-9]:[0-6][0-9] [12][0-9][0-9][0-9]$"
		 "\\|"	;; MAIL
		 "^ [ 0-9][ 0-9][ 0-9][ 0-9][ 0-9]$"
		 "\\)")
	 (function view-mix-mode)
	 "glog_mix"
	 (function glog-mix-version))

   ;; ASCII-Net
   (list 'ascii
	 "ASCII-Net"
	 (concat "\\(" "^L I V E   N E T W O R K !$"
		 "\\|" "^MENU>> "   "\\|" "^READMAIL>> "
		 "\\|" "^EDITOR>> " "\\|" "^INDEX>> "
		 "\\|" "^ Note [0-9]+ .+ \([0-9a-z]+\.[0-9a-z\.]+\)$"
		 "\\|" "^From [a-z][a-z][a-z][0-9][0-9][0-9][0-9][0-9] "
		 "[F-W][a-u][e-t] [A-O][a-u][b-y] [ 0-9][0-9] "
		 "[ 0-2][0-9]:[ 0-5][0-9]:[ 0-6][0-9] "
		 "[1-2][0-9][0-9][0-9]$"
		 "\\)")
	 (function view-ascii-mode)
	 "glog_asc"
	 (function glog-ascii-version))

   ;; FAQ style document (SGML formed)
   (list 'sgmlfaq
	 "SGMLFAQ"
	 "\\(!DOCTYPE\\|\<FAQ\>\\)"
	 (function view-sgmlfaq-mode)
	 "glog_sfq"
	 (function glog-sgmlfaq-version))

   ;; FAQ style document
   (list 'faq
	 "FAQ style"
	 "FAQ"
	 (function view-faq-mode)
	 "glog_faq"
	 (function glog-faq-version))

   ;; BBS
   (list 'tokyobbs
	 "BBS"
	 "^No.==  Date==== Time== = Id======  Title=====m.+n$"
	 (function view-tbs-mode)
	 "glog_tbs"
	 (function glog-tbs-version))

   ;; GLOG Wo͌`
   (list 'glogout
	 "GLOG out format"
	 "^- [^ \.]+: [^ \.]+\..+ -$"
	 (function view-glogout-mode)
	 "glog_glo"
	 (function glog-glogout-version))

   ;; Add BBS-type here, as you need.
   )
  "*ΉBBSʂo^ꂽlist.
ȉ̗v̂őΉBBSŒǉ鎖ł܂.

;;  `.glogrc'ɒǉĂ
(or (assq 'hogehoge glog-bbs-list)              ;; (d`邨܂Ȃ)
    (nconc glog-bbs-list
	   (list
	    (list 'hogehoge                     ;; BBS(Symbol)
		  \"HOGEHOGE-Net\"              ;; BBS(String)
		  \"^Welecome to HogeNet!!!$\"  ;; ʗpK\
		  (function view-hogehoge-mode) ;; [hݒ֐
		  \"glog_hog\"                  ;; Cut@C
		  (function glog-hoge-version)) ;; Version擾֐
	    )))")

;;
;; BBS configration

(defun glog-search-now-buf ()
  ;; "Jgobt@̂aar^Cv𔻒f"
  (let ((bbs)(mmin glog-bbs-search-limit)(mptr)(mstr)(count 0)
        (kanji-flag)(mc-flag))
    (save-excursion
      ;; BBSʂ
      (setq glog-bbs-type nil)
      ;; searching (`glog-bbs-list'ɓo^ꂽJԂ)
      (while (setq bbs (nth count glog-bbs-list))
	;; 擾
	(setq mstr (nth 2 bbs))
	(goto-char (point-min))
	(if (re-search-forward mstr glog-bbs-search-limit t)
	    (progn
	      (setq mptr (match-beginning 0))
	      ;; ɐ	  
	      (if (< mptr mmin)
		  ;; ʒuOOȂBBSXV
		  (progn
		    (setq mmin mptr)
		    (setq glog-bbs-type (car bbs))))))
	(inc count))
      ;; set BBS function
      (if glog-bbs-type
	  (setq glog-bbs-type (glog-set-bbs-function glog-bbs-type))))
    ;; return with BBS type
    glog-bbs-type))


;;
;;  Constants
;;

(defconst glog-startup-message
  (list (concat "GLOG Version "
		(progn
		  (if (string-match "[0-9][0-9\.]+" glog)
		      (concat "0."
			      (substring glog
					 (match-beginning 0)(match-end 0)))
		    "(Unknown)")))
	""
	"Very simple BBS log browser for GNU Emacs.  (Look like `GNUS')"
	""
	""
	"If you have any trouble with this software, please mail to me."
	"I will try to fix your problems in the next release. (may be ^^;)"
	""
	"Comments, suggestions, and bug fixes are welcome."
	""
	"Nam : CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp"))

(defvar glog-Info-nodes
  '((glog-Group-mode   . "(glog)Newsgroup Commands")
    (glog-Subject-mode . "(glog)Subject Commands")
    (glog-Article-mode . "(glog)Article Commands")
    (glog-Post-mode    . "(glog)Post Commands"))
  "*Info nodeɑΉmajor mode̘AzLlist.")

(defvar glog-Group-buffer   "*GLOG Group*"
  "*GLOGŋLIobt@")
(defvar glog-Subject-buffer "*GLOG Subject*"
  "*GLOGŃ^Cg\&Iobt@")
(defvar glog-Article-buffer " *GLOG Article*"
  "*GLOGŋL\obt@")
(defvar glog-Post-buffer    "-post-"
  "*GLOGŋL\obt@")
(defvar glog-read-buffer    " *viewing*"
  "*GLOGŌLOGǂݍރobt@")
(defvar glog-rc-buffer      " *.glogrc*"
  "*GLOG.glogrcǂݍރobt@")

(defvar glog-mark-char (list '( readed . "D" )  ;; Ǘ
			     '( mark   . "M" )  ;; }[N
			     '( unread . "U" )  ;; ǈ
			     '( cansel . "C" )) ;; LZ
  "*GLOG:subjectsł̓Ǘ̑̃}[N")

(defconst glog-regexp-group-line "[0-9]+\:"
  "*GLOG:groupsňړۂɎgpreg-exp")

(defconst glog-regexp-subject-line "^..[ \t]+[0-9]+\:"
  "*GLOG:subjectsňړۂɎgpreg-exp")


(defvar glog-init-flag nil
  "*GLOGɏĂ邩ۂ̃tO")

(defvar glog-bbs-type nil
  "*GLOGŌݎQƂĂBBS̎")

(defvar glog-subject-list nil
  "*GLOGNɍ쐬subjectlist")

(defvar glog-refer-buffer nil
  "*GLOGŌݎQƂĂbuffer")

(defvar glog-current-subject nil
  "*GLOGŌݎQƂĂsubject")

(defvar glog-current-article -1
  "*GLOGŌݎQƂĂarticleԍ")

(defvar glog-readed-list nil
  "*ǋLmessage-idlist. CrossPostcheckɎgp(INETNEWŜ)")

(defvar glog-current-search-regexp nil
  "*ݎQƂĂSubjectł̌(K\). \Ɏgp.")

(defvar glog-post-file-name nil
  "*Post鎞̃Z[u")

(defvar glog-post-data (list (cons 'mesno -1))
  "*Postobt@J̏Ԃۑlist. [buffer-local]
ΉsymbolŕKvȃf[^. ȉsymbol.

'subject  : subject
'mesno    : ԍ
'title    : ^Cg()
'id       : id
'author   : Җ()
'com-no   : ̃Rgԍ
'date     : ̔()
'newfile  : VKobt@ۂ(nilȂfileǂݍł)
'openmode : J̃[h('post:|'mail:[)
'signature: signaturepasteۂ̃tO(tȂpaste)")

(defvar glog-save-file-name nil
  "*Articleۑ鎞̃Z[u")

(defvar glog-resume-window-list nil
  "*window-configurationZ[uϐ(consZ). 
(Nconf . GLOG[hconf)")

;;
;;  misc
;;

(defun glog-undefined-key-actions ()
  ;; ݒ肳ĂȂkeyꂽꍇ̏(defaultbell)
  (interactive)
  (ding))

(defun glog-undefined-function ()
  ;; ̊֐`͂w悤ɂĂ܂. (֋X܂)
  t)

(defun glog-version ()
  "Show version number of GLOG related files."
  (interactive)
  (let ((cbuf (current-buffer))(frm "  %s:\t %s\n")
	(count 0)(bbs)(lib)(fn)(ver))
    (pop-to-buffer "*GLOG version*")
    (erase-buffer)
    (insert "GLOG: show all related file's version.\n")
    (insert (format frm "glog.el" glog))
    (condition-case ()
	(load-library "glog_utl")
      (error (setq glog_utl "Load error!")))
    (insert (format frm "glog_utl.el" glog_utl))
    (while (setq bbs (nth count glog-bbs-list))
      ;; Check BBS definition
      (if (or (not (setq lib (nth 4 bbs)))
	      (not (setq fn (nth 5 bbs))))
	  ;; BBS`擾łȂ͍ڕs̏ꍇ͂̎|\
	  (setq ver "Irregular BBS definition.")
	;; BBS`t@Cǂݍ
	(setq ver nil)
	(condition-case ()
	    (load-library lib)
	  (error (setq ver "Load error!")))
	(if (not ver)
	    (condition-case ()
		(setq ver (funcall fn))
	      (error (setq ver "Can't read version.")))))
      (insert (format frm (concat lib ".el") ver))
      (inc count))
    (message "Type C-x 1 to remove help window.")
    (sit-for 0)
    (switch-to-buffer-other-window cbuf)))

(defun glog-error (&optional str)
  ;; G[bZ[W\. 擪`GLOG: 't.
  (if (not str)
      (message "GLOG: Error!")
    (message (concat "GLOG: " str)))
  (ding)
  (sit-for 5))

(defun glog-erase-buffer (buf)
  ;; w̃obt@erase, mode-line.
  (if (glog-set-buffer buf)
      (progn (setq buffer-read-only nil)
	     (erase-buffer)
	     (setq mode-line-buffer-identification "GLOG:")
	     (set-buffer-modified-p nil)
	     t)))

(defun glog-force-list (flags &optional dummy)
  ;; ^ꂽZIlist`ɂ.(dummyݒ肳ĂΎgp)
  ;; ex.
  ;;     (glog-force-list nil)
  ;;     >(none none)                    <- nil̏ꍇ͓ʂ'nonelistԂ
  ;;     (glog-force-list 'a)
  ;;     >(a dummy)                      <- 'dummy listɂĕԂ
  ;;     (glog-force-list (list 'a 'b))
  ;;     >(a b)                          <- list̏ꍇ͉ςɕԂ
  ;;     (glog-force-list 'a 'foo)
  ;;     >(a foo)                        <- wsymbollistɂĕԂ
  (cond
   ((not flags)
    '('none . 'none))
   ((not (listp flags))
    (if dummy (list flags dummy) (list flags 'dummy)))
   (t flags)))

(defun glog-assoc-list (&optional sym ulist dummy)
  ;; ^ꂽlistsymbolɑΉconsZAzzŃT[`.
  ;; listȊO^ꂽꍇnilԂ(dummyݒ肳ĂdummyԂ.)
  ;;
  ;; ex.
  ;;     (setq foo t)
  ;;     >t
  ;;     (glog-assoc-list 'mesno foo)
  ;;     >nil
  ;;     (setq foo (list (cons 'mesno 777)(cons 'com-no 7)))
  ;;     >((mesno . 777)(com-no . 7))
  ;;     (glog-assoc-list 'mesno foo)
  ;;     >777
  ;;     (glog-assoc-list 'artno foo)
  ;;     >nil
  (let ((foo)(result))
    (setq result (or dummy))
    (if (and ulist (listp ulist) sym)
	(if (setq foo (assoc sym ulist))
	    (setq result (cdr foo))))
    result))

(defun glog-set-list (&optional sym ulist)
  ;; ^ꂽlistconsZcdrɑΉZw肳ꂽlɒuĕԂ.
  ;; ΉsymbolΐVconsZ쐬Ēǉ.
  ;; listȊO^ꂽꍇ͌̒lԂ.
  ;;
  ;; ex.
  ;;     (setq foo t)
  ;;     >t
  ;;     (glog-set-list (cons 'mesno 777) foo)
  ;;     >t
  ;;     (setq foo (list (cons 'mesno 777)(cons 'com-no 7)))
  ;;     >((mesno . 777) (com-no . 7))
  ;;     (setq foo (glog-set-list (cons 'mesno 666) foo))
  ;;     >((com-no . 7) (mesno . 666))
  ;;     (setq foo (glog-set-list (cons 'artno 555) foo))
  ;;     >((com-no . 7) (mesno . 666) (artno . 555))
  (let (key)
    (if (and sym ulist (listp ulist))
	(progn
	  (setq key (if (consp sym) (car sym) sym))
	  (if (setq key (assoc key ulist))
	      (setq ulist (delq key ulist)))
	  (if (consp sym) (nconc ulist (list sym)))))
    ulist))

(defun glog-get-current-line ()
  ;; Jgobt@̃Jgs̕擾.
  (save-excursion
    (let ((start (progn (beginning-of-line)(point)))
	  (end   (progn (end-of-line)      (point))))
      (buffer-substring start end))))

(defun glog-foward-empty-line ()
  ;; Jgobt@̋s΂.
  (let ((limit (glog-get-forward-line-position 100)) (kanji-flag)(mc-flag))
    (re-search-forward "^.+$" limit 1)
    (beginning-of-line)))

(defun glog-delete-current-line (&optional lines)
  ;; Jgobt@̃Jgs폜.
  (save-excursion
    (let ((s)(e))
      (beginning-of-line)
      (setq s (point))
      (if lines (forward-line lines) (forward-line))
      (setq e (point))
      (delete-region s e))))

(defun glog-delete-line-end-space (str)
  ;; I[(p|Sp)󔒂菜.
  (if str
      (let ((mdata (match-data)))	;; }b`f[^̕ی
	(if (string-match "[ @\t]+$" str)
	    (setq str (substring str 0 (match-beginning 0))))
	;; }b`f[^̕
	(if mdata (store-match-data mdata))))
  str)

(defun glog-delete-long-space (str)
  ;; 񂩂3ȏ㑱(p|Sp)󔒋yшȍ~̕菜.
  (if str
      (let ((mdata (match-data)))	; }b`f[^̕ی
	(if (string-match "\\(   +\\|@@+\\|\t+\\)" str)
	    (setq str (substring str 0 (match-beginning 0))))
	;; }b`f[^̕
	(if mdata (store-match-data mdata))))
  str)

(defun glog-replace-long-space (str)
  ;; 񂩂2ȏ㑱(p|Sp)󔒂2̔p󔒂ɒu.
  (if str
      ;; }b`f[^̕ی
      (let ((mdata (match-data))(ms)(me)(foo)(bar))
	(while (string-match "\\(  +\\|[\t@]+\\)" str)
	  (setq ms (match-beginning 0))
	  (setq me (match-end 0))
	  (cond
	   ((< ms 1)                ; 擪ɋ󔒂ꍇ
	    (setq str (substring str me)))
	   ((< me (length str))     ; ^񒆂ɋ󔒂ꍇ
	    (progn
	      (setq foo (substring str 0 ms))
	      (setq bar (substring str me))
	      (setq str (concat foo " " bar))))
	   (t                       ; s[ɋ󔒂ꍇ
	    (setq str (substring str 0 ms)))))
	;; }b`f[^̕
	(if mdata (store-match-data mdata))))
  str)

(defun glog-delete-rerere (&optional str)
  ;; ^CǵuRe:Re:Re:v΍. 'Re...:'폜lԂ.
  (let ((mdata (match-data))(res str) (kanji-flag)(mc-flag))
    (if (string-match
	 "^\\([Rrq][Eed][\\^\\*#0-9Ssr]*[:>F ][ ]*\\)+" str)
	(setq res (substring str (match-end 0))))
    (if mdata (store-match-data mdata))
    res))

(defun glog-string-to-int (str)
  ;; (p|Sp)intɕϊ. ŖnilԂ.
  (let ((mdata (match-data))  ; }b`f[^̕ی
	(foo)(bar 0)(c)(rstr "")(result nil))
    (if str
	;; str^Ă
	(progn
	  (while (setq foo (string-match "[0-9O-X\-|]" str bar))
	    (setq bar (match-end 0))
	    (setq c (cdr (assoc
			  (substring str foo bar)
			  '(("1" . "1")("2" . "2")("3" . "3")("4" . "4")
			    ("5" . "5")("6" . "6")("7" . "7")("8" . "8")
			    ("9" . "9")("0" . "0")
			    ("P" . "1")("Q" . "2")("R" . "3")("S" . "4")
			    ("T" . "5")("U" . "6")("V" . "7")("W" . "8")
			    ("X" . "9")("O" . "0")("-" . "-")("|" . "-")))))
	    (setq rstr (concat rstr c)))
	  (setq result (string-to-int rstr))))
    ;; }b`f[^̕
    (if mdata (store-match-data mdata))
    result))

(defun glog-month-to-int (str)
  ;; 񂩂琔ɕϊ(Ă͂܂Ȃꍇ0)
  (let (mm)
    (if (setq mm (assoc str
			'(("Jan" . 1)("Feb" .  2)("Mar" .  3)("Apr" .  4)
			  ("May" . 5)("Jun" .  6)("Jul" .  7)("Aug" .  8)
			  ("Sep" . 9)("Oct" . 10)("Nov" . 11)("Dec" . 12))))
	(cdr mm)
      0)))

(defun glog-mime-decode-str (&optional str)
  ;; ^ꂽMIMEGR[hĂ邩, MIMEȂfR[h
  ;; l,łȂȂ猳̕Ԃ.
  ;; Ȃ݂Ƃ`mime-kit.el'Kv.
  (let ((mdata (match-data))(res)(foo)(st)(ed))
    (if (not (string-match "=\\?.+\\?=" str))
	(setq res str)
      (setq st (match-beginning 0))
      (setq ed (match-end 0))
      (setq res (substring str st ed))
      ;; fR[h֐Ăяo
      (condition-case ()
	  (setq foo (mime/decode-string res))
	;; `Ȃ̂mime-kit.elǂݍ
	(error
	 (condition-case ()
	     (progn
	       (load-library "mime-kit")
	       (setq foo (mime/decode-string res)))
	   (error (setq foo nil)))))
      (if foo
	  (setq res (concat (substring str 0 st) foo (substring str ed)))
	(setq res str)))
    (if mdata (store-match-data mdata))
    res))

(defun glog-get-inethead-info ()
  ;; JgsInterNet`wb_e𓾂. 
  ;; ĂяõXR[vňȉ̕ϐ.
  ;; ngroup,subject,mesid,addr,name,replyto,idate,gdate,lines,hlines
  ;;
  ;; el̓e͈ȉ̒ʂ.(Ȃ͌̒lȂ)
  ;;   ngroup  ` Newsgroups:
  ;;   subject ` X-Nsubject:  ( Subject:)
  ;;   mesid   ` Message-Id:
  ;;   addr    ` Authorizing: ( From:) ̃AhX(<name@test.co.jp>)
  ;;   name    ` Authorizing: ( From:) ̔AhX
  ;;   repluto ` Resent-From: ( Reply-To:) ̃AhX
  ;;   idate   ` Date:
  ;;   gdate   ` Date: glog`ɕϊ
  ;;   lines   ` Lines:
  ;;   hlines  ` wb_̍s
  ;;
  ;; Masanobu UMEDA`timezone.el'`gdate'͐ϊ܂.
  (let ((limit)(pos (point))(foo)(bar)(yy)(dd)(mm)(tm))
    ;; ܂wb_I[߂
    (setq limit (glog-get-forward-line-position 100))
    (if (re-search-forward "^$" limit 1)
	(setq hlines (+ (count-lines pos (setq limit (point))) 1)))
    ;; "Newsgroups:"
    (goto-char pos)
    (if (re-search-forward "^Newsgroups:[ \t]" limit 1)
	(progn
	  (setq foo (glog-get-current-line))
	  (if (string-match "^Newsgroups:[ \t]+" foo)
	      (setq ngroup (substring foo (match-end 0))))))
    ;; "Subject:"
    (goto-char pos)
    (if (re-search-forward "^X-Nsubject:[ \t]" limit 1)
	(progn
	  (setq foo (glog-get-current-line))
	  (if (string-match "^X-Nsubject:[ \t]+" foo)
	      (setq subject
		    (glog-mime-decode-str (substring foo (match-end 0))))))
      ;; "X-Nsubject:""Subject:"擾
      (goto-char pos)
      (if (re-search-forward "^Subject:[ \t]" limit 1)
	  (progn
	    (setq foo (glog-get-current-line))
	    (if (string-match "^Subject:[ \t]+" foo)
		(setq subject
		      (glog-mime-decode-str (substring foo (match-end 0))))))))
    ;; "Message-ID:"
    (goto-char pos)
    (if (re-search-forward "^Message-ID:[ \t]" limit 1)
	(progn
	  (setq foo (glog-get-current-line))
	  (if (string-match "^Message-ID:[ \t]+" foo)
	      (setq mesid (substring foo (match-end 0))))))
    ;; "Authorizing:"
    (setq foo nil)
    (goto-char pos)
    (if (re-search-forward "^Authorizing:[ \t]" limit 1)
	(progn
	  (setq foo (glog-mime-decode-str (glog-get-current-line)))
	  ;; ̍s󔒂Ȃ玟s擾
	  (forward-line)
	  (setq bar (glog-get-current-line))
	  (if (string-match "^[ \t]+" bar)
	      (setq foo (concat foo (glog-mime-decode-str bar)))))
      ;; "Authorizing:""From:"擾
      (goto-char pos)
      (if (re-search-forward "^From:[ \t]" limit 1)
	  (progn
	    (setq foo (glog-mime-decode-str (glog-get-current-line)))
	    ;; ̍s󔒂Ȃ玟s擾
	    (forward-line)
	    (setq bar (glog-get-current-line))
	    (if (string-match "^[ \t]+" bar)
		(setq foo (concat foo (glog-mime-decode-str bar)))))))
    ;; 擾ł"<xxx@yyy> name"addrnameɕ
    (if foo
	(progn
	  (if (string-match "^[^ ]+:[ \t]*" foo)
	      (setq foo (substring foo (match-end 0))))
	  (if (string-match "[^ \t<]+@[^ \t>]+" foo)
	      (progn
		(setq dd (match-beginning 0))
		(setq mm (match-end 0))
		(setq addr (substring foo dd mm))
		(setq name
		      (concat (substring foo 0 (if (> dd 0) (- dd 1) 0))
			      (if (< mm (length foo))
				  (substring foo (+ mm 1))
				""))))
	    ;; Nifty̌ÂpostMIMEGR[hꂽ̂ (--#)
	    (setq name foo))))
    ;; name̗[̗]ȋ󔒂菜, '(`)'Ȃ犇ʂO
    (if name
	(progn
	  (if (string-match "^[ @\t(]+" name)
	      (setq name (substring name (match-end 0))))
	  (if (string-match "[ @\t)]+$" name)
	      (setq name (substring name 0 (match-beginning 0))))))
    ;; "Resent-From:""Reply-To:""To:"
    ;;(lisp-jpgĂ̂ŁA"Resent-From:"悤ɂ  '95.5.26)
    (goto-char pos)
    (setq foo nil)
    (if (re-search-forward "^Resent-From:[ \t]" limit 1)
	(setq foo (glog-get-current-line))
      (goto-char pos)
      (if (re-search-forward "^Reply-To:[ \t]" limit 1)
	  (setq foo (glog-get-current-line))
	;; "Resent-From:""Reply-To:""To:"T '95.6.19
	(goto-char pos)
	(if (re-search-forward "^To:[ \t]" limit 1)
	    (setq foo (glog-get-current-line)))))
    (if (and foo
	     (string-match "[^ \t<]+@[^ \t>]+" foo))
	(setq replyto (substring foo (match-beginning 0)(match-end 0))))
    ;; "Date:"
    (goto-char pos)
    (if (re-search-forward "^Date:[ \t]" limit 1)
	(progn
	  (setq foo (glog-get-current-line))
	  (string-match "^Date:[ \t]+" foo)
	  (setq idate (substring foo (match-end 0)))
	  ;; gdate
	  (setq foo nil)
	  ;; fR[h֐Ăяo
	  (condition-case ()
	      (setq foo (timezone-make-date-sortable idate))
	    ;; `Ȃ̂timezone.elǂݍ
	    (error
	     (condition-case ()
		 (progn
		   (load-library "timezone")
		   (setq foo (timezone-make-date-sortable idate)))
	       (error ()))))
	  (if (and foo (not (string= foo "00000000:00:00")))
	      (progn
		;; "95021503:51:52"  "1995/02/15 03:51:52"
		(setq yy (string-to-int (substring foo 0 2)))
		(setq mm (substring foo 2 4))
		(setq dd (substring foo 4 6))
		(setq tm (substring foo 6))
		;; N␳gdate('38'ȑOȂ1900N)
		(setq gdate (format "%4d/%s/%s %s"
				    (+ yy (if (> yy 39) 1900 2000))
				    mm dd tm))))))
    ;; "Lines:"
    (goto-char pos)
    (if (re-search-forward "^Lines:[ \t]*[0-9]+$" limit 1)
	(progn
	  (setq foo (glog-get-current-line))
	  (if (string-match "^Lines:[ \t]+" foo)
	      (setq lines (string-to-int (substring foo (match-end 0)))))))
    ;; hookݒ肳ĂΎs
    (run-hooks 'glog-get-inethead-info-hook)
    ;; Ōpoint߂ďI
    (goto-char pos)))

(defun glog-search-comment-root (title &optional subject flag)
  ;; [Re:xxx]RgwƂăRgԍ𓾂. Ȃ-1Ԃ.
  ;; ԍ΃^CgŋL.
  ;; flag  'nil Ȃ܂ԍ̌Ƀ^Cg, 't Ȃ^Cĝ.
  (let ((mdata (match-data))(result -1)(str)(sub)(art)(tl)(mesno)(count 0)
	(kanji-flag)(mc-flag))
    (if (string-match
	 "\\([qRr][dEe][rSs]*\\|[`Aa]\\)\\([\\^\\*][0-9]+\\|\\)[Ft:#>.@ ]*"
	 title)
	(progn
	  (setq str (substring title (match-end 0)))  ;; "Re:"
	  (if (and (not flag) (string-match "^[0-9O-X]+" str))
	      ;; ܂ŌāAʂRgԍƂĎ擾
	      (setq result (glog-string-to-int
			    (substring str 0 (match-end 0))))
	    ;; Rg^CgƂċL
	    (if (not subject) (setq subject glog-current-subject))
	    (if (not (setq sub (cdr (assoc subject glog-subject-list))))
		()
	      (while (setq art (elt sub count))
		(setq tl (glog-article-info-title art))
		;; "Re:""Re:"tɃ}b`Ȃloop
		(if (and (not (string= str tl)) (not (string= title tl)))
		    (inc count)
		  (setq result (glog-article-info-no art))
		  (setq count (length sub))))))))
    ;; }b`f[^̕
    (if mdata (store-match-data mdata))
    result))

(defun glog-replace-symbol (str &optional from to)
  ;; [str][from][to]ɒu(1x̂)
  (let ((mdata (match-data)) (kanji-flag)(mc-flag))  ; }b`f[^̕ی
    (if (and str from (string-match from str))
	(setq str (concat
		   (substring str 0 (match-beginning 0))
		   (or to "")                        ; to  nil Ȃ "" 
		   (substring str (match-end 0)))))
    ;; }b`f[^̕
    (if mdata (store-match-data mdata))
    str))

(defun glog-mark-char (kind)
  ;; wsymbolɑΉǗ}[N̕Ԃ.
  ;; ex.
  ;;   (glog-mark-char 'readed)
  ;;   >"D"
  (let ((org (list '(readed . "D")'(mark . "M")'(unread . "U")'(cansel . "C")))
	(result))
    (if (not (setq result (cdr (assq kind glog-mark-char))))
	(setq result (cdr (assq kind org))))
    result))

(defun glog-set-bbs-function (bbs-type &optional msg)
  ;; BBS`擾Ċ֐o^. o^ꂽBBS(symbol)Ԃ.
  (let ((bbs)(fn)(lib)(result))
    (setq result bbs-type)
    ;; Check BBS definition
    (if (or (not (setq bbs (assoc bbs-type glog-bbs-list)))
	    (not (setq lib (nth 4 bbs))))
	;; BBS`擾łȂ͍ڕs̏ꍇ͂̎|\
	(progn
	  (message "Irregular BBS definition at `%s'." bbs-type)
	  (ding)
	  (sit-for 5)
	  (setq result nil))
      ;; show BBS-name
      (if msg
	  (glog-message msg)
	(glog-message (concat "May be " (nth 1 bbs))))
      ;; BBS`ɓǂݍ܂Ă邩ۂcheck
      (setq fn (nth 3 bbs))
      (condition-case ()
	  ;; calling function (set mode-string and mode-function)
	  (funcall fn)
	;; `Ȃ̂BBS`t@Cǂݍ
	(error
	 (condition-case ()
	     (progn
	       (load-library lib)
	       (funcall fn))
	   (error (progn
		    (message "Can't load `%s' library." lib)
		    (ding)
		    (sit-for 5)
		    (setq result nil)))))))
    result))

(defun glog-toggle-threads ()
  "Rgc[\On/Off؂芷. ftHg̓c[\L.
\Ȃ悤ݒ肵Ȃ .glogrcɂ (setq glog-disable-threads t)"
  (interactive)
  (if (and (boundp 'glog-disable-threads) glog-disable-threads)
      (progn
	(glog-message "threads [enable]")
	(setq glog-disable-threads nil))
    (glog-message "threads [disable]")
    (setq glog-disable-threads t)))

(defun glog-search-article-data (&optional no)
  ;; article̊ef[^𓾂.
  ;; ̊֐ĂяoɈȉ̕ϐ[J錾Ă.
  ;;    mesno,title,id,author,com-no,date,mesid
  ;;
  ;; '95.3.29Ɏdlg, Ɉȉ̕ϐǉ.
  ;;    kind,replyto,idate
  (let ((cbuf (current-buffer))(sub)(art)(handlelist)(foo))
    (setq mesno (or no glog-current-article))  ; No.w肪current
    (if (and mesno glog-current-subject)
	(progn
	  ;; ݕ\articleԍ擾ł
	  ;; subjectŘAzzAΉsubject-list(=yAcdr)擾
	  (setq sub (cdr (assoc glog-current-subject glog-subject-list)))
	  (if (and sub (set-buffer glog-Subject-buffer))
	      (progn
		;; ԍɑΉLAzzŌ
		(if (setq art (assq mesno sub))
		    (progn
		      (setq title  (glog-article-info-title  art))
		      (setq id     (glog-article-info-id     art))
		      (setq author (glog-article-info-author art))
		      (setq date   (glog-article-info-date   art))
		      (setq com-no (glog-article-info-comno  art))
		      (setq kind   (glog-article-info-kind   art))
		      (setq mesid  (glog-article-info-mesid  art))
		      (setq idate  (glog-article-info-idate  art))
		      (setq replyto (glog-article-info-replyto art))))
		(set-buffer cbuf)))
	  ;; nhXgo^Ă
	  (setq handlelist
		(glog-assoc-list glog-bbs-type glog-handle-list
				 (list (list nil -1))))
	  (if (setq foo (assoc id handlelist))  ;; nhXg猟
	      (setq author (cdr foo)))
	  ;; ҖID𖼑OƂĕ\
	  (if (< (length author) 1)
	      (setq author id))))))

(defun glog-title-search-regexp (regexp &optional mesno subject)
  ;; L̃^Cgœ蕶̗L.
  ;; ^Cgs, ȂnilԂ.
  ;; 
  ;; ex.
  ;;     (glog-title-search-regexp "ISH")
  ;;     >"Elisp>GLOG0.5.11[useISH&LHa]"
  ;;
  ;;     (glog-title-search-regexp "ISH" 777 glog-current-subject)
  ;;     >nil
  (let ((sub)(art)(title nil)(result nil) (kanji-flag)(mc-flag))
    ;; bufferł̋L̈ʒu𒲂ׂ
    (if (not mesno) (setq mesno glog-current-article))
    (if (not subject) (setq subject glog-current-subject))
    (if (setq sub (assoc subject glog-subject-list))
	(if (setq art (assq mesno (cdr sub)))
	    (setq title (glog-article-info-title art))))
    ;; ^Cgœ蕶񂪗L邩
    (if (and title (string-match regexp title))
	(setq result title))
    result))

(defun glog-article-search-regexp (regexp &optional mesno subject)
  ;; L蕶̗L.
  ;; 炻̍s, ȂnilԂ.
  ;;
  ;; ex.
  ;;     (glog-article-search-regexp "^From:[ \t]+")
  ;;     >"From: hogehoge <INET#hoge.@misc.or.jp>"
  ;;
  ;;     (glog-article-search-regexp "^Author:[ \t]+" 7 glog-current-subject)
  ;;     >nil
  (let ((cbuf (current-buffer))(sub)(art)(pe)(result nil)
	(kanji-flag t)(mc-flag t)) ;; 邩
    ;; bufferł̋L̈ʒu𒲂ׂ
    (if (not mesno) (setq mesno glog-current-article))
    (if (not subject) (setq subject glog-current-subject))
    (if (setq sub (assoc subject glog-subject-list))
	(setq art (assq mesno (cdr sub))))
    (if (and art (set-buffer glog-read-buffer))
	(save-excursion
	  (goto-char (glog-article-info-pos art))
	  (setq pe (glog-get-forward-line-position
		    (glog-article-info-lines art)))
	  ;; read-bufferœ蕶񂪗L邩
	  (if (re-search-forward regexp pe t)
	      (setq result (glog-get-current-line)))))
    (set-buffer cbuf)
    result))

(defun glog-save-buf (filename &optional buf append verbose)
  ;; w肳ꂽt@CɃZ[utԂ. Z[ułȂnilԂ.
  ;; bufw肳ĂȂ΃Jg̃obt@Z[u.
  ;; appendtȂ㏑ɃAyh.
  ;; verbosetȂ(㏑|Ayh)ɖ₢킹.
  (let ((longname (expand-file-name filename))(prompt)(errmsg)
	(cbuf (current-buffer))(sbuf)(tmpbuf)(result nil))
    (setq errmsg (format "%s: Write error!" longname))
    (setq prompt (format "%s exists. Shall I %s to it? "
			 longname (if append "append" "overwrite")))
    (setq sbuf (or buf cbuf))  ; buf  cbuf 
    ;; ̃obt@݂邩`FbN
    (if (glog-set-buffer sbuf)
	(if (or (not (file-exists-p longname))
		(not verbose)
		(and verbose (y-or-n-p prompt))) ;; verboseȂ₢킹
	    (condition-case ()
		  (progn
		    (if append
			(save-restriction
			  (widen)
			  (save-excursion
			    (append-to-file (point-min) (point-max) longname)))
		      ;; ㏑̏ꍇ̓e|̃obt@ɂڂ
		      ;; Z[u(backup肽)
		      (setq tmpbuf (generate-new-buffer "glogtmp"))
		      (set-buffer tmpbuf)
		      (setq buffer-read-only nil)
		      (insert-buffer sbuf)
		      (write-file longname)
		      (set-buffer sbuf)
		      (kill-buffer tmpbuf))
		    (setq result t))
		(error (message errmsg)))))
    (message "")
    (set-buffer cbuf)
    result))

(defun glog-read-config-file ()
  ;; .glogrcobt@ɓǂݍ,̃obt@Ԃ. ǂݍ߂Ȃnil.
  ;; ɓǂݍł΂̃obt@ԂI.
  (let ((cbuf (current-buffer))(longname (expand-file-name glog-config-file))
	(result))
    (if (setq result (get-file-buffer longname))
	;; ɓǂݍł
	()
      ;; ēǂݍ
      (if (file-exists-p longname)
	  ;; t@C݂Ȃ̂ōƒf
	  (progn
	    (if (not (file-readable-p longname))
		;; t@Cǂ߂Ȃ
		(glog-error (format "`%s' can't read." longname))
	      ;; .glogrcǂݍŃobt@쐬
	      (condition-case ()
		  (progn
		    (set-buffer (find-file-noselect longname))
		    (setq result (get-file-buffer longname))
		    (setq buffer-read-only nil)
		    (rename-buffer glog-rc-buffer))
		(error ()))))))
    ;; ǂݍ݂ɐeva
    (if result
	(condition-case ()
	    (progn
	      (set-buffer result)
	      (save-restriction
		(widen)
		(eval-current-buffer)))
	  (error (glog-error (format "eval error in `%s'"
				     (buffer-name result))))))
    (set-buffer cbuf)
    result))

(defun glog-get-empty-buffer (buffname)
  ;; ̃obt@쐬
  (let ((cbuf (current-buffer)))
    (if (not (get-buffer buffname))
	;; obt@΍쐬
	(get-buffer-create buffname)
      ;; ɓ̃obt@΃NA
      (set-buffer buffname)
      (setq buffer-read-only nil)
      (erase-buffer))
    ;; Jgobt@𕜋A
    (set-buffer cbuf)))

(defun glog-set-group-buffer ()
  ;; Group-buffer݂Ȃ΍쐬A݂΃Jgobt@ɃZbg
  (if (get-buffer glog-Group-buffer)
      (set-buffer glog-Group-buffer)
    (get-buffer-create glog-Group-buffer)
    (set-buffer glog-Group-buffer)
    (glog-Group-mode)))

(defun glog-set-subject-buffer ()
  ;; Subject-buffer݂ȂΏA݂΃Jgobt@ɃZbg
  (if (get-buffer glog-Subject-buffer)
      (set-buffer glog-Subject-buffer)
    (get-buffer-create glog-Subject-buffer)
    (set-buffer glog-Subject-buffer)
    (glog-Subject-mode)))

(defun glog-set-article-buffer ()
  ;; Article-buffer݂ȂΏA݂΃Jgobt@ɃZbg
  (if (get-buffer glog-Article-buffer)
      (set-buffer glog-Article-buffer)
    ;; o͂銿R[hݒ
    (progn
      (get-buffer-create glog-Article-buffer)
      (set-buffer glog-Article-buffer)
      (if (and (boundp 'MULE)
	       (boundp 'glog-file-coding-system-for-save-article))
	  (set-file-coding-system glog-file-coding-system-for-save-article)))
    (glog-Article-mode)))

(defun glog-require-file-name (prompt &optional oldname current default exist)
  ;; t@C₢킹.
  ;; prompt: bZ[Wsɕ\vvg
  ;; oldname: ȑOɐݒ肳Ăt@C
  ;; current: ftHg̃fBNg
  ;; default: ftHg̃t@C
  ;; exist:   tȂ瑶݂t@CȊO̓͂֎~
  (let ((pass)(fname)(prompt-str)(result))
    (if oldname
	(progn
	  (setq pass (file-name-directory oldname))
	  (setq fname oldname))
      (setq pass current)
      (setq fname default))
    (setq prompt-str (format "%s %s: "
			     (or prompt "") ; prompt  nil Ȃ ""
			     (if fname (concat "[default: "
					       (file-name-nondirectory fname)
					       "]") "")))
    ;; ꂽt@CfBNg̏ꍇ͍ē͂
    (while (file-directory-p
	    (setq result (read-file-name prompt-str pass fname exist))))
    result))

(defun glog-get-now-buffer-position ()
  ;; Jgobt@̐擪̈ʒu(0<=n<=100%)ŋ߂.
  (let ((pos (/ (point) (/ (point-max) 100))))
    (if (< pos 100) pos 100)))

(defun glog-get-forward-line-position (n)
  ;; nspoint𓾂
  (save-excursion
    (forward-line n)   ; get search end point
    (point)))

(defun glog-configure-windows (action &optional focus-win)
  ;; eWindow̃TCY`action'ɏ]Đݒ肷.
  ;; glog-window-configurationɓo^ĂV{('SelectNewsgroup)
  ;; w肷邱Ƃo鑼, `(1 0 0 0)'ƃXg𒼐ڗ^鎖o܂.
  ;;   Xg̃IvVbuffer-name,֐Iɂ̃obt@
  ;; \ĂwindowANeBuɂ܂.
  (let ((windows)(grpwin)(subwin)(artwin)(pstwin)(cbuf)
	(winsum nil)(height nil)
	(grpheight 0)(subheight 0)(artheight 0)(pstheight 0))
    ;; actionV{Ȃ,ΉconfigXg
    (setq windows (if (listp action)
		      action
		    (car (cdr (assq action glog-window-configuration)))))
    (setq grpwin (get-buffer-window glog-Group-buffer))
    (setq subwin (get-buffer-window glog-Subject-buffer))
    (setq artwin (get-buffer-window glog-Article-buffer))
    (setq pstwin (get-buffer-window glog-Post-buffer))
    ;; ɏwindowzuɂȂĂȂskip
    (if (or (null windows)
	    (and (eq (null grpwin)
		     (zerop (nth 0 windows)))
		 (eq (null subwin)
		     (zerop (nth 1 windows)))
		 (eq (null artwin)
		     (zerop (nth 2 windows)))
		 (eq (null pstwin)
		     (zerop (nth 3 windows)))))
	;; KvȂ
	nil
      ;; ǂꂩ̃EBhDƂɂselectedɂ
      (select-window (or grpwin subwin artwin pstwin (selected-window)))
      ;; Sʂgėǂ?
      (if glog-use-full-window
	  (progn
	    (delete-other-windows)
	    (setq height (window-height (selected-window))))
	;; ᖳꍇGLOGŎgĂwindow̑̍vł肭肷
	(setq height (+ (if grpwin (window-height grpwin) 0)
			(if subwin (window-height subwin) 0)
			(if artwin (window-height artwin) 0)
			(if pstwin (window-height pstwin) 0))))
      ;; Group-buffer폜Ăꍇ͍Đ
      (if (not (get-buffer glog-Group-buffer))
	  (progn
	    (glog-set-group-buffer)
	    (glog-Group-make-group)           ; O[vXg̍쐬
	    (if glog-current-subject          ; Osubjects
		(glog-Group-jump-to-group glog-current-subject))))
      ;; Ƃ肠GroupWindowȊOGLOGwindow
      (switch-to-buffer glog-Group-buffer t)
      (if (get-buffer glog-Subject-buffer)
	  (delete-windows-on glog-Subject-buffer)
	;; Subject-buffer폜Ăꍇ͍Đ
	(glog-set-subject-buffer)
	(if glog-current-subject
	    (glog-Subject-make-subject glog-current-subject))
	(if glog-current-article          ; Oarticles
	    (glog-Subject-goto-article glog-current-article)))
      (if (get-buffer glog-Article-buffer)
	  (delete-windows-on glog-Article-buffer)
	;; Article-buffer폜Ăꍇ͍Đ
	(glog-set-article-buffer))
      (if (get-buffer glog-Post-buffer)
	  (delete-windows-on glog-Post-buffer))
      ;; "windows"list̑aZoƂ
      (setq winsum (apply (function +) windows))
      ;; window-heighteobt@ŕ
      (if (not (zerop (nth 0 windows)))
	  (setq grpheight (max window-min-height
			       (/ (* height (nth 0 windows)) winsum))))
      (if (not (zerop (nth 1 windows)))
	  (setq subheight (max window-min-height
			       (/ (* height (nth 1 windows)) winsum))))
      (if (not (zerop (nth 2 windows)))
	  (setq artheight (max window-min-height
			       (/ (* height (nth 2 windows)) winsum))))
      (if (not (zerop (nth 3 windows)))
	  (setq pstheight (max window-min-height
			       (/ (* height (nth 3 windows)) winsum))))
      (setq height (+ grpheight subheight artheight pstheight))
      ;; ͗L...
      (enlarge-window (max 0 (- height (window-height (selected-window)))))
      ;; 񂶂ጋʂɂwindow𕪊܂傤
      ;; (҂ɏ,܂PostBuffer)
      (if (and (not (zerop pstheight))
	       (or (not (zerop grpheight))
		   (not (zerop subheight))
		   (not (zerop artheight))))
	  (split-window-vertically (+ grpheight subheight artheight)))
      (if (and (not (zerop artheight))
	       (or (not (zerop grpheight))
		   (not (zerop subheight))))
	  (split-window-vertically (+ grpheight subheight)))
      (if (and (not (zerop subheight))
	       (not (zerop grpheight)))
	  (split-window-vertically grpheight))
      ;; ł́A(window-list)ォ珇Ԃbuffer蓖ĂĂ܂傤
      (if (not (zerop grpheight))
	  (progn
	    (set-window-buffer (selected-window) glog-Group-buffer)
	    (other-window 1)))
      (if (not (zerop subheight))
	  (progn
	    (set-window-buffer (selected-window) glog-Subject-buffer)
	    (other-window 1)))
      (if (not (zerop artheight))
	  (progn
	    (set-window-buffer (selected-window) glog-Article-buffer)
	    (bury-buffer glog-Article-buffer)
	    (other-window 1)))
      (if (not (zerop pstheight))
	  (progn
	    (setq cbuf (current-buffer))
	    (glog-set-post-buffer) ;; post-bufferkillĂ鋰ꂪL
	    (set-buffer cbuf)
	    (set-window-buffer (selected-window) glog-Post-buffer)))
      ;; windowtH[JX
      (if (and focus-win
	       (get-buffer-window focus-win))
	  (select-window (get-buffer-window focus-win))))))

;; Define GLOG Subsystems.
(autoload 'glog-search-and-append-list "glog_utl"
	  "Jgobt@ŎwST" t)
(autoload 'glog-add-cons-list "glog_utl"
	  "Get data and add to `_glogrc'" t)
(autoload 'glog-add-handle-list "glog_utl"
	  "Get handle name and add to `_glogrc'" t)
(autoload 'glog-add-purge-list "glog_utl"
	  "Get handle name and add to `_glogrc'" t)
(autoload 'glog-add-search-regexp-list "glog_utl"
	  "Get handle name and add to `_glogrc'" t)
(autoload 'glog-add-purge-subject-list "glog_utl"
	  "Get subject name and add to `_glogrc'" t)
(autoload 'glog-add-savearticle-list "glog_utl"
	  "Get save file-name and add to `_glogrc'" t)
(autoload 'glog-add-ML-list "glog_utl"
	  "Get ML name and add to `_glogrc'" t)
(autoload 'glog-Info-find-node "glog_utl"
	  "Find documentation of GLOG and show page." t)

(autoload 'glog-require-bbs-type "glog_utl"
	  "BBSʂ̑SXg\Ďw肳" t)
(autoload 'glog-force-bbs "glog_utl"
	  "IɓBBSݒ肷" t)
(autoload 'glog-save-all-article "glog_utl"
	  "o^ĂSsubject̔ۑ" t)
(autoload 'glog-batch-view "glog_utl"
	  "R}hCŎw肳ꂽLOG𕪐͂\" t)
(autoload 'glog-batch-save "glog_utl"
	  "R}hCŎw肳ꂽLOGA`ꂽ{[hZ[u" t)

;;
;;  Start up
;;

(defun glog-init ()
  ;; GLOG̊eϐ,obt@܂
  (if glog-init-flag
      ()
    ;; Nwindow-configurationZ[u
    (glog-save-window-configuration 'ORG)
    ;; get empty buffers and set up them.
    (glog-set-group-buffer)
    (glog-set-subject-buffer)
    (glog-set-article-buffer)
    (fset 'glog-correct-article (function glog-undefined-function))
    ;; Message-IdXgj
    (setq glog-readed-list nil)
    ;; t@Cĕ]
    (let ((cbuf (current-buffer)) (sbuf))
      (if (setq sbuf (glog-read-config-file))
	  (progn
	    (set-buffer sbuf)
	    (save-restriction
	      (widen)
	      (eval-current-buffer))
	    (set-buffer cbuf))))
    (garbage-collect)
    ;; reference buffer
    (glog-get-empty-buffer glog-read-buffer)
    (set-buffer glog-read-buffer)
    ;; GroupEBhD\
    (glog-configure-windows '(1 0 0 0) glog-Group-buffer)
    ;; tO𗧂Ă
    (setq glog-init-flag t)
    ;; hookݒ肳ĂΎs
    (run-hooks 'glog-init-hook)))

(defun glog-kill (&optional save)
  "IƂăobt@ϐ܂"
  (interactive)
  (let ((cbuf (current-buffer))(blist)(foo)(i 0))
    ;; .glogrcZ[u
    (if (and (setq foo (get-file-buffer (expand-file-name glog-config-file)))
	     (buffer-modified-p foo))
	(progn
	  (set-buffer foo)
	  (widen)
	  (condition-case ()
	      (save-buffer)
	    (error ()))
	  (set-buffer cbuf)))
    ;; ֘Aobt@NA (`glog-Post-buffer'͏Ȃ '95.5.14)
    (setq blist (list glog-Group-buffer glog-Subject-buffer
		      glog-Article-buffer glog-read-buffer))
    (while (setq foo (nth i blist))
      (if (eq save foo)
	  ()
	;; "foo"bufferɊ֘Awindow
	(condition-case ()
	    (delete-windows-on foo)
	  (error ()))
	;; |
	(condition-case ()
	    (progn
	      (set-buffer foo)
	      (kill-all-local-variables)
	      (setq buffer-read-only nil)
	      (set-buffer-modified-p nil)
	      (kill-buffer foo))
	  (error ())))
      (inc i))
    ;; Nwindow-configuration
    (glog-set-window-configuration 'ORG)
    ;; ϐNA
    (setq glog-refer-buffer nil)
    (setq glog-subject-list nil)
    (setq glog-current-subject nil)
    (setq glog-current-article nil)
    (setq glog-post-file-name nil)
    (setq glog-readed-list nil)
    ;; tONA
    (setq glog-init-flag nil)
    ;; hooks
    (run-hooks 'glog-kill-hook)
    (garbage-collect)))

(defun glog-startup-message (&optional dbuf)
  ;; Insert GLOG's startup message in current buffer.
  (let ((cbuf (current-buffer))(foo)(bar)(len)(count 0))
    ;; obt@make
    (or dbuf (setq dbuf glog-Group-buffer)) ; dbufnilȂgroup-buf
    (glog-get-empty-buffer dbuf)
    (switch-to-buffer dbuf)
    (setq buffer-read-only nil)
    ;;
    (goto-char (point-min))
    (setq len (length glog-startup-message))
    (if (< len (window-height))
	(insert (make-string (/ (- (window-height) len) 3) ?\n)))
    (while (< count len)
      (setq foo (elt glog-startup-message count))
      (setq bar (if (< (length foo)(window-width))
		    (make-string (/ (- (window-width) (length foo)) 2) ? )
		  ""))
      (insert (concat bar foo "\n"))
      (inc count))
    (set-window-start (selected-window) 0)
    (set-buffer-modified-p nil)
    (sit-for 0)
    ;; StartUpMessage͍ŏ̈xɂ܂
    (setq glog-startup-message nil)
    ;; Jgobt@𕜋A
    (set-buffer cbuf)))

(defun glog-Group-show-info (info &optional mode)
  ;; Show infomation on group buffer.
  (let ((cbuf (current-buffer)))
    (set-buffer glog-Group-buffer)
    (setq mode-line-buffer-identification (concat "GLOG: " info))
    (if mode (setq mode-name mode))
    (sit-for 0)
    (set-buffer cbuf)))

(defun glog-check-unread-group ()
  ;; ǂ̃`FbN. ǂcĂȂt.
  (let ((cbuf (current-buffer))(result nil) (kanji-flag)(mc-flag))
    (set-buffer glog-Group-buffer)
    (save-excursion
      (goto-char (point-min))
      (if (not
	   (re-search-forward "^..[ \t]+\\([1-9]+\\|[1-9][0-9]+\\)\:" nil t))
	  (setq result t)))       ;; ǂ͎cĂȂ
    (set-buffer cbuf)
    result))

(defun glog-confirm-init ()
  ;; glog-subject-listݒ肵Ăꍇ,ėǂmF.
  ;; ėǂꍇ(͐ݒ肵Ėꍇ)t, ~ꂽꍇnilԂ.
  (if (and glog-subject-list (not (glog-check-unread-group)))
      (if (y-or-n-p "Do you really want to purge old data? ")
	  (progn
	    (glog-message "") ;; bZ[Ws
	    (glog-kill)
	    t)
	(message "Quit viewing new log.")
	nil)
    t))

(defun glog-view-buffer-mode (buf &optional bufpos)
  "obt@̓eLOGƂĕ͂\
\\{glog-view-buffer-mode-map}"
  (interactive "bView buffer: ")
  ;; viewing check
  (if (or (not (get-buffer buf)) (not (glog-confirm-init)))
      ;; buffer,邢͒OLOGjۂꂽꍇ͉ɏI
      (if (not (get-buffer buf))
	  (glog-error (format "No buffer named `%s'" buf)))
    ;; make buffers and init variables
    (glog-init)
    ;; set refer buffer name
    (switch-to-buffer buf)
    (setq glog-refer-buffer (current-buffer))
    ;; ǂBBS
    (if (glog-search-now-buf)    
	(progn
	  (glog-Group-show-info
	   "Searching title list"
	   (nth 1 (assoc glog-bbs-type glog-bbs-list)))
	  (glog-Group-search-group bufpos)
	  (if glog-sort-subject
	      (glog-Group-sort-group))     ; O[vXg̃\[g
	  (glog-Group-make-group)))
    (if glog-subject-list
	(progn
	  (if (not (get-buffer-window glog-Group-buffer))
	      ;; GroupEBhD\
	      (glog-configure-windows '(1 0 0 0) glog-Group-buffer))
	  (glog-Group-describe-briefly))
      ;; FɎs->蓮
      (glog-force-bbs buf))))

(defun glog-view-file-mode (filename &optional bbs)
  "t@CǂݍLOGƂĕ͂\.
\\{glog-view-file-mode-map}"
  (interactive (list (read-file-name "View file: " glog-log-directory nil t)))
  (let ((res)(ocode))
    (setq filename (expand-file-name filename))
    ;; viewing check
    (if (glog-confirm-init)
	;; make buffers and init variables
	(progn
	  (glog-init)
	  ;; GroupEBhD\
	  (glog-configure-windows '(1 0 0 0) glog-Group-buffer)
	  ;; show info
	  (glog-Group-show-info
	   (concat "reading " (file-name-nondirectory filename)) "Unknown")
	  ;; read viewing file
	  (set-buffer glog-read-buffer)
	  (setq buffer-read-only nil)
	  (erase-buffer)
	  ;; ǂݍ(MuleȂ̓t@C̊R[hݒ肵Ă)
	  (if (not (and (boundp 'MULE)
			(boundp 'glog-file-coding-system-for-read)))
	      (setq res (insert-file-contents filename))
	    (setq ocode file-coding-system-for-read)
	    (setq file-coding-system-for-read glog-file-coding-system-for-read)
	    (setq res (insert-file-contents filename))
	    (setq file-coding-system-for-read ocode))
	  (if (not res)
	      ;; ǂݍ݂ɎŝŏI
	      (glog-kill)
	    ;; ǂݍ݂ɐ
	    (setq glog-refer-buffer (current-buffer))
	    (setq buffer-read-only t)
	    (set-buffer-auto-saved)
	    ;; log-directorydirectoryɏC
	    (setq glog-log-directory (file-name-directory filename))
	    ;; BBS胂[h\
	    (glog-Group-show-info "Checking BBS type   " "Unknown")
	    (set-buffer glog-refer-buffer)
	    ;; ǂBBS
	    (if (if (not bbs)
		    (glog-search-now-buf)
		  ;; BBSʎwN̏ꍇ  '95.6.20
		  (setq glog-bbs-type (glog-set-bbs-function bbs)))
		;; ΉBBSȂGroup[h
		(progn
		  (glog-Group-show-info
		   "Searching title list"
		   (nth 1 (assoc glog-bbs-type glog-bbs-list)))
		  (glog-Group-search-group)        ; ^Cg
		  (if glog-sort-subject
		      (glog-Group-sort-group))     ; O[vXg̃\[g
		  (glog-Group-make-group           ; O[vXg̍쐬
		   (file-name-nondirectory filename))))
	    (if glog-subject-list
		(glog-Group-describe-briefly); show help
	      (glog-force-bbs)))))))       ; FɎs->蓮

(defun glog (filename bbs-type)
  "t@CǂݍLOGƂĕ͂\.
`C-u M-x glog' ƂƂ BBS ^Cv̓͂߂."
  (interactive (list (read-file-name "View file: " glog-log-directory nil t)
		     (if current-prefix-arg
			 (intern (read-from-minibuffer "BBS type: ")) )))
  ;; viewing check
  (if (glog-confirm-init)
    ;; make buffers and init variables
      (progn
	(glog-init)
	;; show title
	(if (and (not glog-quiet-mode) glog-startup-message)
	    (glog-startup-message))
	(glog-view-file-mode filename bbs-type))))

(defun glog-save-window-configuration (mode)
  ;; window-configurationZ[u܂. mode'ORG'GLOG̓.
  (let ((winconf (current-window-configuration)))
    (condition-case ()
	(if (eq mode 'ORG)
	    (setcdr glog-resume-window-list winconf)
	  (setcar glog-resume-window-list winconf))
      (error (setq glog-resume-window-list (cons winconf winconf))))))

(defun glog-set-window-configuration (mode)
  ;; window-configuration؂ւ܂. mode'ORG'GLOG̓.
  (condition-case ()
      (if (eq mode 'ORG)
	  (set-window-configuration (cdr glog-resume-window-list))
	(set-window-configuration (car glog-resume-window-list)))
    ;; listorG[oꍇ
    (error (glog-save-window-configuration mode))))

(defun glog-pause (&optional saveonly)
  "GLOGwindowꎞ܂.(ex.BOSS!)"
  (interactive)
  ;; window-configurationZ[u(car:window-list, cdr:???)
  (glog-save-window-configuration 'GLOG)
  ;; Nwindow\
  (if saveonly
      ()
    (glog-set-window-configuration 'ORG)
    ;; GLOG֌Wwindow
    (let ((foo)(i 0)(blist (list glog-Post-buffer glog-Article-buffer
				 glog-Subject-buffer glog-Group-buffer)))
      (while (setq foo (nth i blist))
	(if (get-buffer foo)
	    (delete-windows-on foo))
	(inc i)))
    (message ""))    ;; message
  ;; [U[`֐s
  (run-hooks 'glog-pause-hook))

(defun glog-resume ()
  "PAUSEԂ畜A"
  (interactive)
  (glog-save-window-configuration 'ORG)
  (glog-set-window-configuration 'GLOG)
  (run-hooks 'glog-resume-hook))

(defun glog-kill-buffer (win)
  "[C-x k]SɎgׂ̃_~[֐.
glog֘Abuffer͍폜windowł"
  (interactive "bKill Buffer: ")
  (if (or (equal win glog-Group-buffer)   (equal win glog-Subject-buffer)
	  (equal win glog-Article-buffer) (equal win glog-Post-buffer)
	  (equal win glog-read-buffer))
      ;; glog֘Abuffer, killdelete-windoŵ
      (progn
	;; resumeł悤window-configurationZ[u
	(glog-save-window-configuration 'GLOG)
	(if (one-window-p)
	    (delete-windows-on win)
	  (delete-window (get-buffer-window win)))
	(glog-message "[M-x glog-resume] to restore window."))
    ;; glogȊObufferȂ̂ł̂܂kill
    (kill-buffer win)))


;;
;;  Group mode
;;

(defvar glog-Group-mode-map nil
  "Local key map for Group mode in GLOG.")

(defun glog-make-Group-mode-keymap ()
  ;; Make local key map for Group mode in GLOG.
  (if glog-Group-mode-map
      ()
    (setq glog-Group-mode-map (make-keymap))
;;(fillarray  glog-Group-mode-map 'glog-undefined-key-actions)
  (define-key glog-Group-mode-map " " 'glog-Group-read-group)
  (define-key glog-Group-mode-map "=" 'glog-Group-select-group)
  (define-key glog-Group-mode-map "j" 'glog-Group-jump-to-group)
  (define-key glog-Group-mode-map "n" 'glog-Group-next-unread-group)
  (define-key glog-Group-mode-map "p" 'glog-Group-prev-unread-group)
  (define-key glog-Group-mode-map "\177" 'glog-Group-prev-unread-group)
  (define-key glog-Group-mode-map "N" 'glog-Group-next-group)
  (define-key glog-Group-mode-map "P" 'glog-Group-prev-group)
  (define-key glog-Group-mode-map "\C-n" 'glog-Group-next-group)
  (define-key glog-Group-mode-map "\C-p" 'glog-Group-prev-group)
  (define-key glog-Group-mode-map "\r"   'glog-Group-next-group)
  (define-key glog-Group-mode-map "\C-f" 'glog-Group-scroll-up)
  (define-key glog-Group-mode-map "\C-b" 'glog-Group-scroll-down)
  (define-key glog-Group-mode-map "\C-v" 'glog-Group-scroll-up)
  (define-key glog-Group-mode-map "\Ev"  'glog-Group-scroll-down)
  (define-key glog-Group-mode-map "/" 'isearch-forward)
  (define-key glog-Group-mode-map "<" 'beginning-of-buffer)
  (define-key glog-Group-mode-map ">" 'end-of-buffer)
  (define-key glog-Group-mode-map "u" 'glog-Group-unsubscribe-current-group)
  (define-key glog-Group-mode-map "U" 'glog-Group-unsubscribe-group)
  (define-key glog-Group-mode-map "a" 'glog-Group-post)
  (define-key glog-Group-mode-map "\e\C-t"   'glog-toggle-threads)
  (define-key glog-Group-mode-map "\C-ch"    'glog-add-handle-list)
  (define-key glog-Group-mode-map "\C-c\C-h" 'glog-add-purge-list)
  (define-key glog-Group-mode-map "\C-cs"    'glog-add-search-regexp-list)
  (define-key glog-Group-mode-map "\C-co"    'glog-add-savearticle-list)
  (define-key glog-Group-mode-map "\C-xk" 'glog-kill-buffer)
  (define-key glog-Group-mode-map "\C-w" 'copy-region-as-kill)
  (define-key glog-Group-mode-map "O" 'glog-Group-save-all-article)
  (define-key glog-Group-mode-map "V" 'glog-version)
  (define-key glog-Group-mode-map "c" 'glog-Group-catch-up)
  (define-key glog-Group-mode-map "C" 'glog-Group-catch-up-all)
  (define-key glog-Group-mode-map "s" 'glog-Group-force-update)
  (define-key glog-Group-mode-map "z" 'glog-Group-suspend)
  (define-key glog-Group-mode-map "q" 'glog-Group-exit)
  (define-key glog-Group-mode-map "Q" 'glog-Group-quit)
  (define-key glog-Group-mode-map "!" 'glog-pause)
  (define-key glog-Group-mode-map "?" 'glog-Group-describe-briefly)
  (define-key glog-Group-mode-map "\C-c\C-i" 'glog-Info-find-node)
))

(defun glog-Group-mode ()
  "Function of GLOG. Show group list buffer.
\\{glog-Group-mode-map}"
  (interactive)
  (set-buffer glog-Group-buffer)
  (buffer-flush-undo (current-buffer))
  (setq major-mode 'glog-Group-mode)
  (setq mode-name "Group")
  (setq mode-line-buffer-identification "GLOG:")
  (setq mode-line-process nil)
  (use-local-map glog-Group-mode-map)
  (setq parse-sexp-ignore-comments t)
  (run-hooks 'glog-Group-mode-hook))

(defun glog-Group-info-searching-position ()
  (let ((kanji-flag t)(mc-flag t))  ; Ȃƕ
    (glog-message
     ;; L̃tH[}bg message ̈Ƃēn߁A%%%% ƂĂB
     ;; %% ƁAmessage ̈Ƃĕ]Ƃ % ɂȂĂ܂Aargument 
     ;; sƓ{Ă܂B
     (format "GLOG: %d%%%% of headers received. (Looking: %s)"
	     (glog-get-now-buffer-position)
	     (glog-replace-long-space glog-current-subject) ))))

(defun glog-Group-add-article (subject-name &optional article uniq)
  ;; Internal Function of `glog-Group-search-subject'.
  ;; Add subject to title list.
  ;; Use scope `sub-cons',`sub-car' and sub-cdr' (in glog-Group-search-subject)
  (let ((art)(mesno))
    (if (or (string= subject-name sub-car)
	    (if (setq sub-cons (assoc subject-name glog-subject-list))
		(progn
		  (setq sub-car (car sub-cons))
		  (setq sub-cdr (cdr sub-cons)))
	      nil))
	;; current̃yA΁ÃyAcdrlistǉ
	(progn
	  (setq mesno (glog-article-info-no article))
	  ;; uniqnon-nilȂAuniqȔԍɂȂ悤ɕ␳(mailp)
	  (if (and uniq
		   (setq art (assq mesno sub-cdr))
		   ;; idtitleƔᖳdv
		   (or (not (string= (glog-article-info-title article)
				     (glog-article-info-title art)))
		       (not (string= (glog-article-info-id    article)
				     (glog-article-info-id    art)))
		       (not (string= (glog-article-info-date  article)
				     (glog-article-info-date  art)))))
	      (progn
		;; ԍuniqɂȂ܂Ń[vinc
		(while (and (assq mesno sub-cdr) (> mesno 0))
		  (inc mesno))
		(setcar article mesno)))
	  ;; ԍarticle`FbN
	  (if (setq art (assq mesno sub-cdr))
	      ;; (݂ꍇ͍s傫o^)
	      (if (> (glog-article-info-lines article)
		     (glog-article-info-lines art))
		  (progn
		    ;; Âarticle폜
		    (setq sub-cdr (delq art (copy-alist sub-cdr)))
		    (nconc sub-cdr (list article))))
	    ;; ԍarticlê͖œo^
	    (nconc sub-cdr (list article))))
      ;; 'glog-current-subject'ɖꍇ(VK{[h)
      (setq sub-cons (cons subject-name (list article)))
      (setq sub-car subject-name)
      (setq sub-cdr (cdr sub-cons))
      (if glog-subject-list
	  ;; 'glog-subject-list'ɐVK{[hǉ
	  (nconc glog-subject-list (list sub-cons))
	;; ŏ̃{[h̏ꍇA'glog-subject-list'VKɍ쐬
	(setq glog-subject-list (list sub-cons))))
    ;; Iɐis󋵂񍐂
    (if (= (% (length sub-cdr) 20) 0)
	(glog-Group-info-searching-position))))

(defun glog-Group-search-subject (&optional bufpos)
  ;; Internal Function of `glog-Group-search-group'.
  ;; Search subjects and make subject-list.
  (let ((forum "unknown")(board "misc")(sub-cons nil)(sub-car "")(sub-cdr "")
	(mllist) (article)(foo)(bar)(lines) (buf))
    ;; mailing-list-idXgo^Ă
    (setq mllist
	  (glog-assoc-list glog-bbs-type glog-ML-list (list (list nil))))
    (setq glog-current-subject (concat forum "." board))
    (save-excursion
      (goto-char (or bufpos (point-min))) ; bufposnilȂbuffer擪
      ;; 
      (while (re-search-forward glog-search-regexp nil t)
	;; get 1 line
	(setq buf (buffer-substring (match-beginning 0) (match-end 0)))
	;; pxɔr
	(cond
	 ;; article start ?
	 ((string-match glog-match-string-article buf)
	  (progn
	    (setq article (glog-get-article-info))
	    ;; articleȂglog-subject-listɓo^
	    (if article
		(glog-Group-add-article glog-current-subject article)
	      (forward-line))))
	 ;; mail start ?
	 ((and glog-match-string-mail
	       (string-match glog-match-string-mail buf))
	  (progn
	    (setq article (glog-get-mail-info))
	    (if (null article)
		;; mailŖꍇ́Alistɓo^s
		(forward-line)
	      ;; `.mail'Ƃēo^
	      (setq foo glog-current-subject)
	      (setq glog-current-subject ".mail")
	      ;; MLo^ĂȂ
	      (if (and (setq replyto (glog-article-info-replyto article))
		       (setq bar (assoc replyto mllist)))
		  (setq glog-current-subject (format ".ML(%s)" (cdr bar))))
	      (glog-Group-add-article glog-current-subject article 'uniq)
	      (setq glog-current-subject foo))))
	 ;; board start ?
	 ((and glog-match-string-board
	       (string-match glog-match-string-board buf))
	  (progn
	    (setq board (glog-get-board-name))
	    (if board (setq glog-current-subject (concat forum "." board)))
	    (glog-Group-info-searching-position)))
	 ;; forum start?
	 ((and glog-match-string-forum
	       (string-match glog-match-string-forum buf))
	  (progn
	    (if (setq foo (glog-get-forum-name))
		(progn
		  (setq bar forum)         ; rׂ̈ɑOforumۑ
		  (setq forum (downcase foo))
		  (if (not (string= forum bar))
		      (setq board "misc")) ; forumςboard
		  (setq glog-current-subject (concat forum "." board))))
	    (glog-Group-info-searching-position)))
	 ;; ʂ蔲h~
	 (t (forward-line)))
	;; {[hrhook
	(run-hooks 'glog-Group-search-group-loop-hook)
	;; `i' Œf
	(if (and (input-pending-p)
		 (eq (downcase (read-char)) ?i))
	    (progn
	      (setq buf "")
	      (goto-char (point-max))
	      (glog-message "Interrupted."))))))
  ;; current-subject̏
  (setq glog-current-subject nil))

(defun glog-Group-search-group (&optional bufpos add)
  "Search current buffer and make title list.
bufposw肳Ă΁Ãobt@ʒuJn.

  Ԃy߂悤ɁAFX׍Hłhookpӂ܂.

    Jn: glog-Group-search-group-start-hook
      : glog-Group-search-group-loop-hook
    I: glog-Group-search-group-end-hook

  ܂AhookŎg悤Ɏϐ(glog-Group-search-v*)錾Ă܂."
  (interactive)
  (let ((glog-Group-search-v1)(glog-Group-search-v2)(glog-Group-search-v3)
	(glog-Group-search-v4)(glog-Group-search-v5)(glog-Group-search-v6))
    (if (not add) (setq glog-subject-list nil)) ;; addnon-nilȂ珉
    ;; {[hJnhook
    (run-hooks 'glog-Group-search-group-start-hook)
    ;; Jn
    (glog-Group-search-subject bufpos)
    ;; {[hIhook
    (run-hooks 'glog-Group-search-group-end-hook)))

(defun glog-Group-count-unread-subject (now-subject)
  "Count unread subjects."
  (interactive)
  (let ((subject)(sub-list)(article)(foo 0)(purgelist)(count 0))
    ;; \idXgo^Ă
    (setq purgelist
	  (glog-assoc-list glog-bbs-type glog-purge-id-list (list (list nil))))
    (if (listp glog-subject-list)
	(progn
	  ;; search assoc by `now-subject' to getting pair's cdr
	  (setq subject (assoc now-subject glog-subject-list))
	  ;; check subject
	  (if (consp subject)
	      (progn
		(setq sub-list (cdr subject))
		;; loop subject to end
		(while (setq article (elt sub-list foo))
		  ;; ǂ\idȂ
		  (if (or (eq ?d (glog-article-info-unread article)) ;ǂ
			  (assoc (glog-article-info-id article) purgelist))
		      ()
		    ;; check and count up `unread'
		    (inc count))
		  (inc foo))))))
    count))

(defun glog-lessp-group (str1 &optional str2)
  ;; glog-Group-sort-groupŌĂ΂. 2subjectr.
  (string-lessp (car str1) (car str2)))

(defun glog-Group-sort-group (&optional way)
  ;; Sort subjects.
  (if (listp glog-subject-list)
      (setq glog-subject-list (sort glog-subject-list
				    (if (or (not way) (eq way t))
					'glog-lessp-group
				      way)))
    (message "I can't sort group!")))

(defun glog-Group-search-regexp-subject (now-subject)
  ;; Internal Function of `glog-Group-make-group'.
  ;; wsubjectŌʂԂ.
  (let ((sub)(sub-list)(art)(foo)(bar)(regexp nil)(count 0)(res nil))
    ;; 񃊃Xgo^Ă
    (if (and (boundp 'glog-search-regexp-list) glog-bbs-type)
	(progn
	  (setq sub (glog-assoc-list glog-bbs-type glog-search-regexp-list))
	  (if (listp sub)
	      (progn
		(setq foo (glog-assoc-list "all" sub))
		(setq bar (glog-assoc-list now-subject sub))
		(setq regexp (if (and foo bar)
				 (format "\\(%s\\|%s\\)" foo bar)
			       (or foo bar))))))) ; foonilȂbarZbg
    ;; search assoc by `now-subject' to getting pair's cdr
    (if (and regexp
	     (listp glog-subject-list)
	     (setq sub (assoc now-subject glog-subject-list))
	     (consp sub))
	;; check subject
	(progn
	  (setq sub-list (cdr sub))
	  ;; loop subject to end
	  (while (and (setq art (elt sub-list count)) (not res))
	    (setq res (glog-article-search-regexp regexp
						  (glog-article-info-no art)
						  now-subject))
	    (inc count))))
    res))

(defun glog-Group-make-group (&optional bufname)
  "Search current buffer and make title list.
`glog-auto-search-group'non-nil, 񂪐ݒ肳Ă
ꗗɕ\.  '95.5.16"
  (interactive)
  (let ((count 0)(title)(purgelist)(sdisp nil)(sres nil)(mflag nil))
    ;; \{[hXgo^Ă
    (setq purgelist (glog-assoc-list
		     glog-bbs-type glog-purge-subject-list (list (list nil))))
    ;; ʂ\Ȃ
    (if (and (boundp 'glog-auto-search-group) glog-auto-search-group
	     (boundp 'glog-search-regexp-list) (listp glog-search-regexp-list))
	(setq sdisp t))
    ;; MuleȂ
    (if (boundp 'MULE) (setq mflag t))
    (if (not (listp glog-subject-list))
	;; No unread news
	(glog-message "No more unread news.")
      ;; get buffer name
      (if (not bufname) (setq bufname (buffer-file-name (current-buffer))))
      ;; get empty buffer
      (set-buffer glog-Group-buffer)
      (setq truncate-lines t)               ; stop line folding
      (setq buffer-read-only nil)
      (erase-buffer)
      ;; show BBS name
      (setq mode-name (nth 1 (assoc glog-bbs-type glog-bbs-list)))
      ;; show viewing file's name
      (setq mode-line-buffer-identification (concat "GLOG: viewing " bufname))
      (setq title (length glog-subject-list))
      (if (< title 2)
	  (sit-for 0)
	(glog-message (format "GLOG: %d subjects." title)))
      ;; insert board names
      (while (setq title (car (nth count glog-subject-list)))
	;; 
	(setq sres (if sdisp (glog-Group-search-regexp-subject title) nil))
	;; \{[hłȂΕ\(Δ\ݒł\)
	(if (or (not (assoc title purgelist)) sres)
	    (insert (format "%7d:%s%s\n"
			    (glog-Group-count-unread-subject title)
			    (if sres "*" " ")
			    title)))
	;; MuleȂ狭ł͂Ȃ`glog-emphasize-match-hook'g
	(if (and sres mflag)
	    (save-excursion
	      (forward-line -1)
	      (beginning-of-line)
	      (re-search-forward "^[ \t0-9]+" nil t)
	      (run-hooks 'glog-emphasize-match-hook)))
	(inc count))
      ;; Adjust cursor point.
      (goto-char (point-min))
      (re-search-forward glog-regexp-group-line nil t)
      (setq buffer-read-only t)
      (set-buffer-modified-p nil))))

(defun glog-Group-get-subject-name ()
  ;; Function of GLOG. Get subject name at group buffer.
  (let ((cbuf (current-buffer))(linebuf)(result nil) (kanji-flag)(mc-flag))
    (if (glog-set-buffer glog-Group-buffer)
	(progn
	  (setq linebuf (glog-get-current-line))
	  (if (string-match "\:." linebuf)
	      (setq result (substring linebuf (+ (match-beginning 0) 2))))
	  (set-buffer cbuf)))
    result))

(defun glog-Group-select-group (&optional subject)
  "Function of GLOG. Select subject on group buffer."
  (interactive)
  (or subject (setq subject (glog-Group-get-subject-name)))
  (if subject
      (progn
	(glog-Subject-sort-article subject)
	(glog-Subject-make-subject subject)
	(set-buffer glog-Subject-buffer)
	(if (< (buffer-size) 1)
	    ;; ǂ߂Lꍇ
	    (message
	     (format "GLOG: No readable article in `%s'" subject))
	  (glog-configure-windows 'ExpandSubject glog-Subject-buffer)
	  (bury-buffer glog-Group-buffer)
	  (goto-char (point-min))
	  (re-search-forward glog-regexp-subject-line nil t)))))

(defun glog-Group-read-group (&optional subject)
  "Function of GLOG. Select subject and show it."
  (interactive)
  (or subject (setq subject (glog-Group-get-subject-name)))
  (if subject
      (progn
	(glog-Subject-sort-article subject)
	(glog-Subject-make-subject subject)
	(set-buffer glog-Subject-buffer)
	(if (< (buffer-size) 1)
	    ;; ǂ߂Lꍇ
	    (message
	     (format "GLOG: No readable article in `%s'" subject))
	  (if glog-auto-select-first
	      (progn
		(glog-configure-windows 'SelectArticle glog-Subject-buffer)
		(glog-Subject-show-page))
	    (glog-configure-windows 'ExpandSubject glog-Subject-buffer))
	  (bury-buffer glog-Group-buffer)
	  (goto-char (point-min))
	  (re-search-forward glog-regexp-subject-line nil t)))))

(defun glog-Group-scroll-up (lines)
  "group-bufferŃXN[up"
  (interactive "p")
  (let ((cwin (selected-window)))
    (if (select-window (get-buffer-window glog-Group-buffer))
	(progn
	  (condition-case ()
	      (scroll-up (if (> lines 1) lines (/ (window-height) 2)))
	    (error ()))
	  (select-window cwin)))))

(defun glog-Group-scroll-down (lines)
  "group-bufferŃXN[down"
  (interactive "p")
  (let ((cwin (selected-window)))
    (if (select-window (get-buffer-window glog-Group-buffer))
	(progn
	  (condition-case ()
	      (scroll-down (if (> lines 1) lines (/ (window-height) 2)))
	    (error ()))
	  (select-window cwin)))))

(defun glog-Group-completing-read-group (&optional org)
  ;; subject̕⊮L
  (completing-read "Group name: " glog-subject-list nil t org))

(defun glog-Group-jump-to-group (&optional group)
  "groupobt@Ŏw肳ꂽgroupֈړ"
  (interactive)
  (let ((cbuf (current-buffer))(regexp)(pos))
    (if (not group)
	(setq group (glog-Group-completing-read-group)))
    (if (and group (set-buffer glog-Group-buffer))
	(progn
	  (setq pos (point))
	  (goto-char (point-min))
	  (setq regexp (concat "[0-9]+:." group))
	  (if (re-search-forward regexp nil t)
	      (progn
		(beginning-of-line)
		(re-search-forward glog-regexp-group-line nil t))
	    ;; Ȃ猳̈ʒu
	    (goto-char pos)
	    (if (interactive-p) (glog-message "No such subject.")))
	  (set-buffer cbuf)))))

(defun glog-Group-prev-unread-group ()
  "groupobt@őO̖groupֈړ"
  (interactive)
  (glog-Group-prev-group t))

(defun glog-Group-next-unread-group ()
  "groupobt@Ŏ̖groupֈړ"
  (interactive)
  (let (result)
    (if (setq result (glog-Group-next-group t))
	()
      (if (interactive-p) (glog-message "No unread subject.")))
    result))

(defun glog-Group-prev-group (&optional unread)
  "groupobt@őOsubjectɈړ"
  (interactive)
  (let ((cbuf (current-buffer))(linebuf)(foo)(bar)(result nil))
    (set-buffer glog-Group-buffer)
    (beginning-of-line)
    (while (if (null result)
	       (re-search-backward glog-regexp-group-line nil t)
	     nil)
      (setq linebuf (glog-get-current-line))
      (if (setq foo (string-match "[0-9]+:" linebuf))
	  (progn
	    ;; ǐǂ
	    (setq bar (string-to-int (substring linebuf foo)))
	    ;; ǂ
	    (if (and (or (> bar 0) (null unread))
		     (string-match ":." linebuf))
		      (setq result (format "%s [%d]"
					   (substring linebuf (match-end 0))
					   bar))))))
    (beginning-of-line)
    (re-search-forward glog-regexp-group-line nil t)
    (set-buffer cbuf)
    result))

(defun glog-Group-next-group (&optional unread)
  "groupobt@ŎsubjectɈړ"
  (interactive)
  (let ((cbuf (current-buffer))(linebuf)(foo)(bar)(result nil))
    (set-buffer glog-Group-buffer)
    (beginning-of-line)
    (forward-line)
    (while (if (null result)
	       (re-search-forward glog-regexp-group-line nil t)
	     nil)
      (setq linebuf (glog-get-current-line))
      (if (setq foo (string-match "[0-9]+:" linebuf))
	  (progn
	    ;; ǐǂ
	    (setq bar (string-to-int (substring linebuf foo)))
	    ;; ǂ
	    (if (and (or (> bar 0) (null unread))
		     (string-match ":." linebuf))
		(setq result (format "%s [%d]"
				     (substring linebuf (match-end 0))
				     bar))))))
    (if result
	()
      (re-search-backward glog-regexp-group-line nil t)
      (re-search-forward glog-regexp-group-line nil t))
    (set-buffer cbuf)
    result))

(defun glog-Group-get-next-group-name (&optional unread)
  ;; groupobt@Ŏsubject̖O𓾂
  (let ((cbuf (current-buffer))(result nil))
    (if (glog-set-buffer glog-Group-buffer)
	(progn
	  (save-excursion
	    (setq result (glog-Group-next-group unread)))
	  (set-buffer cbuf)))
    result))

(defun glog-Group-update-group (group &optional visible-only)
  ;; Update newsgroup info of GROUP.
  ;; If optional argument VISIBLE-ONLY is non-nil, non displayed group
  ;; is ignored.
  (let ((cbuf (current-buffer))(count 0))
    (if (glog-set-buffer glog-Group-buffer)
	(save-excursion
	  (goto-char (point-min))
	  (if (re-search-forward
	       (concat "^.+:." (regexp-quote group) "$") nil t)
	      (progn
		;; delete old line
		(setq buffer-read-only nil)
		(delete-region (match-beginning 0) (match-end 0))
		;; write new line
		(insert (format "%7d: %s"
				(glog-Group-count-unread-subject group)
				group))
		(setq buffer-read-only t)
		(set-buffer-modified-p nil))))
      (beginning-of-line)
      (re-search-forward glog-regexp-group-line nil t))
    (set-buffer cbuf)))

(defun glog-Group-post ()
  "Function of GLOG. Set post buffer."
  (interactive)
  (glog-post))

(defun glog-Group-unsubscribe-current-group (&optional group)
  "\{[ho^"
  (interactive)
  (glog-add-purge-subject-list (if group glog-current-subject group)))

(defun glog-Group-unsubscribe-group (&optional str)
  "\{[ho^"
  (interactive)
  (glog-add-purge-subject-list str))

(defun glog-Group-force-update (&optional fname)
  "Function of GLOG. Updating `.logrc'
쒆"
  (interactive)
  (let ((result nil))
    ;;ǂΏÏӎvmF(܂Z[ułȂ)
    (setq result (glog-check-unread-group))
    (if (and (not result)
	     (y-or-n-p "Do you really quit reading log? "))
	(setq result t))
    (message "")
    result))

(defun glog-Group-exit (&optional withoutsave)
  "Function of GLOG. Exit group mode with updating .logrc"
  (interactive)
  (if (if withoutsave
	  t
	;; ǏZ[u
	(glog-Group-force-update))
      ;; obt@NA
      (glog-kill))
  ;; batchNȂEmacsI
  (if (and (boundp 'glog-batch-flag) glog-batch-flag)
      (kill-emacs)))

(defun glog-Group-quit ()
  "Function of GLOG. Exit subject mode without updating read-flag."
  (interactive)
  (if (y-or-n-p "Do you really quit reading log? ")
      (glog-Group-exit t)
    ())
  ;; Erase "Yes or No"
  (message ""))

(defun glog-Group-suspend ()
  "Suspend GLOG."
  (interactive)
  (glog-Group-exit t))

(defun glog-Group-describe-briefly ()
  "Describe Group mode commands briefly."
  (interactive)
  (message
   (concat
    (substitute-command-keys "\\[glog-Group-read-group]:Select  ")
    (substitute-command-keys "\\[glog-Group-next-unread-group]:Forward  ")
    (substitute-command-keys "\\[glog-Group-prev-unread-group]:Backward  ")
    (substitute-command-keys "\\[glog-Group-exit]:Exit  ")
    (substitute-command-keys "\\[glog-Info-find-node]:Run Info  ")
    (substitute-command-keys "\\[glog-Group-describe-briefly]:This help")
    )))

;; Define GLOG Subsystems.
(autoload 'glog-Group-catch-up "glog_utl"
	  "wsubjectǗɐݒ肷" t)
(autoload 'glog-Group-catch-up-all "glog_utl"
	  "SsubjectǗɐݒ肷" t)
(autoload 'glog-Group-save-all-article "glog_utl"
	  "JgTuWFNg̑SĂ̔ۑ" t)
(autoload 'glog-Group-reset-unread-subject "glog_utl"
	  "wsubject̑SL𖢓ǂɍĐݒ" t)
(autoload 'glog-Group-find-regexp "glog_utl"
	  "K\Ŏw肳ꂽŋL, hitgroup\" t)

;;
;;  Subject mode
;;

(defvar glog-Subject-mode-map nil
  "Local key map for Subject mode in GLOG.")

(defun glog-make-Subject-mode-keymap ()
  ;; Make local key map for Subject mode in GLOG.
  (if glog-Subject-mode-map
      ()
    (setq glog-Subject-mode-map (make-keymap))
;;(fillarray  glog-Subject-mode-map 'glog-undefined-key-actions)
  (define-key glog-Subject-mode-map " "    'glog-Subject-next-page)
  (define-key glog-Subject-mode-map "\177" 'glog-Subject-prev-page)
  (define-key glog-Subject-mode-map "\r"   'glog-Subject-next-page)
  (define-key glog-Subject-mode-map "n" 'glog-Subject-next-unread-article)
  (define-key glog-Subject-mode-map "p" 'glog-Subject-prev-unread-article)
  (define-key glog-Subject-mode-map "N" 'glog-Subject-next-article)
  (define-key glog-Subject-mode-map "P" 'glog-Subject-prev-article)
  (define-key glog-Subject-mode-map "\C-n" 'glog-Subject-next-subject)
  (define-key glog-Subject-mode-map "\C-p" 'glog-Subject-prev-subject)
  (define-key glog-Subject-mode-map "\en"  'glog-Subject-next-unread-subject)
  (define-key glog-Subject-mode-map "\ep"  'glog-Subject-prev-unread-subject)
  (define-key glog-Subject-mode-map "."    'glog-Subject-first-unread-article)
  (define-key glog-Subject-mode-map "\C-v" 'glog-Subject-scroll-up)
  (define-key glog-Subject-mode-map "\ev"  'glog-Subject-scroll-down)
  (define-key glog-Subject-mode-map "/" 'isearch-forward)
;;(define-key glog-Subject-mode-map "s"  'glog-Subject-isearch-article)
  (define-key glog-Subject-mode-map "\es"'glog-Subject-search-article-forward)
  (define-key glog-Subject-mode-map "\eS"'glog-Subject-search-article-backward)
  (define-key glog-Subject-mode-map "<" 'glog-Subject-beginning-of-article)
  (define-key glog-Subject-mode-map ">" 'glog-Subject-end-of-article)
  (define-key glog-Subject-mode-map "j"    'glog-Subject-goto-article)
  (define-key glog-Subject-mode-map "J"    'glog-Subject-goto-subject)
  (define-key glog-Subject-mode-map "\C-j" 'glog-Subject-goto-group)
  (define-key glog-Subject-mode-map "l" 'glog-Subject-goto-last-article)
  (define-key glog-Subject-mode-map "^" 'glog-Subject-refer-parent-article)
  (define-key glog-Subject-mode-map "\er" 'glog-Subject-refer-article)
  (define-key glog-Subject-mode-map "u" 'glog-Subject-mark-as-unread-forward)
  (define-key glog-Subject-mode-map "U" 'glog-Subject-mark-as-unread-backward)
  (define-key glog-Subject-mode-map "d" 'glog-Subject-mark-as-read-forward)
  (define-key glog-Subject-mode-map "D" 'glog-Subject-mark-as-read-backward)
  (define-key glog-Subject-mode-map "h" 'glog-Subject-mark-forward)
  (define-key glog-Subject-mode-map "H" 'glog-Subject-mark-backward)
  (define-key glog-Subject-mode-map "\eu" 'glog-Subject-clear-mark-forward)
  (define-key glog-Subject-mode-map "\eU" 'glog-Subject-clear-mark-backward)
  (define-key glog-Subject-mode-map "\e\C-t"    'glog-Subject-toggle-threads)
;;(define-key glog-Subject-mode-map "\e\C-s"    'glog-Subject-show-thread)
;;(define-key glog-Subject-mode-map "\e\C-h"    'glog-Subject-hide-thread)
;;(define-key glog-Subject-mode-map "\e\C-f"    'glog-Subject-next-thread)
;;(define-key glog-Subject-mode-map "\e\C-b"    'glog-Subject-prev-thread)
;;(define-key glog-Subject-mode-map "\e\C-u"    'glog-Subject-up-thread)
;;(define-key glog-Subject-mode-map "\e\C-d"    'glog-Subject-down-thread)
;;(define-key glog-Subject-mode-map "\e\C-k"    'glog-Subject-kill-thread)
  (define-key glog-Subject-mode-map "\C-c\C-sn" 'glog-Subject-sort-by-number)
  (define-key glog-Subject-mode-map "\C-c\C-si" 'glog-Subject-sort-by-id)
  (define-key glog-Subject-mode-map "\C-c\C-sa" 'glog-Subject-sort-by-author)
  (define-key glog-Subject-mode-map "\C-c\C-ss" 'glog-Subject-sort-by-subject)
  (define-key glog-Subject-mode-map "\C-c\C-sd" 'glog-Subject-sort-by-date)
  (define-key glog-Subject-mode-map "\C-c\C-sl" 'glog-Subject-sort-by-lines)
  (define-key glog-Subject-mode-map "=" 'glog-Subject-expand-window)
;;(define-key glog-Subject-mode-map "G" 'glog-Subject-reselect-current-group)
;;(define-key glog-Subject-mode-map "w" 'glog-Subject-stop-page-breaking)
;;(define-key glog-Subject-mode-map "\C-c\C-r" 'glog-Subject-caesar-message)
  (define-key glog-Subject-mode-map "g" 'glog-Subject-show-article)
;;(define-key glog-Subject-mode-map "t" 'glog-Subject-toggle-header)
  (define-key glog-Subject-mode-map "v" 'glog-Subject-show-all-headers)
;;(define-key glog-Subject-mode-map "\C-d" 'glog-Subject-rmail-digest)
  (define-key glog-Subject-mode-map "a" 'glog-Subject-post-news)
  (define-key glog-Subject-mode-map "f" 'glog-Subject-post-reply)
  (define-key glog-Subject-mode-map "F" 'glog-Subject-post-reply-with-original)
;;(define-key glog-Subject-mode-map "C" 'glog-Subject-cancel-article)
  (define-key glog-Subject-mode-map "r" 'glog-Subject-mail-reply)
  (define-key glog-Subject-mode-map "R" 'glog-Subject-mail-reply-with-original)
;;(define-key glog-Subject-mode-map "\C-c\C-f" 'glog-Subject-mail-forward)
;;(define-key glog-Subject-mode-map "m" 'glog-Subject-mail-other-window)
  (define-key glog-Subject-mode-map "o" 'glog-Subject-save-article)
  (define-key glog-Subject-mode-map "O" 'glog-Subject-save-all-article)
  (define-key glog-Subject-mode-map "y" 'glog-Subject-yax-article)
;;(define-key glog-Subject-mode-map "\C-o" 'glog-Subject-save-in-mail)
;;(define-key glog-Subject-mode-map "|" 'glog-Subject-pipe-output)
;;(define-key glog-Subject-mode-map "\ek" 'glog-Subject-edit-local-kill)
;;(define-key glog-Subject-mode-map "\eK" 'glog-Subject-edit-global-kill)
  (define-key glog-Subject-mode-map "\C-ch"    'glog-add-handle-list)
  (define-key glog-Subject-mode-map "\C-c\C-h" 'glog-add-purge-list)
  (define-key glog-Subject-mode-map "\C-cs"    'glog-add-search-regexp-list)
  (define-key glog-Subject-mode-map "\C-cm"    'glog-add-ML-list)
  (define-key glog-Subject-mode-map "\C-co"    'glog-add-savearticle-list)
  (define-key glog-Subject-mode-map "V" 'glog-version)
  (define-key glog-Subject-mode-map "q" 'glog-Subject-exit)
  (define-key glog-Subject-mode-map "\C-xk" 'glog-kill-buffer)
  (define-key glog-Subject-mode-map "\C-w" 'copy-region-as-kill)
  (define-key glog-Subject-mode-map "Q" 'glog-Subject-quit)
  (define-key glog-Subject-mode-map "!" 'glog-pause)
  (define-key glog-Subject-mode-map "?" 'glog-Subject-describe-briefly)
  (define-key glog-Subject-mode-map "\C-c\C-i" 'glog-Info-find-node)
))

(defun glog-Subject-mode ()
  "Function of GLOG. Show subject buffer.
\\{glog-Subject-mode-map}"
  (interactive)
  (set-buffer glog-Subject-buffer)
  (setq buffer-read-only t)
  (buffer-flush-undo (current-buffer))
  (set-buffer-auto-saved)
  (setq major-mode 'glog-Subject-mode)
  (setq mode-name "Subject")
  (setq mode-line-buffer-identification "GLOG:")
  (setq mode-line-process nil)
  (use-local-map glog-Subject-mode-map)
  (setq parse-sexp-ignore-comments t)
  (run-hooks 'glog-Subject-mode-hook))

(defun glog-Subject-set-mode-line ()
  ;; mode-linesubjectZbg
  (let ((cbuf (current-buffer))(title "")(subcons)(art))
    ;; 'glog-current-subject'ŘAzzAΉ锭title擾
    (if (and glog-current-subject glog-current-article
	     (setq subcons (assoc glog-current-subject glog-subject-list))
	     (setq art (assq glog-current-article (cdr subcons)))
	     (setq title (glog-article-info-title art)))
	(setq title (glog-strcut (glog-replace-long-space title) 42)))
    (if (glog-set-buffer glog-Subject-buffer)
	(progn
	  (setq mode-line-buffer-identification (concat "GLOG: " title))
	  (set-buffer cbuf)))))

(defun glog-Subject-show-all-headers (&optional mark-char)
  "Remake title list (unread|read) to subject buffer."
  (interactive)
  (if glog-current-subject
      (glog-Subject-make-subject glog-current-subject mark-char t)))

(defun glog-lessp-subject-by-no (sub1 &optional sub2)
  ;; ԍœ̔r
  (let ((no1 (glog-article-info-no sub1))(no2 (glog-article-info-no sub2)))
    (< no1 no2)))

(defun glog-lessp-subject-by-id (sub1 &optional sub2)
  ;; idœ̔r
  (let ((str1 (glog-article-info-id sub1))(str2 (glog-article-info-id sub2)))
    (if (string-equal str1 str2)
	;; idꍇ͔ԍŔr
	(< (glog-article-info-no sub1) (glog-article-info-no sub2))
      (string-lessp str1 str2))))

(defun glog-lessp-subject-by-author (sub1 &optional sub2)
  ;; Җ(nh)œ̔r
  (let ((foo)(str1)(str2)
	(handlelist
	 (glog-assoc-list glog-bbs-type glog-handle-list (list (list nil)))))
    (setq str1 (if (setq foo (assoc (glog-article-info-id sub1) handlelist))
		   (cdr foo)
		 (if (setq foo (glog-article-info-author sub1))
		     foo
		   (glog-article-info-id sub1))))
    (setq str2 (if (setq foo (assoc (glog-article-info-id sub2) handlelist))
		   (cdr foo)
		 (if (setq foo (glog-article-info-author sub2))
		     foo
		   (glog-article-info-id sub2))))
    (if (string-equal str1 str2)
	;; nhꍇ͔ԍŔr
	(< (glog-article-info-no sub1) (glog-article-info-no sub2))
      (string-lessp str1 str2))))

(defun glog-lessp-subject-by-subject (sub1 &optional sub2)
  ;; ^Cgœ̔r
  (let ((str1 (glog-article-info-title sub1))
	(str2 (glog-article-info-title sub2)))
    (if (string-equal str1 str2)
	;; ^Cgꍇ͔ԍŔr
	(< (glog-article-info-no sub1) (glog-article-info-no sub2))
      (string-lessp str1 str2))))

(defun glog-lessp-subject-by-date (sub1 &optional sub2)
  ;; œ̔r
  (let ((str1 (glog-article-info-date sub1))
	(str2 (glog-article-info-date sub2)))
    (if (string-equal str1 str2)
	;; tꍇ͔ԍŔr
	(< (glog-article-info-no sub1) (glog-article-info-no sub2))
      (string-lessp str1 str2))))

(defun glog-lessp-subject-by-lines (sub1 &optional sub2)
  ;; s̑召œ̔r
  (let ((s1 (glog-article-info-lines sub1))(s2 (glog-article-info-lines sub2)))
    (if (= s1 s2)
	;; sꍇ͔ԍŔr
	(< (glog-article-info-no sub1) (glog-article-info-no sub2))
      (< s1 s2))))

(defun glog-Subject-sort (&optional subject way remake)
  ;; Subject\[g
  (let ((now-subject)(subcons)(subcdr))
    (setq now-subject (or subject glog-current-subject))
    ;; 'subject'ŘAzzAΉyAcdr擾
    (if (setq subcons (assoc now-subject glog-subject-list))
	(progn
	  (setq subcdr (copy-alist (cdr subcons)))
	  (setcdr subcons
		  (sort (copy-alist (cdr subcons))
			(if (or (not way) (eq way t))
			    'glog-lessp-subject-by-no
			  way)))))
    ;; remakenon-nilȂ subjectobt@č쐬
    (if remake (glog-Subject-show-all-headers))))

(defun glog-Subject-sort-by-number ()
  "subject𔭌ԍŃ\[gčĕ\(Ǘmark̓NA܂)"
  (interactive)
  (glog-message "Sort by number.")
  (glog-Subject-sort glog-current-subject 'glog-lessp-subject-by-no t))

(defun glog-Subject-sort-by-id ()
  "subjectidŃ\[gčĕ\(Ǘmark̓NA܂)"
  (interactive)
  (glog-message "Sort by ID.")
  (glog-Subject-sort glog-current-subject 'glog-lessp-subject-by-id t))

(defun glog-Subject-sort-by-author ()
  "subjectnhŃ\[gčĕ\(Ǘmark̓NA܂)"
  (interactive)
  (glog-message "Sort by author.")
  (glog-Subject-sort glog-current-subject 'glog-lessp-subject-by-author t))

(defun glog-Subject-sort-by-subject ()
  "subjectLŃ\[gčĕ\(Ǘmark̓NA܂)"
  (interactive)
  (glog-message "Sort by subject.")
  (glog-Subject-sort glog-current-subject 'glog-lessp-subject-by-subject t))

(defun glog-Subject-sort-by-date ()
  "subjectŃ\[gčĕ\(Ǘmark̓NA܂)"
  (interactive)
  (glog-message "Sort by date.")
  (glog-Subject-sort glog-current-subject 'glog-lessp-subject-by-date t))

(defun glog-Subject-sort-by-lines ()
  "subjectsŃ\[gčĕ\(Ǘmark̓NA܂)"
  (interactive)
  (glog-message "Sort by lines.")
  (glog-Subject-sort glog-current-subject 'glog-lessp-subject-by-lines t))

(defun glog-Subject-toggle-threads ()
  "Rgc[On/Off؂芷čĕ\(Ǘmark̓NA܂)"
  (interactive)
  (let ((mesno (glog-Subject-get-article-no)))
    (glog-toggle-threads)
    (glog-Subject-make-subject glog-current-subject)
    (if mesno (glog-Subject-goto-article mesno))))

(defun glog-Subject-sort-article (subject)
  "Sort articles."
  (let ((lines)(sub))
    ;; subject\[g
    (if (or (null glog-subject-list) (not glog-sort-article))
	;; sortȂ
	()
      ;; ASCII-NetȂtsortȂ(...dȂ)
      (if (and (eq glog-bbs-type 'ascii)
	       (eq glog-sort-article 'glog-lessp-subject-by-date))
	  (setq lines 'glog-lessp-subject-by-no)
	(setq lines glog-sort-article))
      ;; sort
      (if (setq sub (assoc subject glog-subject-list))
	  (glog-Subject-sort (car sub) lines)))))

(defun glog-Subject-write-subject (art)
  ;; internal function of `glog-Subject-make-subject'. Return with article No.
  ;; Use variable's scoop...
  ;;   notice-str   : ʕ\p(default:)
  ;;   namelength   : nhő\
  ;;   comlist      : Rgc[p[Xg
  ;;   threads      : Rgc[̗L
  ;;   org-title    : Rg^Cg
  ;;   unread       : ǃ`FbN
  ;;   mark-char    : Ǖ\(default:D)
  ;;   handlelist   : nhXg
  ;;   purgelist    : \nhXg
  (let ((mesno)(lines)(com-no)(id)(author)(name)(title)
	(notice)(readmark)(disable)(tab) (foo)(bar)
	(kanji-flag)(mc-flag))
    ;; Ǘ}[N`FbN
    (setq readmark (glog-article-info-unread art))
    (if (and (eq ?d readmark) unread)
	(setq mesno nil)
      ;; ǂȂobt@ɒǉ
      (setq mesno  (glog-article-info-no art))
      (setq title  (glog-article-info-title  art))
      (setq id     (glog-article-info-id     art))
      (setq author (glog-article-info-author art))
      (setq lines  (glog-article-info-lines  art))
      (setq com-no (if threads (glog-article-info-comno  art) -1))
      (if (setq foo (assoc id handlelist))  ;; nhXg猟
	  (setq author (cdr foo)))
      ;; ҖID𖼑OƂĕ\
      (setq name (if (> (length author) 0) author id))
      ;; tab
      (if (setq foo (assq com-no comlist))
	  (progn
	    ;; "Re:"菜^CgɂĂ
	    (setq bar (glog-delete-rerere title))
	    ;; RgɑOMSGƓ^Cg̏ꍇ͔\
	    (if (string= bar org-title)
		(setq title ""))
	    ;; indent1i[
	    (setq bar (cdr foo))
	    (if (< (* glog-subject-indent-level (+ 1 bar))
		   (/ (window-width) 2))
		(inc bar))
	    (setq tab (make-string (* glog-subject-indent-level bar) ? )))
	;; RgA؂ꂽ珉
	(setq tab "")
	;; "Re:"菜^CgɂĂ
	(setq org-title (glog-delete-rerere title))
	(setq bar 0))
      ;; AXgɒǉ
      (nconc comlist (list (cons mesno bar)))
      ;; 蕶
      (if (and glog-current-search-regexp
	       (glog-article-search-regexp glog-current-search-regexp mesno))
	  (setq notice t)
	(setq notice nil))
      ;; \idcheck
      (setq disable (assoc id purgelist)) ;; hook̕ԂlƂĂgp
      ;; Ǐ(glog-readed-list)check(INETNEWSΉ:'94.8.15)
      (if (and (setq foo (glog-article-info-mesid art)) ; message-idL
	       (assoc foo glog-readed-list)             ; readed-listɑ
	       unread)                                  ; Stitle\ł͖
	  (progn                                        ;(ĕ\\ '95.5.9)
	    (glog-article-set-unread art ?d)
	    (setq disable t)))                          ;ȏ̏Ȃ\
      ;; hooko^ĂΎs
      (run-hooks 'glog-Subject-make-list-hook)
      ;; \idłȂΓo^
      (if disable
	  (setq mesno nil) ;; \idȂ̂ŕ\Ȃ
	(insert (format "%s  %s%5d: [%3d:%s] %s%s\n"
			(if (eq ?d readmark) mark-char  " ")
			tab mesno lines
			(glog-strcut name namelength 'left)
			(if notice (car notice-str)(cdr notice-str))
			title))
	;; MuleȂ狭ł͂Ȃ`glog-emphasize-match-hook'g '95.5.14
	(if (and notice (boundp 'MULE))
	    (save-excursion
	      (forward-line -1)
	      (beginning-of-line)
	      (re-search-forward "[0-9]+" nil t)
	      (run-hooks 'glog-emphasize-match-hook)))))
    mesno))

(defun glog-Subject-make-subject (now-subject &optional mark-char showall)
  "Subjectobt@Ƀ^CgXg쐬.

ex.  LT[`subject-list𑀍삷
  (setq glog-Subject-make-list-hook
    '(lambda ()
       ;; ^Cg\"ISH\"ƌPꂪoƂ͕\Ȃ
       (if (glog-title-search-regexp \"ISH\" mesno)
           (setq disable t))
     ))"
  (interactive)
  (let ((notice-str (cons "" "  "))(namelength 10)(threads t)
	(comlist (list (cons nil 0)))(clist (list (cons nil 0)))
	(cstack nil)(handlelist)(purgelist)(org-title "")(unread t)
	(i 0)(mc)(mesno)(foo)(bar)(sub nil)(art))
    ;; ǂ0ȂStitle\
    (if (< 0 (glog-Group-count-unread-subject now-subject))
	()
      (setq unread nil)
      (glog-message "No unread article."))
    ;; showalltȂ疳őStitle\
    (if showall (setq unread nil))
    ;; mark-charݒ肳ĂȂ΃ftHg̓Ǘ("D")ݒ
    (if (not mark-char)
	(setq mark-char (glog-mark-char 'readed)))
    ;; nhXgo^Ă
    (setq handlelist
	  (glog-assoc-list glog-bbs-type glog-handle-list (list (list nil))))
    ;; \idXgo^Ă
    (setq purgelist
	  (glog-assoc-list glog-bbs-type glog-purge-id-list (list (list nil))))
    (if showall (setq purgelist (list (list nil))))
    ;; id\̒ݒ肳Ă
    (if (and (boundp 'glog-subject-name-length) (> glog-subject-name-length 4))
	(setq namelength glog-subject-name-length))
    ;; MuleȂ狭͎g킸`glog-emphasize-match-hook'g '95.5.14
    (if (boundp 'MULE) (setq notice-str (cons "" "")))
    ;; 񂪓o^Ă΂g(Muleło^ĂΗD)
    (if (and (boundp 'glog-subject-notice-str) (consp glog-subject-notice-str))
	(setq notice-str glog-subject-notice-str))
    ;; 񃊃Xgo^Ă
    (setq glog-current-search-regexp nil) ;; ܂
    (if (boundp 'glog-search-regexp-list)
	(setq sub (glog-assoc-list glog-bbs-type glog-search-regexp-list)))
    (if (and sub (listp sub))
	(progn
	  (setq foo (glog-assoc-list "all" sub))
	  (setq bar (glog-assoc-list now-subject sub))
	  (if (and foo bar)
	      (setq glog-current-search-regexp
		    (format "\\(%s\\|%s\\)" foo bar))
	    (setq glog-current-search-regexp (or foo bar)))) ; foonilȂbar
      (setq notice-str (cons "" "")))
    ;; Rgc[ɂȂȂ '93.10.10
    (if (and (boundp 'glog-disable-threads) glog-disable-threads)
	(setq threads nil))
    ;; subject-buffer
    (glog-set-subject-buffer)
    ;; now-subjectsubject-listɑ݂, title-list쐬
    (if (and now-subject
	     (setq sub (assoc now-subject glog-subject-list))
	     ;;(> (length (cdr sub)) 0))
	     (cdr sub))
      (progn
	(setq sub (cdr sub))
	;; echosNA
	(if (< (length (cdr sub)) 50)
	    (glog-message "")
	  (glog-message (format "GLOG: %s ..." now-subject)))
	;; current-subjectZbg
	(setq glog-current-subject now-subject)
	;; Subject-bufferNA
	(setq buffer-read-only nil)
	(erase-buffer)
	(setq truncate-lines t)               ; stop line folding
	;; ŏɃRg̘Azz񃊃Xg
	(if threads
	    (while (setq art (nth i sub))
	      ;; \idłȂΓo^
	      (if (not (assoc (glog-article-info-id art) purgelist))
		  (nconc clist (list (cons (glog-article-info-no art)
					   (glog-article-info-comno art)))))
	      (inc i))
	  ;; Rgc[̏ꍇ
	  (while (setq art (nth i sub))
	    ;; \idłȂΓo^
	    (if (not (assoc (glog-article-info-id art) purgelist))
		(nconc clist (list (cons (glog-article-info-no art) -1))))
	    (inc i)))
	;; ŏ̃_~[Z`(nil . 0)'폜
	(if (cdr clist)
	    (setq clist (cdr clist))
	  (setq clist nil))
	;; [vJn
	(while (setq mc (car clist))          ;; \Ȃ܂
	  (if (and (input-pending-p)          ;; `i' Œf
		   (eq (downcase (read-char)) ?i))
	      (setq clist nil))
	  (if (setq i (car cstack))           ;; RgX^bNQ
	      (setq mc (rassq i clist)))      ;; łꍇ́A擾
	  (if (not mc)                        ;; X^bNւ̃Rg
	      (setq cstack (delq i cstack))   ;; ΃X^bN폜
	    (setq clist (delq mc clist))
	    (setq i (car mc))
	    ;;(setq cstack (append (list i) cstack))
	    (setq cstack (nconc (list i) cstack))
	    (setq art (assq i sub))
	    (glog-Subject-write-subject art)
	    ;; Iɐis󋵂񍐂
	    (setq i (length clist))
	    (if (and (= (% i 25) 0) (> i 0))
		(glog-message
		 (format "GLOG: %s [remain %d]" now-subject i)))))
	;; garbage-collect
	(if (> (length (cdr sub)) 100) (garbage-collect))
	;; kill last blank line
	(delete-indentation)
	(setq buffer-read-only t)
	(set-buffer-modified-p nil)
	;; Adjust cursor point.
	(goto-char (point-min))
	(re-search-forward glog-regexp-subject-line nil t)
	(setq glog-current-article -1)
	(sit-for 0)
	;; erase message line
	(glog-message "")))))

(defun glog-Subject-set-point (&optional mesno)
  ;; ݓǂłarticleɑΉsubjects擪pointu.
  ;; mesnow肳Ă, ̋Lԍsubjectsɒu.
  (let ((cbuf (current-buffer))(cpos)(regexp)(res nil) (kanji-flag)(mc-flag))
    (if (set-buffer glog-Subject-buffer)
	(progn
	  (setq cpos (point))  ;; Âpointۑ
	  (goto-char (point-min))
	  (setq regexp
		(concat "^..[ \t]+" (int-to-string
				     (if mesno 
					 mesno
				       glog-current-article)) ":"))
	  (if (re-search-forward regexp nil t)
	      (setq res t)
	    (goto-char cpos)) ;; Ȃ猳ɖ߂
	  (set-buffer cbuf)))
    res))

(defun glog-Subject-set-current-mark (&optional mark-char)
  ;; ݓǂłarticleɑΉsubjectsɃJg}[N(ftHg`+')
  ;; u.  ̍,Oʒũ}[N͍폜.
  (let ((cbuf (current-buffer)) (kanji-flag)(mc-flag))
    (if (set-buffer glog-Subject-buffer)
	(progn
	  (setq buffer-read-only nil)
	  (save-excursion
	    ;; ܂̃}[N폜
	    (goto-char (point-min))
	    (if (re-search-forward "^..[ \t]+[0-9]+\:[^ \t]" nil t)
		(progn
		  (delete-char -1)
		  (insert " ")))
	    ;; current-article̍s܂ňړ
	    (if (glog-Subject-set-point)
		(progn
		  (delete-char 1)
		  (insert (or mark-char "+")))))
	  ;; obt@̌n
	  (setq buffer-read-only t)
	  (set-buffer-modified-p nil)
	  (set-buffer cbuf)))))

(defun glog-Subject-mark-as-read (&optional article mark-char)
  ;; JgarticleɓǗ}[N(ftHg`D')t.
  ;; ŏ̃IvVgarticleԍw肪ł.
  ;; ̃IvVœǗ}[ÑLN^wł.
  (let ((cbuf (current-buffer)))
    (if (set-buffer glog-Subject-buffer)
	(progn
	  (setq buffer-read-only nil)
	  (save-excursion
	    ;; ԍwȂw̔ԍ̍s܂pointړ
	    (if article (glog-Subject-set-point article))
	    ;; ԍw肪΃JgsɓǗ}[N
	    (beginning-of-line)
	    (delete-char 1)
	    (insert (or mark-char (glog-mark-char 'readed))))
	  (setq buffer-read-only t)
	  (set-buffer-modified-p nil)
	  (set-buffer cbuf)))))

(defun glog-Subject-mark-as-read-forward (count)
  "JgarticleɓǗ}[N(`D')tarticleǂ."
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil (glog-mark-char 'readed))
    (glog-Subject-next-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-mark-as-read-backward (count)
  "JgarticleɓǗ}[N(`D')tOarticleǂ."
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil (glog-mark-char 'readed))
    (glog-Subject-prev-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-mark-as-unread-forward (count)
  "Jgarticleɔǃ}[N(`U')tarticleǂ."
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil (glog-mark-char 'unread))
    (glog-Subject-next-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-mark-as-unread-backward (count)
  "Jgarticleɔǃ}[N(`U')tOarticle"
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil (glog-mark-char 'unread))
    (glog-Subject-prev-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-mark-forward (count)
  "JgarticleɃ}[N(`M')tarticle"
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil (glog-mark-char 'mark))
    (glog-Subject-next-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-mark-backward (count)
  "JgarticleɃ}[N(`M')tOarticle"
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil (glog-mark-char 'mark))
    (glog-Subject-prev-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-clear-mark-forward (count)
  "Jgarticlẽ}[NĎarticle"
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil " ")
    (glog-Subject-next-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-clear-mark-backward (count)
  "Jgarticlẽ}[NđOarticle"
  (interactive "p")
  (while (> count 0)
    (glog-Subject-mark-as-read nil " ")
    (glog-Subject-prev-subject 1 nil)
    (setq count (1- count))))

(defun glog-Subject-read-subject ()
  "Function of GLOG. Show article buffer."
  (interactive)
  (glog-configure-windows 'SelectArticle glog-Subject-buffer)
  (glog-Subject-show-page))

(defun glog-Subject-get-article-no ()
  "Function of GLOG. Get article number. (G[̎nilԂ.)"
  (interactive)
  (let ((cbuf (current-buffer))(linebuf)(result nil))
    (if (glog-set-buffer glog-Subject-buffer)
	(progn
	  (setq linebuf (glog-get-current-line))
	  (if (string-match "[0-9]+" linebuf)
	      (setq result (string-to-int
			    (substring linebuf (match-beginning 0)))))
	  (set-buffer cbuf)))
    result))

(defun glog-Subject-show-page (&optional oldmes)
  "Subjectobt@point`+'̈ʒu̔̓eArticleobt@ɕ\.
ɕ\ĂΉȂ."
  (interactive)
  (let (mesno)
    (if (setq mesno (glog-Subject-get-article-no))
	;; O񔭌ԍ^ĂΓۂ`FbN
	(if (and oldmes (= oldmes mesno))
	    ;; O񔭌ԍ^ĂĊԍȂĕ\Ȃ
	    nil
	  (glog-Article-show-article mesno)
	  nil))))

(defun glog-Subject-next-article (unread &optional subject)
  "Show next article."
  (interactive "P")
  (let ((c)(key)(keystr)(nextsubject))
    (if (get-buffer-window glog-Subject-buffer)
	;; ŌarticlełȂ
	(if (glog-Subject-next-subject 0 unread)
	    ;; article\
	    (glog-Subject-show-page glog-current-article)
	  ;; Ōarticlȅꍇ
	  (if (eq glog-auto-select-next 'quietly)
	      ;; ǖك[h
	      (glog-Subject-exit-and-next unread)
	    ;; subject֍sۂq˂
	    (setq nextsubject (glog-replace-long-space
			       (glog-Group-get-next-group-name unread)))
	    (setq key (downcase last-input-char))
	    (setq keystr (if (eq key 32) "SPC" (char-to-string key)))
	    (message "No more%s articles %s"
		     (if unread " unread" "")
		     (if (and glog-auto-select-next nextsubject)
			 ;; auto-select-nextnon-nil̏ꍇ
			 (concat "(Type [" keystr "] to " nextsubject ")")
		       ;; auto-select-nextnilȂ
		       (concat "(Type [" keystr "] to exit.)")))
	    (setq c (downcase (read-char)))
	    (cond ((eq c key)
		   (if (and glog-auto-select-next nextsubject)
		       (glog-Subject-exit-and-next unread)
		     (glog-Subject-exit)))
		  ((eq c ?q)
		   (glog-Subject-exit))
		  (t ()))))
      ;; subject-buffer\ĂȂΕ\
      (glog-Subject-show-article))))

(defun glog-Subject-next-unread-article (&optional subject)
  "Show next article."
  (interactive "P")
  (glog-Subject-next-article t subject))

(defun glog-Subject-prev-article (unread &optional subject)
  "Show prev article."
  (interactive "P")
  (if (glog-Subject-show-article)
      ;; article-buffer\Ă
      (if (glog-Subject-prev-subject 0 unread)
	  ;; Oarticle\
	  (glog-Subject-show-page glog-current-article)
	;; ŏarticlȅꍇ
	(glog-message "No article before."))))

(defun glog-Subject-prev-unread-article (&optional subject)
  "Show next article."
  (interactive "P")
  (glog-Subject-prev-article t subject))

(defun glog-Subject-next-page (&optional unread)
  "Function of GLOG. Show article buffer."
  (interactive)
  (let ((mesno)(c)(key)(keystr)(nextsubject))
    ;; x\Ėꍇerror-trap
    (if (not glog-current-article) (setq glog-current-article -1))
    (if (or
	 ;; ݕ\articleԍ擾łȂΏI
	 (not (setq mesno (glog-Subject-get-article-no)))
	 ;; article-buffer\ďI
	 (not (glog-Subject-show-article)))
	nil
      ;; ݕ\Ăẽ`FbN
      (if (/= mesno glog-current-article)
	  ;; ݕ\ĂesubjectƈvȂ΂article\
	  (glog-Article-show-article mesno)
	;; ݕ\ĂearticleȂscroll
	(if (glog-Article-next-page)
	    ()
	  ;; article-bufferscrollɎs->article
	  (if (glog-Subject-next-subject 0)
	      ;; article\
	      (glog-Subject-show-page glog-current-article)
	    ;; Ōarticlȅꍇ
	    (if (eq glog-auto-select-next 'quietly)
		;; ǖك[hȂ炻̂܂܎subject
		(glog-Subject-exit-and-next unread)
	      (setq nextsubject (glog-replace-long-space
				 (glog-Group-get-next-group-name unread)))
	      (setq key last-input-char)
	      (setq keystr (if (eq key 32) "SPC" (char-to-string key)))
	      (message "No more articles %s"
		       (if (and glog-auto-select-next nextsubject)
			   ;; auto-select-nextnon-nil̏ꍇ
			   (concat "(Type [" keystr "] to " nextsubject ")")
			 ;; auto-select-nextnilȂ
			 (concat "(Type [" keystr "] to exit.)")))
	      ;; L[͑҂
	      (setq c (downcase (read-char)))
	      (cond ((eq c key)
		     (if (and glog-auto-select-next nextsubject)
			 (glog-Subject-exit-and-next unread)
		       (glog-Subject-exit)))
		    ((eq c ?q)
		     (glog-Subject-exit))
		    (t ())))))))))

(defun glog-Subject-prev-page ()
  "articleOy[W֖߂"
  (interactive)
  (let (mesno)
    ;; x\Ėꍇerror-trap
    (if (not glog-current-article) (setq glog-current-article -1))
    (if (or
	 ;; ݕ\articleԍ擾łȂΏI
	 (not (setq mesno (glog-Subject-get-article-no)))
	 ;; article-buffer\ďI
	 (not (glog-Subject-show-article)))
	nil
      (if (/= mesno glog-current-article)
	  ;; ݕ\ĂesubjectƈvȂ΂article\
	  (glog-Article-show-article mesno)
	;; ݕ\ĂearticleȂscroll
	(if (glog-Article-prev-page)
	    ()
	  ;; article-bufferscrollɎs->Oarticle
	  (glog-Subject-prev-subject 0)
	  (glog-Subject-show-page glog-current-article))))))

(defun glog-Subject-search-subject (backward unread subject)
  ;; (subject鉺֐)
  (let ((cbuf (current-buffer))(cptr)(regexp)(result nil)
	(kanji-flag)(mc-flag))
    ;; ǂT[`邩ۂŌpݒ
    (setq regexp (if unread "^ .[ \t]+[0-9]+:" "^.[ \t]+[0-9]+:"))
    (if (glog-set-buffer glog-Subject-buffer)
	(progn
	  (setq cptr (point))
	  (beginning-of-line)
	  (setq result
		(if backward
		    (re-search-backward regexp nil t)
		  ;; QƂ̏ꍇ͈s
		  (forward-line)
		  (re-search-forward regexp nil t)))
	  (if (not result)	;; ɎspointړȂ
	      (goto-char cptr)
	    (if backward	;; OQƂ̎̓J[\":"̌
		(goto-char (match-end 0))))
	  (set-buffer cbuf)))
    result))

(defun glog-Subject-search-forward (&optional unread subject)
  ;; subject
  (glog-Subject-search-subject nil unread subject))

(defun glog-Subject-search-backward (&optional unread subject)
  ;; subjectO
  (glog-Subject-search-subject t unread subject))

(defun glog-Subject-next-subject (n &optional unread)
  "subjectobt@Ŏ̖Ǖֈړ(point̍sɈړ)"
  (interactive "p")
  (while (and (> n 1) (glog-Subject-search-forward unread))
    (setq n (- n 1)))
  (cond ((glog-Subject-search-forward unread)
	 (progn
	   (glog-Subject-recenter)
	   t))
	(t nil)))

(defun glog-Subject-next-unread-subject (n)
  "subjectobt@N̖Ǖֈړ(point̍sɈړ)"
  (interactive "p")
  (glog-Subject-next-subject n t))


(defun glog-Subject-prev-subject (n &optional unread)
  "subjectobt@Ŗǂt(pointO̍sɈړ)"
  (interactive "p")
  (while (and (> n 1) (glog-Subject-search-backward unread))
    (setq n (- n 1)))
  (cond ((glog-Subject-search-backward unread)
	 (glog-Subject-recenter))
	(unread
	 (glog-message "No more unread articles"))
	(t
	 (glog-message "No more articles"))
	))

(defun glog-Subject-prev-unread-subject (n)
  "subjectobt@N̖ǂt(pointO̍sɈړ)"
  (interactive "p")
  (glog-Subject-prev-subject n t))

(defun glog-Subject-recenter ()
  ;; subjectobt@ŃJg|CgSɂ悤ɂ.
  (let ((cbuf (current-buffer)))
    (if (glog-set-buffer glog-Subject-buffer)
	(progn
	  (if glog-auto-center-subject
	      (recenter (/ (- (window-height) 2) 2)))
	  (set-buffer cbuf)))))

(defun glog-Subject-scroll-up (lines)
  (interactive "p")
  (let ((cwin (selected-window)))
    (if (select-window (get-buffer-window glog-Subject-buffer))
	(progn
	  (condition-case ()
	      (scroll-up (if (> lines 1) lines (window-height)))
	    (error ()))
	  (select-window cwin)))))

(defun glog-Subject-scroll-down (lines)
  (interactive "p")
  (let ((cwin (selected-window)))
    (if (select-window (get-buffer-window glog-Subject-buffer))
	(progn
	  (condition-case ()
	      (scroll-down (if (> lines 1) lines (window-height)))
	    (error ()))
	  (select-window cwin)))))

(defun glog-Subject-first-unread-article ()
  (interactive)
  (let (mesno)
    (glog-Subject-show-article)
    (set-buffer glog-Subject-buffer) ;; glog-Subject-show-article
    (goto-char (point-min))
    (if (setq mesno (glog-Subject-get-article-no))
	(glog-Article-show-article mesno))))

(defun glog-get-search-regexp (&optional backward subject)
  ;; ͂. ͂ꂽԂ.
  (let ((regexp nil)(sub nil)(str)
	(kanji-flag t)(mc-flag t)) ;; ȂSubjectobt@
    ;; ܂{[hXgČ𓾂
    (if (boundp 'glog-search-regexp-list)
	(setq sub (glog-assoc-list glog-bbs-type glog-search-regexp-list)))
    (if (and sub (listp sub))
	(setq regexp (glog-assoc-list (or subject "all") sub)))
    ;; glog-last-search-regexpݒ肳Ă΁AD
    (if (and (boundp 'glog-last-search-regexp) glog-last-search-regexp)
	(setq regexp glog-last-search-regexp))
    ;; 
    (setq str (read-string
	       (concat "Search "
		       (if backward "backward" "forward")
		       "(regexp): "
		       (if regexp (concat "(default " regexp ") ")))))
    (if (string-equal str "")
	(setq str regexp))
    str))

(defun glog-Subject-search-article (regexp &optional backward unread)
  (let ((cbuf (current-buffer))(cwin)(mesno)(search-func)(goto-func)(p nil)
	(found nil)(count 0) (kanji-flag)(mc-flag))
    (if (not (and glog-current-article glog-current-subject
		  (get-buffer glog-Subject-buffer)))
	;; subject-bufferERROR
	(glog-message "I can't find subject-buffer")
      ;; ֐o^
      (if backward
	  (progn
	    (setq search-func (function re-search-backward))
	    (setq goto-func   (function glog-Subject-search-backward)))
	(setq search-func (function re-search-forward))
	(setq goto-func   (function glog-Subject-search-forward)))
      ;; Jnԍ
      (setq mesno glog-current-article)
      ;; 񂪗^ĂȂΓ
      (if (not regexp)
	  (setq regexp (glog-get-search-regexp backward glog-current-subject)))
      ;; 񂪓͂ĂΌJn
      (if regexp
	  (progn
	    (setq glog-last-search-regexp regexp)
	    ;; ܂Jgarticlecheck
	    (if (and (get-buffer glog-Article-buffer)   ;; article-bufferL
		     (set-buffer glog-Article-buffer))  ;; łꍇ
		(progn
		  (if backward (beginning-of-line))
		  (if (setq found (funcall search-func regexp nil t))
		      (setq p (point)))))
	    ;; ArticleɖAsubjectɃT[`
	    (if found
		()
	      (set-buffer glog-Subject-buffer)
	      (save-excursion
		;; glog-current-article܂ňړ
		(glog-Subject-set-point)
		;; [v
		(while (and (not found)
			    (funcall goto-func unread))
		  (setq mesno (glog-Subject-get-article-no))
		  (setq found (glog-article-search-regexp regexp mesno))
		  (inc count)
		  (if (= (% count 10) 0)
		      (glog-message (format "Searching [%d]" mesno))))))))
      ;; ʂ?
      (if (not found)
	  (glog-message (format "Search failed: \"%s\"" regexp))
	;; 
	;; ܂article-bufferĕ\
	(if (or (not (get-buffer-window glog-Article-buffer))
		(not (eq mesno glog-current-article)))
	    (glog-Subject-goto-article mesno))
	;; Ɍpointړ
	(setq cwin (selected-window))
	(unwind-protect
	    (progn
	      (set-buffer glog-Article-buffer)
	      (select-window (get-buffer-window glog-Article-buffer))
	      (if p
		  (goto-char p)
		(goto-char (if backward (point-max) (point-min)))
		(funcall search-func regexp nil t))
	      (recenter 2))
	  (select-window cwin))
	(setq glog-current-article mesno)
	(glog-Subject-set-current-mark)
	(glog-Subject-set-point)
	(glog-message "Found!")))
    (set-buffer cbuf)
    found))

(defun glog-Subject-search-article-forward (&optional regexp unread)
  "LO"
  (interactive)
  (glog-Subject-search-article regexp nil unread))

(defun glog-Subject-search-article-backward (&optional regexp unread)
  "L"
  (interactive)
  (glog-Subject-search-article regexp t unread))

(defun glog-Subject-beginning-of-article ()
  "article̕\ʒuŏ"
  (interactive)
  (let ((cwin (selected-window)))
    (if (select-window (get-buffer-window glog-Article-buffer))
	(progn
	  (goto-char (point-min))
	  (set-window-start (selected-window) (point))
	  (select-window cwin)))))

(defun glog-Subject-end-of-article ()
  "article̕\ʒuŌ"
  (interactive)
  (let ((cwin (selected-window))(height))
    (if (select-window (get-buffer-window glog-Article-buffer))
	(progn
	  (setq height (window-height (selected-window)))
	  (goto-char (point-max))
	  (condition-case ()
	      (forward-line (- 1 height))
	    (error ()))
	  (set-window-start (selected-window) (point))
	  (select-window cwin)))))

(defun glog-Subject-goto-article (mesno)
  "Function of GLOG. Go to article."
  (interactive "nArticle number: ")
  (if (glog-Subject-set-point mesno)
      (glog-Article-show-article mesno)
    (glog-message (format "Can't find [%d]" mesno))))

(defun glog-Subject-completing-read-subject (&optional org)
  ;; ^Cg̕⊮L
  (let ((sub)(art)(count 0)(sublist (list (cons nil 0))))
    (if (and glog-subject-list glog-current-subject)
	(progn
	  (setq sub (cdr (assoc glog-current-subject glog-subject-list)))
	  (while (setq art (nth count sub))
	    (nconc sublist (list (cons (glog-article-info-title art) count)))
	    (inc count))
	  ;; ŏ̃_~[Z`(nil . 0)'폜
	  (if (cdr sublist)
	      (setq sublist (cdr sublist))
	    (setq sublist nil))
	  (completing-read "Subject string: " sublist nil t org)))))

(defun glog-Subject-goto-subject (&optional subject)
  "Function of GLOG. Go to subject."
  (interactive)
  (let ((linebuf)(mesno))
    (if (not subject)
	(setq subject (glog-Subject-completing-read-subject)))
    (if (glog-set-buffer glog-Subject-buffer)
	(progn
	  (goto-char (point-min))
	  (if (not (re-search-forward
		    (format "^..[ \t]+[0-9]+:.\\[.+\\].+%s"
			    (regexp-quote subject))
		    nil t))
	      (glog-message (format "Can't find [%s]" subject))
	    (setq linebuf (glog-get-current-line))
	    (string-match "[0-9]+" linebuf)
	    (setq mesno (string-to-int
			 (substring linebuf (match-beginning 0))))
	    (glog-Article-show-article mesno))))))

(defun glog-Subject-goto-group (&optional group)
  "Function of GLOG. Go to group."
  (interactive)
  (if (not group)
      (setq group (glog-Group-completing-read-group)))
  (glog-Group-read-group group))

(defun glog-Subject-goto-last-article ()
  "Go to last subject line."
  (interactive)
  (let (mesno)
    (glog-Subject-show-article)
    (set-buffer glog-Subject-buffer)
    (goto-char (point-max))
    (re-search-backward "^ ..[ \t]+[0-9]+:" nil t)
    (if (setq mesno (glog-Subject-get-article-no))
	(glog-Article-show-article mesno))))

(defun glog-Subject-refer-parent-article ()
  "쒆"
  (interactive)
  (ding))

(defun glog-Subject-refer-article ()
  "쒆"
  (interactive)
  (ding))

(defun glog-Subject-expand-window ()
  "subject-buffer̕\g"
  (interactive)
  (glog-configure-windows 'ExpandSubject glog-Subject-buffer))

(defun glog-Subject-show-article ()
  "ArticleBuffer\ĖΉʂ𕪊\"
  (interactive)
  (if (get-buffer-window glog-Article-buffer)
      t
    (glog-configure-windows 'SelectArticle glog-Subject-buffer)
    (glog-Subject-show-page)
    nil))

(defun glog-Subject-count-unread-article ()
  ;; Jgsubject-buffer̖ǐ𒲂ׂ.
  (let ((cbuf (current-buffer))(count 0) (kanji-flag)(mc-flag))
    (if (glog-set-buffer glog-Subject-buffer)
	(progn
	  (save-excursion
	    (goto-char (point-min))
	    ;; bufferœǗ}[N̖article𐔂.
	    (while (re-search-forward "^[ \t]+[0-9]+:" nil t)
	      (inc count)))
	  (set-buffer cbuf)))
    count))

(defun glog-Subject-update-unread-articles (&optional mark-char)
  ;; Jgsubject̓Ǘ}[N`FbNglog-subject-listɔf.
  (let ((cbuf (current-buffer))(linebuf)(sub)(art)(art-no)(regexp)(foo)
	(kanji-flag)(mc-flag))
    ;; subjectŘAzzAΉsubject-list(=yAcdr)擾
    (setq sub (cdr (assoc glog-current-subject glog-subject-list)))
    (if (and sub (set-buffer glog-Subject-buffer))
	(progn
	  ;; Ǘ}[NTăXgɔf
	  (setq regexp
		(concat "^[^ " (glog-mark-char 'unread) "].[ \t]+[0-9]+:"))
	  (goto-char (point-min))
	  ;; echosNA
	  (if (< (length sub) 100)
	      (glog-message "")
	    (glog-message "GLOG: updating data..."))
	  ;; Jn
	  (while (re-search-forward regexp nil t)
	    (setq linebuf (glog-get-current-line))
	    (setq art-no
		  (if (string-match "[0-9]+:" linebuf)
		      (string-to-int (substring linebuf (match-beginning 0)))
		    -1))
	    ;; ԍɑΉLAzzŌ
	    (if (setq art (assq art-no sub))
		(progn
		  ;; XgɓǗ}[Nt
		  (glog-article-set-unread art ?d)
		  ;; Message-IDLglog-readed-listɒǉ(INETp:'94.8.15)
		  (if (setq foo (glog-article-info-mesid art))
		      (if glog-readed-list
			  (nconc glog-readed-list (list (list foo)))
			;; listnilȂlist쐬
			(setq glog-readed-list (list (list foo))))))))
	  (glog-message "")
	  (set-buffer cbuf)
	  t)
      nil)))

(defun glog-Subject-save-and-exit (&optional withoutsave)
  ;; Function of GLOG. Exit subject mode with updating read-flag.
  (if (or withoutsave (not glog-current-subject))
      ()
    (glog-Subject-update-unread-articles)           ;; ǏZ[u
    (glog-Group-update-group glog-current-subject)) ;; O[vobt@XV
  ;; subject,articleobt@NA
  (glog-erase-buffer glog-Subject-buffer)
  (glog-erase-buffer glog-Article-buffer)
  ;; 
  (setq glog-save-file-name nil)
  (setq glog-current-subject nil)
  (setq glog-current-article nil))

(defun glog-Subject-exit-and-next (&optional unread)
  ;; ݂subjectZ[uĎsubject
  (if (glog-Group-get-next-group-name unread)
      (progn
	(glog-Subject-save-and-exit nil)
	(glog-Group-next-group unread)
	(glog-Group-read-group))
    (glog-Subject-exit)))

(defun glog-Subject-exit (&optional withoutsave)
  "Function of GLOG. Exit subject mode with updating read-flag."
  (interactive)
  (glog-Subject-save-and-exit withoutsave)
  ;; ̃O[v
  (glog-configure-windows 'ExitNewsgroup glog-Group-buffer)
  (select-window (get-buffer-window glog-Group-buffer))
  (glog-Group-next-group))

(defun glog-Subject-quit ()
  "Function of GLOG. Exit subject mode without updating read-flag."
  (interactive)
  (if (y-or-n-p "Do you really quit reading this subject? ")
      (glog-Subject-exit t)
    ())
  ;; Erase "Yes or No"
  (message ""))


(defun glog-Subject-post (&optional mode reply titleon)
  ;; Function of GLOG. Set post buffer.
  ;; mesno,title,id,author,com-no,date̓XR[vƂĉʊ֐Ŏgp.
  (let ((mesno)(title)(id)(author)(com-no)(date)(mesid)(kind)(replyto)(idate))
    (glog-Subject-show-page glog-current-article)
    ;; 擪ɌL̃^Cgǉ
    (if (and reply (setq mesno glog-current-article))
	    ;; ݕ\articleԍ擾ł
	    ;; ԍɑΉLAzzŌ
	    (glog-search-article-data mesno))
    (if (not titleon) (setq title nil))
    (glog-Post-set-post-buffer mode reply)))

(defun glog-Subject-post-news ()
  "Function of GLOG. Set post buffer."
  (interactive)
  (glog-Subject-post 'article nil))

(defun glog-Subject-post-reply ()
  "Function of GLOG. Set post buffer."
  (interactive)
  (glog-Subject-post 'article 'reply t))

(defun glog-Subject-post-reply-with-original ()
  "Function of GLOG. Set post buffer."
  (interactive)
  (glog-Subject-post 'article 'with-original t))

(defun glog-Subject-mail-reply ()
  "Function of GLOG. Set post buffer."
  (interactive)
  (glog-Subject-post 'mail 'reply t))

(defun glog-Subject-mail-reply-with-original ()
  "Function of GLOG. Set post buffer."
  (interactive)
  (glog-Subject-post 'mail 'with-original t))

(defun glog-Subject-make-marklist (&optional markchar)
  ;; SubjectBuffermarkꂽLALԍ̃XgԂ.
  ;; marknilԂ.
  (let ((cbuf (current-buffer))(result nil)(mlist (list nil))
	(search-regexp)(foo)(no) (kanji-flag)(mc-flag))
    (if (glog-set-buffer glog-Subject-buffer)
	(progn
	  ;; Jn
	  (save-excursion
	    (goto-char (point-min))
	    ;; }[NꂽL̔ԍT[`ăXg
	    (setq search-regexp (format "^%s.[ \t]+" (or markchar "M")))
	    (while (re-search-forward search-regexp nil t)
	      (setq foo (glog-get-current-line))
	      (if (not (string-match "[0-9]+:" foo))
		  ()
		(setq no (string-to-int (substring foo (match-beginning 0))))
		(nconc mlist (list no)))))
	  (if (> (length mlist) 1)
	      (setq result (cdr mlist)))
	  (set-buffer cbuf)))
    result))

(defun glog-Subject-clear-marks (&optional markchar)
  ;; SubjectBuffermarkǗt.
  (let ((cbuf (current-buffer))(search-regexp) (kanji-flag)(mc-flag))
    (if (glog-set-buffer glog-Subject-buffer)
	;; Jn
	(progn
	  (setq buffer-read-only nil)
	  (save-excursion
	    (goto-char (point-min))
	    ;; }[NꂽL̔ԍT[`ăXg
	    (setq search-regexp (format "^%s.[ \t]+" (or markchar "M")))
	    (while (re-search-forward search-regexp nil t)
	      (beginning-of-line)
	      (delete-char 1)
	      (insert (glog-mark-char 'readed)) ;; s"D"t
	      (end-of-line)))
	  (setq buffer-read-only t)))
    (set-buffer cbuf)))

(defun glog-Subject-save-article (&optional filename batchflag)
  "Function of GLOG. Save Article to file.
Z[u̍ۂ`glog-Subject-save-article-hook'ĂԂ̂,
̒`wb_:header',`:page',`tb^:footer'ύXł܂.
ex.
  \"- sscience.vZSƎZ@ -\" ĂȊ̃wb_t
  (setq glog-Subject-save-article-hook
    '(lambda ()
      (setq outflag nil)  ;; ܂W`̃wb_}~
      (if glog-current-subject
	  (setq header (format \"- %s -\\n\" glog-current-subject)))
      (setq page \"==\n\")
     ))"
  (interactive)
  (let ((cbuf (current-buffer))(header "")(page "\n\n")(footer "")(outflag t)
	(count 0)(marklist)(sub)(mesno)(art)(pos)(posend)(lines)
	(foo)(bar)(rs)(re))
    ;; ܂}[N邩ۂׂ
    (setq marklist (glog-Subject-make-marklist (glog-mark-char 'mark)))
    ;; batchflag  t Ȃ}[N͖
    (if batchflag (setq marklist nil))
    ;; }[N batchflag  nil ȂJg̋Lĕ\
    (if (and (not marklist)(not batchflag))
	(glog-Subject-show-page glog-current-article))
    ;; Z[uXgo^ĂΌăftHg '95.5.9
    (setq foo (glog-assoc-list glog-bbs-type
			       glog-savearticle-list (list (list nil))))
    (if (and (setq bar (assoc glog-current-subject foo))
	     (not glog-save-file-name))	;; ɃftHgLΏ㏑Ȃ
	(setq glog-save-file-name (cdr bar)))
    ;; Z[u
    (setq glog-save-file-name (if filename
				  ;; t@Cw肳ĂΓ͂Ȃ
				  (expand-file-name filename)
				;; t@C̓͗v
				(glog-require-file-name
				 "Save file name" glog-save-file-name
				 glog-save-directory nil nil)))
    ;; run save article hook
    (run-hooks 'glog-Subject-save-article-hook)
    ;; append
    (glog-set-article-buffer)
    (setq buffer-read-only nil)
    ;; }[NȂobt@NA
    (if marklist (erase-buffer))
    ;; 'glog-current-subject'ŘAzzAΉyAcdr擾
    (setq foo (assoc glog-current-subject glog-subject-list))
    (setq sub (cdr foo))
    (save-excursion
      (goto-char (point-min))
      (insert header)			;; wb_}
      (if (and outflag (not marklist))  ;; GLOGWwb_t(PƂ̏ꍇ)
	  (progn
	    (setq lines (count-lines (point-min)(point-max)))
	    (insert (format "- %s: %s  (%dL) -\n"
			    glog-bbs-type glog-current-subject lines))))
      (setq rs (point))			;; wb_ʒuL
      ;; }[NꂽLRs[
      (while (setq mesno (nth count marklist))
	(if (setq art (assq mesno sub))	;; vԍ̋L
	    (progn
	      (setq pos   (glog-article-info-pos   art))
	      (setq lines (glog-article-info-lines art))
	      ;; check
	      (if (or (< lines 0) (not (get-buffer glog-refer-buffer)))
		  ()
		(set-buffer glog-refer-buffer)	;; read from refer-buffer
		(save-excursion
		  (goto-char pos)
		  (forward-line lines)
		  (setq posend (point)))
		(set-buffer glog-Article-buffer) ;; write to article-buffer
		(if outflag                     ;; GLOGWwb_t
		    (insert (format "- %s: %s  (%dL) -\n"
				    glog-bbs-type
				    glog-current-subject
				    lines)))
		(insert-buffer-substring glog-refer-buffer pos posend)
		(insert page))))		;; ł}
	  (inc count))
      ;; tb^
      (goto-char (point-max))
      (setq re (point))			;; tb^JnʒuL
      (if (not marklist) (insert page))
      (insert footer)			;; tb^}
      ;; Z[u
      (if (glog-save-buf glog-save-file-name glog-Article-buffer t nil)
	  ;; appendłZ[uJgύX
	  (setq glog-save-directory (file-name-directory glog-save-file-name)))
      ;; }[N΃Jg̋Lĕ\
      (set-buffer glog-Article-buffer)
      (if marklist
	  (progn
	    (glog-Subject-clear-marks (glog-mark-char 'mark))
	    (glog-Article-show-article glog-current-article))
	;; }[N΃wb_/tb^폜
	(delete-region re (point-max))  ;; tb^폜
	(delete-region rs (point-min))) ;; wb_폜
      (setq buffer-read-only t))
    (set-buffer cbuf)))

(defun glog-Subject-describe-briefly ()
  "Describe Subject mode commands briefly."
  (interactive)
  (message
   (concat
    (substitute-command-keys "\\[glog-Subject-next-page]:Select  ")
    (substitute-command-keys "\\[glog-Subject-next-unread-article]:Forward  ")
    (substitute-command-keys "\\[glog-Subject-prev-unread-article]:Backward  ")
    (substitute-command-keys "\\[glog-Subject-exit]:Exit  ")
    (substitute-command-keys "\\[glog-Info-find-node]:Run Info  ")
    (substitute-command-keys "\\[glog-Subject-describe-briefly]:This help")
    )))

;; Define GLOG Subsystems.
(autoload 'glog-Subject-yax-article "glog_utl"
	  "Run `yax' with current Article" t)
(autoload 'glog-Subject-save-all-article "glog_utl"
	  "JgTuWFNg̑SĂ̔ۑ" t)


;;
;;  Article mode
;;

(defvar glog-Article-mode-map nil
  "Keymap for GLOG, in read article mode.")

(defun glog-make-Article-mode-keymap ()
  ;; Make local key map for Article mode in GLOG.
  (if glog-Article-mode-map
      ()
    (setq glog-Article-mode-map (make-keymap))
;;(fillarray  glog-Article-mode-map 'glog-undefined-key-actions)
  (define-key glog-Article-mode-map " "    'glog-Article-next-page)
  (define-key glog-Article-mode-map "\177" 'glog-Article-prev-page)
  (define-key glog-Article-mode-map "r"    'glog-Article-refer-article)
  (define-key glog-Article-mode-map "o"    'glog-Article-pop-article)
  (define-key glog-Article-mode-map "h"    'glog-Article-show-subjects)
  (define-key glog-Article-mode-map "s"    'glog-Article-show-subjects)
  (define-key glog-Article-mode-map "f" 'glog-Subject-post-reply)
  (define-key glog-Article-mode-map "F" 'glog-Subject-post-reply-with-original)
  (define-key glog-Article-mode-map "r" 'glog-Subject-mail-reply)
  (define-key glog-Article-mode-map "R" 'glog-Subject-mail-reply-with-original)
  (define-key glog-Article-mode-map "\C-ch"    'glog-add-handle-list)
  (define-key glog-Article-mode-map "\C-c\C-h" 'glog-add-purge-list)
  (define-key glog-Article-mode-map "\C-cs"    'glog-add-search-regexp-list)
  (define-key glog-Article-mode-map "\C-xk" 'glog-kill-buffer)
  (define-key glog-Article-mode-map "\C-w" 'copy-region-as-kill)
  (define-key glog-Article-mode-map "q"    'glog-Article-exit)
  (define-key glog-Article-mode-map "Q"    'glog-Article-exit)
  (define-key glog-Article-mode-map "!"    'glog-pause)
  (define-key glog-Article-mode-map "?"    'glog-Article-describe-briefly)
  (define-key glog-Article-mode-map "\C-c\C-i" 'glog-Info-find-node)
))

(defun glog-Article-mode ()
  "Function of GLOG.
\\{glog-Article-mode-map}"
  (interactive)
  (set-buffer glog-Article-buffer)
  (buffer-flush-undo (current-buffer))
  (set-buffer-auto-saved)
  (setq buffer-read-only t)
  (setq major-mode 'glog-Article-mode)
  (setq mode-name "Article")
  (setq mode-line-buffer-identification "GLOG:")
  (setq mode-line-process nil)
  (use-local-map glog-Article-mode-map)
  (setq parse-sexp-ignore-comments t)
  ;; hookΎs
  (run-hooks 'glog-Article-mode-hook))

(defun glog-Article-set-mode-line ()
  ;; article-buffermode-lineɏݒ
  (let ((cbuf (current-buffer))(subject ""))
    (if (glog-set-buffer glog-Article-buffer)
	(progn
	  (if glog-current-subject
	      (setq subject (glog-strcut glog-current-subject 30)))
	  (setq mode-line-buffer-identification
		(format "GLOG: %s{%d} %s"
			subject
			(glog-Subject-get-article-no)
			(format "%d more"
				(glog-Subject-count-unread-article))))
	  (set-buffer cbuf)))))

(defun glog-Article-show-article (mesno)
  "Function of GLOG. ԍvarticle-bufferɕ\."
  (interactive)
  (let ((cbuf (current-buffer))(sub)(art)(pos)(posend)(hlines)(lines -1)(i 0))
    ;; 'glog-current-subject'ŘAzzAΉyAcdr擾
    (setq sub (cdr (assoc glog-current-subject glog-subject-list)))
    ;; v锭ԍarticleAzzŌ
    (if (and sub (/= mesno -1))  ;; "="΍
	(if (not (setq art (assq mesno sub)))
	    (message "Error: show-article, can't find %d" mesno)
	  (setq pos   (glog-article-info-pos   art))
	  (setq lines (glog-article-info-lines art))
	  (setq hlines (glog-article-info-headlines art))))
    ;; check
    (if (or (< lines 0) (not (glog-set-buffer glog-refer-buffer)))
	nil
      ;; read from refer-buffer
      (save-excursion
	(goto-char pos)
	(forward-line lines)
	(setq posend (point)))
      ;; write to article-buffer
      (glog-set-article-buffer)
      (setq mode-name "Article")
      (setq buffer-read-only nil)
      (erase-buffer)
      (insert-buffer-substring glog-refer-buffer pos posend)
      ;; 񂪂΋\(*Mulê*)
      (if (and glog-current-search-regexp (boundp 'MULE))
	  (progn
	    (goto-char (point-min))
	    (while (re-search-forward glog-current-search-regexp nil t)
	      (run-hooks 'glog-emphasize-match-hook))))
      ;; set readonly
      (setq buffer-read-only t)
      (set-buffer-modified-p nil)
      (goto-char (point-min))
      ;; Jgarticleԍo
      (setq glog-current-article mesno)
      ;; pointmesnőLs
      (glog-Subject-set-point)
      ;; ݂subjectɃJg}[Nt
      (glog-Subject-set-current-mark)
      ;; ݂subjectɓǗ}[N
      (glog-Subject-mark-as-read mesno)
      ;; ArticleBuffer\ĖΉʂ𕪊\
      (if (not (get-buffer-window glog-Article-buffer))
	  (glog-configure-windows 'SelectArticle glog-Subject-buffer))
      ;; [hCXV
      (glog-Subject-set-mode-line)
      (glog-Article-set-mode-line)
      ;; \␳(wb_\s΂ĕ\Jn) '95.3.28
      (glog-set-article-buffer)
      (if (and glog-hide-headers
	       hlines (> hlines 0))
	  (progn
	    (goto-char (point-min))
	    (forward-line hlines)
	    (set-window-start
	     (get-buffer-window glog-Article-buffer) (point))))
      ;; BBS̕\␳֐s  '94.10.16
      (glog-correct-article)
      (run-hooks 'glog-show-article-hook)
      ;; JgA
      (set-buffer cbuf)
      t)))

(defun glog-Article-next-page ()
  "Function of GLOG. Page up article buffer."
  (interactive)
  (let ((posold)(posnew)(cwin (selected-window))(twin))
    (if (setq twin (get-buffer-window glog-Article-buffer))
	(progn
	  (select-window twin)
	  (setq posold (window-start))
	  (condition-case ()
	      (scroll-up)
	    (error (message "")))
	  (setq posnew (window-start))
	  (select-window cwin)
	  ;; XN[łȂ(=window\ʒuςĂȂ)nil
	  (if (= posold posnew)
	      nil
	    t))
      nil)))

(defun glog-Article-prev-page ()
  "Function of GLOG. Page up article buffer."
  (interactive)
  (let ((posold)(posnew)(cwin (selected-window))(twin))
    (if (setq twin (get-buffer-window glog-Article-buffer))
	(progn
	  (select-window twin)
	  (setq posold (window-start))
	  (condition-case ()
	      (scroll-down)
	    (error (message "")))
	  (setq posnew (window-start))
	  (select-window cwin)
	  ;; XN[łȂ(=window\ʒuςĂȂ)nil
	  (if (= posold posnew)
	      nil
	    t))
      nil)))

(defun glog-Article-show-subjects ()
  "Function of GLOG. Show subject list.
쒆"
  (interactive)
  (ding))

(defun glog-Article-refer-article ()
  "Function of GLOG. Reference article.
쒆"
  (interactive)
  (ding))

(defun glog-Article-pop-article ()
  "Function of GLOG. Show article.
쒆"
  (interactive)
  (ding))

(defun glog-Article-exit ()
  "Function of GLOG. Exit article."
  (interactive)
  (glog-configure-windows 'SelectArticle glog-Subject-buffer)
  (select-window (get-buffer-window glog-Subject-buffer)))

(defun glog-Article-describe-briefly ()
  "Describe Article mode commands briefly."
  (interactive)
  (message
   (concat
    (substitute-command-keys "\\[glog-Article-next-page]:Next page  ")
    (substitute-command-keys "\\[glog-Article-prev-page]:Prev page  ")
    (substitute-command-keys "\\[glog-Article-show-subjects]:Show headers  ")
    (substitute-command-keys "\\[glog-Info-find-node]:Run Info  ")
    (substitute-command-keys "\\[glog-Article-describe-briefly]:This help")
    )))


;;
;;  Post mode
;;

(defvar glog-Post-mode-map nil
  "Keymap for GLOG, in write article mode.")

;; Define GLOG Subsystems.
(autoload 'glog-make-Post-mode-keymap "glog_utl"
	  "Make local key map for Post mode in GLOG." t)
(autoload 'glog-Post-mode "glog_utl"
	  "Post mode function" t)
(autoload 'glog-Post-set-mode-line "glog_utl"
	  "post-buffermode-lineɏݒ" t)
(autoload 'glog-Post-set-post-buffer "glog_utl"
	  "Set post-buffer." t)
(autoload 'glog-set-post-buffer "glog_utl"
	  "Post-bufferZbg" t)
(autoload 'glog-Post-set-quote-string "glog_utl"
	  "pύX" t)
(autoload 'glog-Post-insert-quote "glog_utl"
	  "pt" t)
(autoload 'glog-Post-copy-from-article-and-paste "glog_utl"
	  "ptpaste" t)
(autoload 'glog-Post-quote-from-article "glog_utl"
	  "article-buffer̃[WptŃy[Xg" t)
(autoload 'glog-Post-quote-from-article-all "glog_utl"
	  "article-buffeȓSeptŃy[Xg" t)
(autoload 'glog-Post-copy-from-article "glog_utl"
	  "article-buffer̃[Wy[Xg" t)
(autoload 'glog-Post-widen-buffer "glog_utl"
	  "Widen post buffer." t)
(autoload 'glog-Post-show-reference "glog_utl"
	  "Show subject buffer." t)
(autoload 'glog-Post-show-ruler "glog_utl"
	  "Postobt@̃[hC؂ւĒK\" t)
(autoload 'glog-set-signature "glog_utl"
	  "post-buffersignaturet" t)
(autoload 'glog-Post-set-signature "glog_utl"
	  "post-buffersignaturet" t)
(autoload 'glog-Post-save-article "glog_utl"
	  "Jgpost-bufferƂ݂ȂēeZ[u" t)
(autoload 'glog-Post-exit "glog_utl"
	  "post-buffer̓eZ[uexit" t)
(autoload 'glog-Post-quit "glog_utl"
	  "post-buffer̓eZ[uexit" t)
(autoload 'glog-Post-describe-briefly "glog_utl"
	  "Describe Post mode commands briefly." t)

(defun glog-post ()
  "Post mode function of GLOG."
  (interactive)
  (let ((mesno nil)(title nil)(id nil)(author nil)(com-no nil)(date nil)
	(kind 'board)(mesid nil)(replyto nil)(idate nil))
    (glog-init) ;; `glog-init'ĂȂ΃obt@
    (glog-Post-set-post-buffer 'article nil)))

;;
;; x֐Q
;;

;; nɖˑɂ̂...
(defun glog-strcut-emacs (str &optional len mode chr)
  ;; w̒ɐ؂l߂.(len͎񒷂ł͖,ʏł̒)
  ;; 񂪎w蒷Zꍇ, mode('left|'right)̎͋󔒂[.
  ;; chrw肳Ăꍇ͕U̍ۂɂ̕gp.
  ;; (*work under plain Emacs!*)
  (let ((count)(c)(result))
    (if (not chr) (setq chr ? ))
    (setq count (if (or (< (length str) len) (< len 1)) (length str) len))
    (setq result (substring str 0 count))
    ;; Zꍇ͕␳
    (if (> (setq count (- len (length result))) 0)
	(cond
	 ((eq mode 'left)
	  (setq result (concat (make-string count chr) result)))
	 ((eq mode 'right)
	  (setq result (concat result (make-string count chr))))
	 (t result)))
    result))

(defun glog-strcut-nemacs (str &optional len mode chr)
  ;; w̒ɐ؂l߂.(len͎񒷂ł͖,ʏł̒)
  ;; 񂪎w蒷Zꍇ, mode('left|'right)̎͋󔒂[.
  ;; chrw肳Ăꍇ͕U̍ۂɂ̕gp.
  ;; (*work under Nemacs!*)
  (let ((count)(result)
	(kanji-flag t)) ; ɓȂƕB
    (if (not chr) (setq chr ? ))
    ;; ꍇ͐؂l߂
    (if (<= (length str) len)
	(setq result str)
      (if (not (check-string-kanji-code str))
	  ;; p݂̂ȂPsubstring
	  (setq result (substring str 0 len))
	(setq count (if (< (length str) len) (length str) len))
	;; 1byteڂꕶ炷(ʂh~)
	(if (and (not (string-match "[\040-\176\240-\337@-@-]+$"
			       (substring str 0 count)))
		 (> count 0))
	    (setq count (- count 1)))
	(setq result (substring str 0 count))))
    ;; Zꍇ͕␳
    (if (> (setq count (- len (length result))) 0)
	(cond
	 ((eq mode 'left)
	  (setq result (concat (make-string count chr) result)))
	 ((eq mode 'right)
	  (setq result (concat result (make-string count chr))))
	 (t result)))
    result))

(defun glog-strcut-mule (str &optional len mode chr)
  ;; w̒ɐ؂l߂.(len͎񒷂ł͖,ʏł̒)
  ;; 񂪎w蒷Zꍇ, mode('left|'right)̎͋󔒂[.
  ;; chrw肳Ăꍇ͕U̍ۂɂ̕gp
  ;; (*work under Mule!*)
  (let ((count)(result)
    (mc-flag t)  ) ; ɓȂ sref ŃG[ɂȂ邵
    (if (not chr) (setq chr ? ))
    (setq count (if (> (length str) len) (length str) len))
    (setq result str)
    ;; ꍇ؂l߂
    (while (and (> count 0) (> (string-width result) len))
      (while (and (setq count (if (> count 0) (- count 1) 0))
		  (< (sref str count) 0)))
      (setq result (substring str 0 (+ count 1))))
    ;; Zꍇ͕␳
    (if (> (setq count (- len (string-width result))) 0)
	(cond
	 ((eq mode 'left)
	  (setq result (concat (make-string count chr) result)))
	 ((eq mode 'right)
	  (setq result (concat result (make-string count chr))))
	 (t result)))
    result))

(fset 'glog-strcut (cond ((boundp 'NEMACS) (function glog-strcut-nemacs))
			 ((boundp 'MULE)   (function glog-strcut-mule))
			 (t                (function glog-strcut-emacs))))


;; t@Cǂݍŕ]
(glog-read-config-file)

;; make keymap
(glog-make-Group-mode-keymap)
(glog-make-Subject-mode-keymap)
(glog-make-Article-mode-keymap)
;; Nwindow-configurationZ[u
(glog-save-window-configuration 'ORG)


;; ͂Aɓǂݍ߂܂
(provide 'glog)

;;; glog.el ends here
