;; glog_asc.el: ASCII-Net mode functions for GLOG.     -*-Emacs-Lisp-*-
;; Copyright (C) 1993-95 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
(defconst glog_asc "$Header: glog_asc.elv  1.13  95/07/26 22:27:54  Nam  Exp $")

(require 'glog)

(defun view-ascii-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing ASCII-Net's log.
  (fset 'glog-get-forum-name        (function glog-get-forum-name-ascii))
  (fset 'glog-get-board-name        (function glog-undefined-function))
  (fset 'glog-get-article-info      (function glog-get-article-info-ascii))
  (fset 'glog-get-mail-info         (function glog-get-mail-info-ascii))
  (fset 'glog-set-post-header       (function glog-set-post-header-ascii))
  (fset 'glog-set-post-terminator   (function glog-set-post-terminator-ascii))
  (fset 'glog-set-mail-header       (function glog-set-mail-header-ascii))
  (fset 'glog-set-mail-terminator   (function glog-set-mail-terminator-ascii))
  (fset 'glog-check-post            (function glog-undefined-function))
  (setq glog-match-string-forum
        (concat "^\[ INDEX \] .+ \([0-9a-z]+\.[0-9a-z]+\) "
		"[ 1][0-9]\:[ 1-5][0-9][ap]m "
		"[ 1][0-9]\/[ 1-3][0-9]\/[ 0-9][0-9]$")) ;; ق܂, Thks!
  (setq glog-match-string-board     nil)  ; ASCIIforuminfô
  (setq glog-match-string-article
		"^ Note [0-9]+ .+ \([0-9a-z]+\.[0-9a-z\.]+\)$")
  (setq glog-match-string-mail    ; NASCII-NetLog(^_^;)
		(concat "^From [a-z][a-z][a-z][0-9][0-9][0-9][0-9][0-9] "
		"[F-W][a-u][d-u] [A-O][a-u][b-y] [ 0-3][0-9] "
		"[ 0-9][0-9]:[ 0-9][0-9]:[ 0-9][0-9] [1-2][0-9][0-9][0-9]$"))
  (setq glog-match-string-skip      nil)
  (setq glog-match-string-article-end
        (concat "\\(" "^MENU>> " "\\|" "^READMAIL>> " "\\|" "^EDITOR>> "
		 "\\|" "^INDEX>> " "\\|" "^NOTES>> "
		 "\\|" "^ Note [0-9]+ .+ \([0-9a-z]+\.[0-9a-z\.]+\)$"
		 "\\|" "^From [a-z][a-z][a-z][0-9][0-9][0-9][0-9][0-9] "
		 "[F-W][a-u][e-t] [A-O][a-u][b-y] [ 0-9][0-9] "
		 "[ 0-9][0-9]:[ 0-9][0-9]:[ 0-9][0-9] [1-2][0-9][0-9][0-9]$"
		 "\\|" "There are no new messages\. $"   ;;
		 "\\|" "^Level:[ 0-9]+<[0-9]+> "         ;; V, Thks!
		 "\\|" "^##### s@I #####$"    ;;
		"\\)"))
  (setq glog-search-regexp
        (concat
	 "\\(" glog-match-string-forum "\\|" glog-match-string-article
	 "\\|" glog-match-string-mail  "\\)"))
  (run-hooks 'view-ascii-mode-hook))


(defun glog-ascii-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_asc)

(defun glog-get-forum-name-ascii ()
  ;; ASCII-Net`̃tH[𓾂.
    (let ((linebuf (glog-get-current-line)))
      (if (string-match "\([0-9a-z]+\.[0-9a-z\.]+\)" linebuf)
	  (setq glog-current-subject
		(substring linebuf
			   (+ (match-beginning 0) 1) (- (match-end 0) 1))))
      nil))

(defun glog-get-article-info-ascii ()
  ;; ASCII-Net`mes̏𓾂.
  (let ((art-no)(author "")(id "unknown")(title "")(com-no -1)
	(lines)(base 0)(hour 0)(min 0)(yy)(date "????\/??\/?? ??:??")
	(linebuf)(limit)(hlines)(pos)(foo)(bar))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; {[h̊mF
    (if (string-match "\([0-9a-z]+\.[0-9a-z\.]+\)" linebuf)
	(progn
	  (setq foo (substring linebuf (+ (match-beginning 0) 1)
			       (- (match-end 0) 1)))
	  ;; current-subjectƈC
	  (if (not (string= foo glog-current-subject))
	      (setq glog-current-subject foo))))
    ;; x[Xԍ
    (if (setq foo (string-match "Note [0-9]+" linebuf))
	(setq base (* (string-to-int (substring linebuf (+ foo 5))) 1000)))
    ;; 1sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; ԍ𓾂
    (if (string-match "BASENOTE" linebuf)
	(setq art-no base)
      (if (not (string-match "[0-9]+ of" linebuf))
	  (setq art-no -1)
	(setq art-no (+ base (string-to-int
			      (substring linebuf (match-beginning 0)))))
	(setq com-no (- art-no 1))))
    ;; 1sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; ^Cg擾
    (if (string-match "^Title:" linebuf)
	(setq title (substring linebuf (match-end 0))))
    ;; 1sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; id擾
    (if (string-match "Author:[0-9a-z]+" linebuf)
	(setq id (substring linebuf (+(match-beginning 0)7)(match-end 0))))
    ;; nh擾
    (if (string-match "\([^\(\)]+\)$" linebuf)
          (setq author (substring linebuf (+(match-beginning 0)1)
				  (-(match-end 0)1))))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕŔr)
    ;; ܂
    (if (string-match "[ 1][0-9]:[0-5][0-9][ap]m" linebuf)
	(progn
	  (setq foo (substring linebuf (match-beginning 0)(match-end 0)))
	  (setq hour (string-to-int foo))
	  (setq min  (string-to-int (substring foo 3)))
	  (if (string-match ":[0-5][0-9]pm" foo)
	      (+ hour 12))))
    ;; ɔN
    (if (string-match "[ 1][0-9]\/[ 0-3][0-9]\/[ 0-9][0-9]" linebuf)
	(progn
	  (setq foo (substring linebuf (match-beginning 0)(match-end 0)))
	  (setq yy (string-to-int (substring foo 6)))
	  (setq date (format "%4d\/%2d\/%2d %2d:%2d"
			     (+ yy (if (> yy 39) 1900 2000))   ; N(4␳)
			     (string-to-int foo)               ; 
			     (string-to-int (substring foo 3)) ; 
			     hour min))))                      ; :
    ;; {̂܂ŋs΂
    (forward-line)
    (glog-foward-empty-line)
    (setq hlines (count-lines pos (point)))
    ;; s (pcs͕\Ȃ̂muleƎ|XLbvłȂ(T_T))
    (setq limit (glog-get-forward-line-position 300)) ; get search end point
    (re-search-forward glog-match-string-article-end limit 1)
    (beginning-of-line)
    (setq lines (count-lines pos (point)))
    ;; XgɓZ߂
    ;; (ԍ unread title id nh  Rg ʒu s
    ;;  wb_s )
    (list art-no ?  title author author date com-no pos lines hlines 'board)))

(defun glog-get-mail-info-ascii ()
  ;; ASCII-Net`mail̏𓾂.
  (let ((art-no)(date)(pos)(lines)(hlines 2)(author "")(id "")(title "")
	(linebuf)(limit)(foo)(bar)(yy)(mm)(dd)(hour)(min))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; obt@؂l߂Čn܂悤ɂ
    (if (string-match "[A-O][a-u][b-y] [ 0-3][0-9]" linebuf)
	(setq linebuf (substring linebuf (match-beginning 0))))
    (setq yy   (string-to-int (substring linebuf 16)))
    (setq mm   (glog-month-to-int (substring linebuf 0 3)))
    (setq dd   (string-to-int (substring linebuf  4)))
    (setq hour (string-to-int (substring linebuf  7)))
    (setq min  (string-to-int (substring linebuf 10)))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕŔr)
    (setq date (format "%4d\/%2d\/%2d %2d:%2d" yy mm dd hour min))
    ;; ԍ(uniqɂׂɌō쐬. make-groupuniqɒ)
    (setq art-no (+ (* mm  7440) (* dd  240) (* hour  10) (% min 6)))
    ;; 1sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; id𓾂
    (if (string-match " [0-9a-z]+ " linebuf)
	(setq id (substring linebuf (match-beginning 0) (match-end 0))))
    ;; nh𓾂
    (if (string-match "\(.+\)" linebuf)
	(setq author (substring linebuf (+ (match-beginning 0) 1)
				(- (match-end 0) 1))))
    ;; ^Cgs܂ŃXLbv
    (forward-line 2)
    (setq limit (point))
    (setq foo (glog-get-forward-line-position 100)) ; get search end point
    (if (re-search-forward "^Subject:[ ]*" foo 1)
	(progn
	  (setq foo (point))
	  (end-of-line)
	  (setq bar (point))
	  (setq title (buffer-substring foo bar))
	  (setq hlines (- (count-lines pos (point)) 1)))
      ;; Ɏs猳̈ʒu֖߂
      (setq title "")
      (goto-char limit))
    ;; s𓾂ׂɏI[
    (setq limit (glog-get-forward-line-position 300)) ; get search end point
    (re-search-forward glog-match-string-article-end limit 1)
    (beginning-of-line)
    (setq lines (count-lines pos (point)))
    ;; XgɓZ߂
    ;; (ԍ unread title id nh  Rg ʒu s
    ;;  wb_s )
    (list art-no ?  title id author date -1 pos lines hlines 'mail)))

(defun glog-set-post-header-ascii (&optional postmode)
  ;; PostBufferASCII-Net`̔wb_}.
  ;; ͏ʂ̊֐̃XR[v, id,title,author,newfileQƂĂ
  t)

(defun glog-set-post-terminator-ascii (&optional postmode)
  ;; PostBufferASCII-Net`̔I\".\"}.
  ;; 'noendmark w肷ΉȂ.
  ;; ex.
  ;;     (defun my-glog-set-post-terminator ()
  ;;       (if (eq glog-bbs-mode 'ascii)         ;; ascii̎Ȃ
  ;;           (glog-set-post-terminator 'noendmark)
  ;;         (glog-set-post-terminator)))

  ;; postmodenilłȂ΋Ilistɂ(̕]̈)
  (setq postmode (glog-force-list postmode))
  (goto-char (point-max))
  (if (re-search-backward "^\." nil t)
      ()  ;; obt@Ɋ"."tĂ̂ŉȂ
    ;; I[
    (if (not (bolp))
	(insert "\n"))
    (if (not (memq 'noendmark postmode))  ;; 'noendmark͉̎Ȃ
        (insert ".\n")))            ;; "."}
  t)

(defun glog-set-mail-header-ascii (&optional postmode)
  ;; PostBufferASCII-Net`̃[̔wb_}.
  ;; 'notitle Ȃ^Cgs}Ȃ 'noauthor ȂMlւ̈AȂ
  ;; ̎wlistΕZ߂Đݒł.
  ;; ex.
  ;;     (defun my-glog-set-mail-header ()
  ;;       (glog-set-mail-header (list 'notitle 'noauthor)))
  ;;
  ;; ̊֐͏ʊ֐̃XR[v id,title,author,newfileQƂĂ

  ;; postmodenilłȂ΋Ilistɂ(̕]̈)
  (setq postmode (glog-force-list postmode))
  (goto-char (point-min))
  (if newfile
      (progn
	(if (and (> (length title) 0)
	         (not (memq 'notitle postmode)))
	    (insert (format "Re:%s\n" title)))
	(if (and (> (length author) 0)
	       (not (memq 'noauthor postmode)))
	    (insert (format "  %s l\n\n" author))))))

(defun glog-set-mail-terminator-ascii (&optional postmode)
  ;; PostBufferASCII-Net`̔I}.
  (glog-set-post-terminator-ascii postmode)
  t)

(provide 'glog_asc)

;;; glog_asc.el ends here
