;; glog_faq.el: FAQ mode functions for GLOG.           -*-Emacs-Lisp-*-
;; Copyright (C) 1994-95 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
(defconst glog_faq "$Header: glog_faq.elv  1.5  95/08/06 21:42:06  Nam  Exp $")

(require 'glog)

(defun view-faq-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing FAQ.
  (fset 'glog-get-forum-name      (function glog-undefined-function))
  (fset 'glog-get-board-name      (function glog-get-board-name-faq))
  (fset 'glog-get-article-info    (function glog-get-article-info-faq))
  (fset 'glog-get-mail-info       (function glog-undefined-function))
  (fset 'glog-set-post-header     (function glog-undefined-function))
  (fset 'glog-set-post-terminator (function glog-undefined-function))
  (fset 'glog-set-mail-header     (function glog-undefined-function))
  (fset 'glog-set-mail-terminator (function glog-undefined-function))
  (fset 'glog-check-post          (function glog-undefined-function))
  (setq glog-match-string-forum     nil)
  (setq glog-match-string-board     "^=+$")
  (setq glog-match-string-article   "^[A-Z]+\-[0-9]+: ")
  (setq glog-match-string-mail      nil)
  (setq glog-match-string-skip      nil)
  (setq glog-match-string-article-end
	(concat
	 "\\(" glog-match-string-board "\\|" glog-match-string-article "\\)"))
  (setq glog-search-regexp
        (concat
	 "\\(" glog-match-string-board "\\|" glog-match-string-article "\\)"))
  (run-hooks 'view-faq-mode-hook))


(defun glog-faq-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_faq)

(defun glog-get-board-name-faq ()
  ;; FAQ`̍ږ𓾂.
  (let ((linebuf))
    ;; sO̕擾
    (save-excursion
      (forward-line -1)
      (setq linebuf (glog-get-current-line)))
    (setq glog-current-subject (downcase linebuf))
    nil))

(defun glog-get-article-info-faq ()
  ;; FAQ`mes̏𓾂.
  (let ((date "????-??-?? ??:??:??")(author "")(title "**")
	(pos)(lines)(art-no -1)(com-no)(linebuf)(limit)(p2)(foo)(bar)(ck nil))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    (forward-line)
    ;; ԍ
    (if (setq foo (string-match "\-[0-9]+: " linebuf))
	(setq art-no (string-to-int (substring linebuf (+ foo 1)))))
    ;; ^Cg
    (setq title (substring linebuf (match-end 0)))
    ;; s
    (setq p2 (point))
    (setq limit (glog-get-forward-line-position 300)) ; get search end pos
    (re-search-forward glog-match-string-article-end limit 1)
    (beginning-of-line)
    (setq lines (count-lines pos (point)))
    ;; ڎȂs炷 (̍s"^=$"Ȃڎ)
    (setq linebuf (glog-get-current-line))
    (if (string-match glog-match-string-board linebuf)
	(setq lines (- lines 2)))
    ;; s΂ȂڎƂ݂Ȃ
    (save-excursion
      (forward-line -1)
      (setq limit (point))
      (if (> limit p2)
	  (progn
	    (goto-char p2)
	    (if (re-search-forward "^[ @\t]*[^ @\t]+" limit 1)
		;; ڎۂcheck (̍s"^=$"Ȃڎ)
		(progn
		  (forward-line)
		  (setq linebuf (glog-get-current-line))
		  (if (not (string-match glog-match-string-board linebuf))
		      (setq ck t)))))))
    (if (and ck (> lines 1))
	;; XgɓZ߂
	;; (ԍ unread title id nh  Rg ʒu s
	;;  wb_s )
	(list art-no ?  title author author date com-no pos lines 0 'board)
      nil)))

(provide 'glog_faq)

;;; glog_faq.el ends here
