;; glog_glo.el: GLOG's out mode functions for GLOG.    -*-Emacs-Lisp-*-
;; Copyright (C) 1995 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
(defconst glog_glo "$Header: glog_glo.elv  1.1  95/08/29 22:07:18  Nam  Exp $")

(require 'glog)

(defvar glog-glogout-regexp "^- [^ \.]+: [^ \.]+\..+ -$"
  "Default save format's regexp.")

(defun set-glogout-mode ()
  ;; GLOGWo͌`ւ̊e֐o^
  (fset 'glog-set-post-header      (function glog-set-post-header-glogout))
  (fset 'glog-set-post-terminator  (function glog-set-post-terminator-glogout))
  (fset 'glog-set-mail-header      (function glog-set-mail-header-glogout))
  (fset 'glog-set-mail-terminator  (function glog-set-mail-terminator-glogout))
  (fset 'glog-check-post           (function glog-check-post-glogout))
  t)

(defun view-glogout-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing GLOG's default save format.
  (fset 'glog-get-forum-name        (function glog-undefined-function))
  (fset 'glog-get-board-name        (function glog-undefined-function))
  (fset 'glog-get-article-info      (function glog-get-article-info-glogout))
  (fset 'glog-get-mail-info         (function glog-undefined-function))
  (set-glogout-mode)
  (setq glog-match-string-forum     nil)
  (setq glog-match-string-board     nil)
  (setq glog-match-string-article glog-glogout-regexp)
  (setq glog-match-string-mail nil)
  (setq glog-match-string-skip      nil)
  (setq glog-match-string-article-end nil)
  (setq glog-search-regexp glog-match-string-article)
  (run-hooks 'view-glogout-mode-hook))


(defun glog-glogout-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_glo)

(defun glog-get-article-info-glogout ()
  ;; GLOGWZ[u`̃wb_𓾂.
  (let ((linebuf)(opos)(limit)(olines 1)(bbs nil)(btype "")(count 0)
	(pos)(art-no)(date "")(lines)(id "")(author "")(title "")(hline 1)
	(mesid nil)(replyto nil)(idate nil) (art)(foo)(bar))
    ;; Jnʒu
    (beginning-of-line)
    (setq opos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    (forward-line)
    ;; swb_͗L邩?
    (if (string-match " ([0-9]+L) -$" linebuf)
	(setq olines (string-to-int
		      (substring linebuf (+ (match-beginning 0) 2))))
      ;; wb_̂ōs擾
      (setq limit (glog-get-forward-line-position 5000)) ; get search end point
      (save-excursion
	(re-search-forward glog-glogout-regexp limit 1)
	(beginning-of-line)
	(setq olines (- (count-lines opos (setq limit (point))) 1))))
    ;; {[h擾
    (if (string-match "[^ ]+:[ ]+" linebuf)
	(progn
	  (setq foo (match-end 0))
	  (if (string-match "[ ]+([0-9]+L) -$" linebuf)
	      (setq bar (match-beginning 0))
	    (if (string-match "[ ]+-$" linebuf)
		(setq bar (match-beginning 0))
	      (setq bar nil)))
	  (if bar
	      (setq glog-current-subject (substring linebuf foo bar))))
      (setq glog-current-subject "Unknown.misc"))
    ;; bbs
    (if (string-match "[^ ]+:" linebuf)
	(progn
	  (setq btype
		(substring linebuf (match-beginning 0) (- (match-end 0) 1)))
	  (while (and (not bbs) (setq foo (nth count glog-bbs-list)))
	    (if (string= btype (symbol-name (nth 0 foo)))
		(setq bbs (car foo)))
	    (inc count))))
    ;; set BBS function
    (if bbs
	(progn
	  (glog-set-bbs-function bbs)
	  (save-excursion
	    (setq art (glog-get-article-info)))
	  (view-glogout-mode)))
    (if art
	(progn
	  (setq art-no  (glog-article-info-no        art))
	  (setq title   (glog-article-info-title     art))
	  (setq id      (glog-article-info-id        art))
	  (setq author  (glog-article-info-author    art))
	  (setq date    (glog-article-info-date      art))
	  (setq comno   (glog-article-info-comno     art))
	  (setq hline   (glog-article-info-headlines art))
	  (setq kind    (glog-article-info-kind      art))
	  (setq mesid   (glog-article-info-mesid     art))
	  (setq replyto (glog-article-info-replyto   art))
	  (setq idate   (glog-article-info-idate     art))))
    ;; (ԍ unread title id nh  Rg ʒu s
    ;;  wb_s )
    (list art-no ?  title id author date comno opos (+ olines 1) (+ hline 1)
	  kind mesid replyto idate)))

(defun glog-check-article-info-glogout ()
  ;; ArticleBufferGLOGWZ[u`̃wb_BBS`֐N
  (let ((cbuf (current-buffer))(linebuf)(bbs nil)(btype "")(foo)(bar)(count 0))
    (glog-set-article-buffer)
    (save-excursion
      (goto-char (point-min))
      ;; ܂1sobt@
      (setq linebuf (glog-get-current-line)))
    (set-buffer cbuf)
    ;; bbs
    (if (string-match "[^ ]+:" linebuf)
	(progn
	  (setq btype
		(substring linebuf (match-beginning 0) (- (match-end 0) 1)))
	  (while (and (not bbs) (setq foo (nth count glog-bbs-list)))
	    (if (string= btype (symbol-name (nth 0 foo)))
		(setq bbs (car foo)))
	    (inc count))))
    ;; set BBS function
    (if bbs
	(save-excursion
	  (glog-set-bbs-function bbs)
	  t)
      nil)))

(defun glog-set-post-header-glogout (&optional postmode)
  ;; PostBufferɊeBBSɑΉ`̔wb_}.
  (if (glog-check-article-info-glogout)
      (glog-set-post-header postmode))
  (set-glogout-mode))

(defun glog-set-post-terminator-glogout (&optional postmode)
  ;; PostBufferɊeBBSɑΉ`̔I\"..\"}.
  (if (glog-check-article-info-glogout)
      (glog-set-post-terminator postmode))
  (set-glogout-mode))

(defun glog-set-mail-header-glogout (&optional postmode)
  ;; PostBufferɊeBBSɑΉ`̃[̔wb_}.
  (if (glog-check-article-info-glogout)
      (glog-set-mail-header postmode))
  (set-glogout-mode))

(defun glog-set-mail-terminator-glogout (&optional postmode)
  ;; PostBufferɊeBBSɑΉ`̔I}.
  (if (glog-check-article-info-glogout)
      (glog-set-mail-terminator postmode))
  (set-glogout-mode))

(defun glog-check-post-glogout (&optional postmode)
  ;; PostBufferɊeBBSɑΉ`̃`FbN.
  (if (glog-check-article-info-glogout)
      (glog-check-post postmode))
  (set-glogout-mode))

(provide 'glog_glo)

;;; glog_glo.el ends here
