;; glog_mix.el: Nikkei-Mix mode functions for GLOG.    -*-Emacs-Lisp-*-
;; Copyright (C) 1993-95 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
;; Thank's for `terse mode' to Y.Nakahara.
;;
(defconst glog_mix "$Header: glog_mix.elv  1.10  95/08/06 21:46:52  Nam  Exp $")

(require 'glog)

(defun view-mix-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing Nikkei-Mix's log.
  (fset 'glog-get-forum-name        (function glog-get-forum-name-mix))
  (fset 'glog-get-board-name        (function glog-get-forum-name-mix))
  (fset 'glog-get-article-info      (function glog-get-article-info-mix))
  (fset 'glog-get-mail-info         (function glog-get-mail-info-mix))
  (fset 'glog-set-post-header       (function glog-set-post-header-mix))
  (fset 'glog-set-post-terminator   (function glog-set-post-terminator-mix))
  (fset 'glog-set-mail-header       (function glog-set-mail-header-mix))
  (fset 'glog-set-mail-terminator   (function glog-set-mail-terminator-mix))
  (fset 'glog-check-post            (function glog-undefined-function))
  (setq glog-match-string-forum
        (concat "^'[0-9a-z\.]+'\\( cA\\|\/\\)'[0-9a-z\.]+' "
		"\\(ȉ\\|\\)Q܂B"
		"[0-9]+ \\(̐V\\|\\)bZ[W܂B$"))
  (setq glog-match-string-board     nil)  ; Mixforuminfô
  (setq glog-match-string-article
        (concat "^[0-9a-z\.]+\/[0-9a-z\.]+ [0-9]+\, " ;;m
		"[0-9A-Za-z_\.]+ \, [0-9]+ \, " ;;m
		"[SMTWF][a-z][a-z] [A-Z][a-z][a-z] [ 0-9][0-9] "
		"[0-9][0-9]:[0-9][0-9]:[0-9][0-9] [1-2][0-9][0-9][0-9]$"))
  (setq glog-match-string-mail "^ [ 0-9][ 0-9][ 0-9][ 0-9][ 0-9]$")
  (setq glog-match-string-skip      nil)
  (setq glog-match-string-article-end
        (concat "\\(" "^Read:" "\\|" "^R:"		;;a
		"\\|" "^̕ȉ\\(\\|ł\\)ǂ\\(Ȃ\\|Ȃ\\)"
		      "bZ[W͂܂B$"
		"\\|" "^̕ȉɎQ\\(\\|Ă\\)܂B$"
		"\\|" "^==========================$"
		"\\|" "^==========$"	;;a
		"\\|" "^NO CARRIER$"
		"\\)"))
  (setq glog-search-regexp
        (concat
	 "\\(" glog-match-string-forum "\\|" glog-match-string-article "\\|"
	       glog-match-string-mail "\\)"))
  (run-hooks 'view-mix-mode-hook))


(defun glog-mix-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_mix)

(defun glog-get-forum-name-mix ()
  ;; Mix`̃tH[𓾂.
    (let ((linebuf (glog-get-current-line))(forum nil)(board nil))
      (if (string-match "^'[0-9a-z\.]+'" linebuf)
	  (setq forum (substring linebuf
				 (+ (match-beginning 0) 1)
				 (- (match-end 0) 1))))
      (setq linebuf (substring linebuf 3))
      (if (string-match "'[0-9a-z\.]+'" linebuf)
	  (setq board (substring linebuf
				 (+ (match-beginning 0) 1)
				 (- (match-end 0) 1))))
      (if (and forum board)
	  (setq glog-current-subject (concat forum "\/" board)))
      nil))

(defun glog-get-article-info-mix ()
  ;; Mix`mes̏𓾂.
  (let ((date "????\/??\/?? ??:??")(author "unknown")(title "")(com-no -1)
	(pos)(lines)(hlines 2)(art-no -1)(linebuf)(limit)(foo)(bar))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; {[h̊mF
    (if (string-match "^[0-9a-z\.]+\/[0-9a-z\.]+" linebuf)
	(progn
	  (setq foo (substring linebuf 0 (match-end 0)))
	  (if (equal foo glog-current-subject)
	      ()
	    ;; current-subjectƈC
	    (setq glog-current-subject foo))))
    ;; ԍ
    (if (setq foo (string-match "[0-9]+," linebuf))
	(setq art-no (string-to-int (substring linebuf foo))))
    ;; nh擾
    (if (setq foo (string-match "[0-9A-Za-z_\.\-]+ " linebuf)) ;;m
	(progn
	  ;; obt@nhJnʒus[܂łɕύX
	  (setq linebuf (substring linebuf foo))
	  (if (setq bar (string-match " " linebuf))
	      (setq author (substring linebuf 0 bar)))))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕŔr)
    (if (string-match "[0-9]+ \, [SMTWF][a-z][a-z] " linebuf)
	(progn
	  ;; obt@(j)ttB[hJnʒuɕύX
	  ;; "Apr 27 02:04:54 1993"Ȃ
	  (setq linebuf (substring linebuf (match-end 0)))
	  (setq date
		(format "%4d\/%2d\/%2d %5s"
			(string-to-int (substring linebuf 16))      ;; N
			(glog-month-to-int (substring linebuf 0 3)) ;; 
			(string-to-int (substring linebuf 4))       ;; 
			(substring linebuf 7 12)))))               ;; 
    ;; sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; Rg ('xxx ւ̃RgłB'-1)
    (if (setq foo (string-match "[0-9]+ ւ̃RgłB$" linebuf))
	(setq com-no (string-to-int (substring linebuf foo))))
    ;; s (Mix͕\Ȃ̂muleƎ|XLbvłȂ(T_T))
    (setq limit (glog-get-forward-line-position 500)) ; get search end point
    (save-excursion
      (re-search-forward glog-match-string-article-end limit 1)
      (beginning-of-line)
      (setq lines (count-lines pos (setq limit (point)))))
    ;; ^Cg
    (setq foo (point))
    (if (re-search-forward "^\-+$" limit 1)
	(progn
	  (forward-line)
	  (setq foo (point))
	  (if (re-search-forward ".+" limit 1)   ; s΂
	      ()
	    (goto-char foo)))
      (goto-char foo))
    (setq foo (glog-get-current-line))
    (setq title (if (string-match "^\\(W[:F][ ]*\\|[ @\t]+\\)" foo)
		    ;; 擪ɋ󔒂Ώ
		    (substring foo (match-end 0))
		  foo))
    (setq hlines (- (count-lines pos (point)) 1))
    ;; pointarticle̖
    (goto-char limit)
    ;; XgɓZ߂
    ;; (ԍ unread title id nh  Rg ʒu s
    ;;  wb_s )
    (list art-no ?  title author author date com-no pos lines hlines 'board)))

(defun glog-get-mail-info-mix ()
  ;; Mix`mail̏𓾂.
  (let ((art-no -1)(author "unknown")(title "")(com-no -1)
	(date "????\/??\/?? ??:??")(yy)(mm)
	(linebuf)(limit)(foo)(bar)(pos)(lines)(hlines))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; ԍ
    (if (string-match "[0-9]+" linebuf)
	(setq art-no (string-to-int
		      (substring linebuf (match-beginning 0)))))
    ;; sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; nh擾
    (if (string-match "^From:[ ]+" linebuf)
	(setq author (substring linebuf (match-end 0))))
    ;; sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕŔr)
    (if (string-match "[ 0-9]+ [A-Za-z]+ [0-9]+ " linebuf)
	(progn
	  (setq yy (string-to-int (substring linebuf 18)))
	  (setq mm (glog-month-to-int (substring linebuf 14 17)))
	  (setq date
		(format "%4d\/%2d\/%2d %5s"
			(+ yy (if (> yy 39) 1900 2000))        ; N␳
			mm                                     ; 
			(string-to-int (substring linebuf 11)) ; 
			(substring linebuf 21 26)))))          ; 
    ;; Rg̔ԍ𓾂
    (forward-line 2)
    (setq limit (point))
    (setq foo (glog-get-forward-line-position 100)) ; get search end point
    (if (not (re-search-forward "^In\-Reply\-To: \<memo\." foo 1))
	(goto-char foo)
      (setq foo (point))
      (end-of-line)
      (setq bar (- (point) 1))
      (setq com-no (string-to-int (buffer-substring foo bar))))
    ;; ^Cgs܂ŃXLbv
    (forward-line)
    (setq limit (point))
    (setq foo (glog-get-forward-line-position 100)) ; get search end point
    (if (not (re-search-forward "^Subject:[ ]*" foo 1))
	;; Ɏs猳̈ʒu֖߂
	(goto-char limit)
      (setq foo (point))
      (end-of-line)
      (setq bar (point))
      (setq title (buffer-substring foo bar)))
    (setq hlines (count-lines pos (point)))
    ;; s (Mix͕\Ȃ̂muleƎ|XLbvłȂ(T_T))
    (setq limit (glog-get-forward-line-position 500)) ; get search end point
    (re-search-forward "^read\/action:" limit 1)
    (beginning-of-line)
    (setq lines (count-lines pos (point)))
    ;; XgɓZ߂
    ;; (ԍ unread title id nh  Rg ʒu s
    ;;  wb_s )
    (list art-no ?  title author author date com-no pos lines hlines 'mail)))

(defun glog-set-post-header-mix ()
  ;; PostBuffermix`̔wb_}.
  ;;Ȃ݂ɂ͏ʊ֐̃XR[v, id,title,author,newfileQƂĂ
  t)

(defun glog-set-post-terminator-mix ()
  ;; PostBuffermix`̔I}.
  (let ((p1 (progn (goto-char (point-max))(point)))
	(p2 (progn (beginning-of-line)(point))))
    (goto-char (point-max))
    (if (re-search-backward "^\.$" nil t)
        ()  ;; obt@Ɋ"."tĂ̂ŉȂ
      (if (/= p1 p2)
	  (progn
	    (goto-char (point-max))
	    (insert "\n")))
      (insert ".\n"))
    t))

(defun glog-set-mail-header-mix ()
  ;; PostBuffermix`̃[̔wb_}.
  ;; ͏ʂ̊֐̃XR[v, id,title,author,newfileQƂĂ
  (goto-char (point-min))
  (if newfile
      (progn
	(if (> (length title) 0) (insert (format "Re:%s\n" title)))
        (if (> (length author) 0)
	    (insert (format "  %s l\n\n" author))))))

(defun glog-set-mail-terminator-mix ()
  ;; PostBuffermix`̔I}.
  (glog-set-post-terminator-mix)
  t)

(provide 'glog_mix)

;;; glog_mix.el ends here
