;; glog_nif.el: Nifty-Serve mode functions for GLOG.   -*-Emacs-Lisp-*-
;; Copyright (C) 1993-95 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
(defconst glog_nif "$Header: glog_nif.elv  1.34  95/08/31 00:47:44  Nam  Exp $")

(require 'glog)

;; macro setteing
(defmacro glog-nif-regexp-forum ()
  "^.+ +[A-Z][0-9A-Z]+$") ;; CUG͐擪FƂ͌Ȃ
(defmacro glog-nif-regexp-hp ()
  "^ID (ŝ݁F\\(HP\\|peBI\\))$")  ;; for HP/PATIO
(defmacro glog-nif-regexp-board-1 ()
  "^- [A-Z0-9]+ +MES([ 0-9][0-9]):.+ [0-9][0-9]/[01][0-9]/[0-3][0-9] -$")
(defmacro glog-nif-regexp-board-2 ()
  "^|c[ 0-9]+.+ :[0-9]+  :[0-9]+|$")
(defmacro glog-nif-regexp-board-3 ()    ;; inetnewsΉ  '94.10.15
  "^- MES([ 0-9][0-9]):[^ ]+ +[0-9][0-9]/[01][0-9]/[0-3][0-9] -$")
(defmacro glog-nif-regexp-article-1 ()
  "^[0-9]+/[0-9]+ +[A-Z*][A-Z*][A-Z*][0-9*][0-9*][0-9*][0-9*][0-9*]  ")
(defmacro glog-nif-regexp-article-2 () ;; for HP
  "^[0-9][0-9][0-9]  \\[[0-9][0-9]/[01][0-9]/[0-3][0-9] [012][0-9]:[0-5][0-9]\\]  [A-Z*][A-Z*][A-Z*][0-9*][0-9*][0-9*][0-9*][0-9*]  ")
(defmacro glog-nif-regexp-mail ()	;; 93/10/01wb_ύX
  "^[ 0-9][0-9] [ #].*[A-Z>]*\\([A-Z][A-Z][A-Z][0-9][0-9][0-9][0-9][0-9]\\|[0-9]+\.[0-9]+\\)  [ 0-9/]*[01][0-9]/[0-3][0-9] [012][0-9]:[0-5][0-9]$")
(defmacro glog-nif-regexp-mail2 ()      ;; [2s
  "^ +薼[F:]")
(defmacro glog-nif-regexp-commandline ()
  "^ *[Gg][Oo] +[A-Za-z][0-9A-Za-z]+ *$")
(defmacro glog-nif-regexp-commandnext ()
  "\\(^$\\|^.*$\\|^|.+|$\\|^FORUM>\\|^MAIL>\\|^CCS([PN])>\\|^ +薼F\\)")

(defmacro nif-id-match (str)
  (list 'string-match
	"[A-Z*][A-Z*][A-Z*][0-9*][0-9*][0-9*][0-9*][0-9*]" str))
(defmacro nif-mailid-match (str)
  (list 'string-match
	"[A-Z>]*\\([A-Z][A-Z][A-Z][0-9][0-9][0-9][0-9][0-9]\\|[0-9]+\.[0-9]+\\)" str))
(defmacro nif-mailidend-match (str)
  (list 'string-match
	"[A-Z>]*\\([A-Z][A-Z][A-Z][0-9][0-9][0-9][0-9][0-9]\\|[0-9]+\.[0-9]+\\) +" str))


(defun view-nifty-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing Nifty-Serve's log.
  (fset 'glog-get-forum-name        (function glog-get-forum-name-nifty))
  (fset 'glog-get-board-name        (function glog-get-board-name-nifty))
  (fset 'glog-get-article-info      (function glog-get-article-info-nifty))
  (fset 'glog-get-mail-info         (function glog-get-mail-info-nifty))
  (fset 'glog-set-post-header       (function glog-set-post-header-nifty))
  (fset 'glog-set-post-terminator   (function glog-set-post-terminator-nifty))
  (fset 'glog-set-mail-header       (function glog-set-mail-header-nifty))
  (fset 'glog-set-mail-terminator   (function glog-set-mail-terminator-nifty))
  (fset 'glog-check-post            (function glog-undefined-function))
  (fset 'glog-correct-article       (function glog-undefined-function))
  (fset 'glog-get-article-end-nifty
	(if (glog-nifty-check-delimiter)
	    (function glog-get-article-end-nifty-dlm-on)
	  (function glog-get-article-end-nifty-dlm-off)))
  (setq glog-match-string-forum
	(concat "\\(" (glog-nif-regexp-forum)
		"\\|" (glog-nif-regexp-hp)
		"\\)"))
  (setq glog-match-string-board
        (concat "\\(" (glog-nif-regexp-board-1)
		"\\|" (glog-nif-regexp-board-2)
		"\\|" (glog-nif-regexp-board-3)
		"\\)"))
  (setq glog-match-string-article
        (concat "\\(" (glog-nif-regexp-article-1)
		"\\|" (glog-nif-regexp-article-2)
		"\\)"))
  (setq glog-match-string-mail (glog-nif-regexp-mail))
  (setq glog-match-string-skip
        "\\(^more>$\\|^$\\|^isŕ\@S:̔j$\\)")
  (setq glog-search-regexp
        (concat "\\(" (glog-nif-regexp-article-1)
		"\\|" (glog-nif-regexp-article-2)
		"\\|" (glog-nif-regexp-mail)
		"\\|" (glog-nif-regexp-board-1) "\\|" (glog-nif-regexp-board-2)
		"\\|" (glog-nif-regexp-board-3)
		"\\|" (glog-nif-regexp-forum)   "\\|" (glog-nif-regexp-hp)
		"\\)"))
  (setq glog-match-string-article-end
	(concat
	 "\\(" (glog-nif-regexp-article-1)
	 "\\|" (glog-nif-regexp-article-2)
	 "\\|" (glog-nif-regexp-mail)
	 "\\|" (glog-nif-regexp-board-1)
	 "\\|" (glog-nif-regexp-board-2)
	 "\\|" (glog-nif-regexp-board-3)
	 "\\|" (glog-nif-regexp-forum)
	 "\\|" (glog-nif-regexp-hp)
	 "\\|" "^FORUM>" "\\|" "^HP>" "\\|" "^MAIL>"
	 "\\|" "^dqc (1:"    "\\|" "^CCS([PN])>"
	 "\\|" (glog-nif-regexp-commandline) "\\)"))
  (setq glog-match-string-mail-end
	(concat
	 "\\(" (glog-nif-regexp-mail)
	 "\\|" "^action:" "\\|" "^M (1:폜.+)$" "\\|" "^MAIL>"
	 "\\|" "^|_E[hI|$"
	 "\\|" (glog-nif-regexp-board-1)
	 "\\|" (glog-nif-regexp-board-2)
	 "\\|" (glog-nif-regexp-board-3)
	 "\\|" (glog-nif-regexp-forum)
	 "\\|" (glog-nif-regexp-hp)
	 "\\|" (glog-nif-regexp-commandline) "\\)"))
  (run-hooks 'view-nifty-mode-hook))


(defun glog-nifty-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_nif)

(defun glog-nifty-check-delimiter ()
  ;; viewing-bufferlog`SET DLM ON'Ă邩ۂ𒲂ׂ.
  ;; `DLM ON'Ȃ`t', `DLM OFF'Ȃ`nil'Ԃ.
  (let ((cbuf (current-buffer))(res nil) (kanji-flag)(mc-flag))
    (if (not glog-refer-buffer)
	()  ;; LOGQƂĂȂnil
      ;; ܂LOGQbufferJgɂ
      (set-buffer glog-refer-buffer)
      (save-excursion
	(goto-char (point-min))
	(if (re-search-forward "^ \010$" 20000 t)
	    (setq res t)))
      (set-buffer cbuf))
    res))

(defun glog-get-forum-name-nifty ()
  ;; Nifty`̃tH[𓾂.
  (let ((linebuf (glog-get-current-line))(forum nil)(title))
    (if (not (string-match "ŝ݁F\\(HP\\|peBI\\)" linebuf))
	;; FORUM
	(if (string-match "[0-9A-Z]+$" linebuf)
	    (setq forum (substring linebuf (match-beginning 0))))
      ;; HP/PATIO
      (setq title (if (string-match "HP" linebuf) "hp." "patio."))
      (forward-line)
      (setq linebuf (glog-get-current-line))
      (if (string-match "[0-9A-Z]+" linebuf)
	  (setq glog-current-subject
		(concat title (substring linebuf (match-beginning 0)))))
      (if (string= "hp." title)
	  ;; HPȂ3si߂ă^Cg擾
	  (progn
	    (forward-line 3)
	    (setq glog-current-subject
		  (format "%s (%s)" glog-current-subject
			  (glog-get-current-line))))))
    forum))

(defun glog-get-board-name-nifty ()
  ;; Nifty`̃{[h𓾂.
  (let ((linebuf)(nextline)(forum)(foo)(bar)(result))
    ;; sobt@
    (setq linebuf (glog-get-current-line))
    (forward-line)
    (setq nextline (glog-get-current-line))
    (cond
     ;; mread̏ꍇ
     ((string-match "^- [A-Z0-9]+ +MES([ 0-9][0-9]):" linebuf)
      (progn
	(if (string-match "[A-Z0-9]+" linebuf)
	    (setq forum (downcase
			 (substring linebuf (match-beginning 0)(match-end 0)))))
	(if (string-match "\):.+[ 0-9][0-9]/[ 0-9][0-9]/[ 0-9][0-9] -" linebuf)
	    (setq result (substring linebuf
				    (+ (match-beginning 0) 2)
				    (- (match-end 0) 11))))
	;; ̍swb_łȂ΁ApƂ݂ȂnilԂ.
	(if (not (string-match glog-match-string-article nextline))
	    nil
	  (setq glog-current-subject (concat forum "." result))
	  nil)))
     ;; 蓮ǂ݂̏ꍇ
     ((string-match "^|c[ 0-9]+" linebuf)
      (progn
	(setq foo (match-end 0))
	(setq result (if (string-match " +" linebuf)
			 (substring linebuf foo (match-beginning 0))
		       nil))
	(if (string-match
	     "\\(^CCS([NP])>\\|^|̉c\\|^dqc\\)" nextline)
	    result
	  nil)))
     ;; inetnews/patiȍꍇ
     ((string-match "^- MES([ 0-9][0-9]):" linebuf)
      (progn
	(setq foo (match-end 0))
	(if (string-match "[ 0-9]+\/[ 0-9]+\/[ 0-9]+-$" linebuf)
	    (setq bar (substring linebuf foo (match-beginning 0)))
	  (setq bar ""))
	(if (not (string-match "^patio.[0-9A-Z]+" glog-current-subject))
	    (setq glog-current-subject bar)
	  (setq foo (substring glog-current-subject 0 (match-end 0)))
	  (setq glog-current-subject (format "%s (%s)" foo bar)))
	nil))
     ;; Ɏsꍇ
     (t
      nil))))

(defun glog-get-article-end-nifty-dlm-on (pos &optional line-end board-no)
  ;; Nifty-Serve-modep̓֐. Nifty`mes(pos:݈ʒu)
  ;; I[܂ł̍s߂. (炩pos܂ňړĂ.)
  ;; `SET DLM ON'̏ꍇ̊֐. FINETĈpooȂ񂾂ȁ`(T-T)
  (let ((kanji-flag)(mc-flag))
    (if (re-search-forward " \010$"
			   (glog-get-forward-line-position line-end) 1)
	(if (< (current-column) 4)
	    (- (count-lines pos (point)) 1)  ;; "^ ^H$"Ȃ1s炷
	  (count-lines pos (point)))
      ;; łȂdlm-offōČ(rONɂꍇɑΉ)
      (goto-char pos)
      (glog-get-article-end-nifty-dlm-off pos line-end board-no))))

(defun glog-get-article-end-nifty-dlm-off (pos &optional line-end board-no)
  ;; Nifty-Serve-modep̓֐. Nifty`mes(pos:݈ʒu)
  ;; I[܂ł̍s߂. (炩pos܂ňړĂ.)
  ;; ȎȂႢȂ̂ANiftỹzXgs
  ;; ȂȂ񂾁B\̂...B
  (let ((limit)(linebuf)(nextline)(endpos (point))(lines -1)(lim2))
    ;; get search end point
    (setq limit (glog-get-forward-line-position line-end))
    ;; s (Nifty͍s\̂őOȂƂȂ(T_T))
    (while (< lines 1)
      (if (not (re-search-forward glog-match-string-article-end limit 1))
	  ;; łȂ΍ŏIʒuƂ
	  (progn
	    (setq lines line-end)
	    (setq endpos limit))
	;; łꍇ
	;; pĂȂA̍s}b`Op^[Ń`FbN
	(beginning-of-line)
	(setq endpos (point))
	(setq linebuf (glog-get-current-line))
	(forward-line)
	(setq nextline (glog-get-current-line))
	(cond
	 ;; msgwb_"^[0-9]+/[0-9]+ +[A-Z*]+"ꍇ
	 ;; (ꂪԑƎv̂ōŏcheck)
	 ((string-match (glog-nif-regexp-article-1) linebuf)
	  (if (and (string-match "^([ 0-9][0-9])" nextline)
		   ;; {[hNo.ĂNo.ĂΈpł͖(?)
		   (= board-no (string-to-int (substring nextline 1))))
	      (setq lines (count-lines pos endpos))))
	 ;; MREAD{[hwb_"^- [A-Z0-9]+ +MES([ 0-9][0-9]):"̏ꍇ
	 ;; smsgwb_"^[0-9]+/[0-9]+ +[A-Z*]+"łȂΈpƂ݂Ȃ
	 ((and (string-match (glog-nif-regexp-board-1) linebuf)
	       (string-match (glog-nif-regexp-article-1) nextline))
	  ;; Ń{[hNo.checkƋtɃ{[hLOG̎Ɍ듮삵܂
	  (setq lines (count-lines pos endpos)))
	 ;; 蓮ǂmsgI(j[)̏ꍇ
	 ((and (string-match "^CCS([PN])>" linebuf)
	       (string-match "\\(^[0-9]+/[0-9]+ \\|CCS([PN])>\\|^FORUM>\\|^.*$\\|^|.*|$\\|^ԍ\\|^$\\)" nextline))
	  (setq lines (count-lines pos endpos)))
	 ;; 蓮ǂmsgI(j[L)̏ꍇ
	 ((and (string-match "^dqc (1:" linebuf)
	       (string-match "^" nextline))
	  (setq lines (count-lines pos endpos)))
	 ;; HP MSGwb_̏ꍇ
	 ;; "^[0-9][0-9][0-9]  \\[[0-9/]+ [0-9]+:[0-9]+\\]  [A-Z0-9*]+"
	 ((and (string-match (glog-nif-regexp-article-2) linebuf)
	       (string-match "^hp\\." glog-current-subject))
	  (setq lines (count-lines pos endpos)))
	 ;; HP READ MSGȈꍇ
	 ((and (string-match "^HP>" linebuf)
	       (string-match "^hp." glog-current-subject))
	  (setq lines (count-lines pos endpos)))
	 ;; mailwb_̏ꍇ
	 ;; ̍s"^ +薼F"Ȃ琳
	 ((and (string-match (glog-nif-regexp-mail) linebuf)
	       (string-match (glog-nif-regexp-mail2) nextline))
	  (setq lines (count-lines pos endpos)))
	 ;; 蓮Ŏforumֈړꍇ
	 ((string-match (glog-nif-regexp-commandline) linebuf)
	  (progn
	    (setq lines (count-lines pos endpos))
	    (setq lim2 (glog-get-forward-line-position 200))
	    (if (re-search-forward glog-match-string-article-end lim2 1)
		(progn
		  ;; ŏɌꂽ̂board/mail̃wb_Ȃp?
		  (setq linebuf (glog-get-current-line))
		  (if (or (string-match glog-match-string-article linebuf)
			  (string-match glog-match-string-mail linebuf))
		      (setq lines -1))))))
	 ;;̑
	 (t
	  ;; ̍s}b`ȂΈp݂Ȃ...
	  (if (string-match (glog-nif-regexp-commandnext) nextline)
	      (setq lines (count-lines pos endpos)))))))
    ;; IʒuɕA
    (goto-char endpos)
    lines))

(defun glog-get-mail-end-nifty (pos &optional line-end)
  ;; Nifty-Serve-modep̓֐. Nifty`mail(pos:݈ʒu)
  ;; I[܂ł̍s߂. (炩pos܂ňړĂ.)
  (let((limit)(linebuf)(nextline)(endpos (point))(lines -1)(lim2))
    ;; get search end point
    (setq limit (glog-get-forward-line-position line-end))
    ;; s (Nifty͍s\̂őOȂƂȂ(T_T))
    (while (< lines 0)
      (if (not (re-search-forward glog-match-string-mail-end limit 1))
	  ;; łȂ΍ŏIʒuƂ
	  (setq lines (count-lines pos limit))
	;; łꍇ
	;; pĂȂA̍s}b`Op^[Ń`FbN
	(beginning-of-line)
	(setq endpos (point))
	(setq linebuf (glog-get-current-line))
	(forward-line)
	(setq nextline (glog-get-current-line))
	(cond
	 ;; mailI(j[)̏ꍇ
	 ((and (string-match "^action:" linebuf)
	       (string-match "\\(^action:\\|^MAIL>\\|^.+$\\|^|.+|$\\|^ԐM \\|^Rg\\|^ȉ\\|^$\\)" nextline))
	  (setq lines (count-lines pos endpos)))
	 ((and (string-match "^|_E[hI|$" linebuf)
	       (string-match "^폜 (1:폜@2:Ȃ)$" nextline))
	  (setq lines (count-lines pos endpos)))
	 ;; mailI(j[L)̏ꍇ
	 ((and (string-match "^M (1:폜.+)$" linebuf)
	       (string-match "^F" nextline))
	  (setq lines (count-lines pos endpos)))
	 ;; mailwb_̏ꍇ
	 ;; ̍s"^ +薼F"Ȃ琳
	 ((and (string-match (glog-nif-regexp-mail) linebuf)
	       (string-match (glog-nif-regexp-mail2) nextline))
	  (setq lines (count-lines pos endpos)))
	 ;; MREAD{[hwb_"^- [A-Z0-9]+ +MES([ 0-9][0-9]):"̏ꍇ
	 ;; smsgwb_"^[0-9]+/[0-9]+ +[A-Z*]+"łȂΈpƂ݂Ȃ
	 ((and (string-match (glog-nif-regexp-board-1) linebuf)
	       (string-match (glog-nif-regexp-article-1) nextline))
	  (setq lines (count-lines pos endpos)))
	 ;; 蓮forumֈړꍇ
	 ((string-match (glog-nif-regexp-commandline) linebuf)
	  (progn
	    (setq lines (count-lines pos endpos))
	    (setq lim2 (glog-get-forward-line-position 200))
	    (if (re-search-forward glog-match-string-article-end lim2 1)
		(progn
		  ;; ŏɌꂽ̂board/mail̃wb_Ȃp?
		  (setq linebuf (glog-get-current-line))
		  (if (or (string-match glog-match-string-article linebuf)
			  (string-match glog-match-string-mail linebuf))
		      (setq lines -1))))))
	 ;;̑
	 (t
	  ;; ̍s}b`ȂΈp݂Ȃ...
	  (if (string-match (glog-nif-regexp-commandnext) nextline)
	      (setq lines (count-lines pos endpos)))))))
    ;; IʒuɕA
    (goto-char endpos)
    lines))

(defun glog-get-article-info-nifty ()
  ;; Nifty`mes̏𓾂.
  (let ((linebuf)(nextline)(pos))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂2sobt@
    (setq linebuf (glog-get-current-line))
    (forward-line)
    (setq nextline (glog-get-current-line))
    ;; `ɂĕ
    (cond
     ;; HomeParty?
     ((string-match "^[0-9][0-9][0-9]  \\[[0-9][0-9]/" linebuf)
      (glog-get-article-info-nifty-hp pos linebuf nextline))
     ;; intetnet?
     ((string-match "^[0-9][0-9][0-9]+/[0-9][0-9][0-9]+ +INE00010" linebuf)
      (glog-get-article-info-nifty-inet pos linebuf nextline))
     ;; FORUMX
     (t
      (glog-get-article-info-nifty-forum pos linebuf nextline)))))

(defun glog-get-article-info-nifty-forum (pos &optional linebuf nextline)
  ;; Nifty`BOARD̏𓾂.
  (let ((foo)(art-no)(date)(lines)(hlines)(id)
	(board-no -1)(author "")(title "")(com-no -1))
    ;; ʏ̃tH[炵̂Ő`FbN
    (if (not (string-match
	      "^([ 0-9][0-9]) +[0-9][0-9]/[01][0-9]/[0-3][0-9] [012][0-9]:[0-5][0-9]" nextline))
	;; 2sڂp^[Ƀ}b`ȂnilԂ
	nil
      ;; ǂ琳炵
      ;; ԍ
      (setq art-no (string-to-int linebuf))
      ;; ID擾
      (nif-id-match linebuf)
      (setq id (substring linebuf (match-beginning 0)(match-end 0)))
      ;; obt@nhJnʒus[܂łɕύX
      (setq foo (substring linebuf (match-end 0)))
      (string-match " +" foo)
      (setq linebuf (substring foo (match-end 0)))
      ;; O擾
      (if (or (string-match "^\\*+" id) (string-match "^[^ ]+$" linebuf))
	  ;; sys-op폜܂͔ҍ폜Ńnh̏ꍇtitlê
	  (setq title linebuf)
	;; nhƃ^Cg𕪗
	(setq foo 0)
	(if (boundp 'MULE)
	    (while (< (string-width author) 16)
	      (if (not (string-match " +" linebuf foo))
		  (setq author linebuf)
		(setq foo (match-end 0))
		(setq author (substring linebuf 0 foo))))
	  (while (< (length author) 16)
	    (if (not (string-match " +" linebuf foo))
		(setq author linebuf)
	      (setq foo (match-end 0))
	      (setq author (substring linebuf 0 foo)))))
	(if (> foo 1)
	    (progn
	      (setq title (substring linebuf foo))
	      (setq author (glog-delete-line-end-space author)))
	  (setq title linebuf)
	  (setq author "")))
      ;; 2sڕ
      ;; {[hԍ(p`FbNɎgp)
      (setq board-no (string-to-int (substring nextline 1)))
      ;; t
      ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
      ;;  (ĕŔr)
      (setq foo (string-to-int (substring nextline 7)))
      ;; N␳date('38'ȑOȂ1900N)
      (setq date (format "%4d%s" (+ foo (if (> foo 39) 1900 2000))
			 (substring nextline 9 21)))   ; "yy/mm/dd HH:MM"
      ;; Rg ('xxxւ̃Rg'-1)
      (if (string-match "[0-9]+" nextline)
	  (setq com-no (string-to-int
			(substring nextline (match-beginning 0)))))
      ;; {̂܂ŋs΂
      (forward-line)
      (glog-foward-empty-line)
      (setq hlines (count-lines pos (point)))
      ;; s (Nifty͍s\̂őOȂƂȂ(T_T))
      (setq lines (glog-get-article-end-nifty pos 320 board-no))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (list art-no ?  title id author date com-no pos lines hlines 'board))))

(defun glog-get-article-info-nifty-hp (pos &optional linebuf nextline)
  ;; Nifty`HP̏𓾂.
  (let ((foo)(art-no)(date)(lines)(id)(author "")(title "")(com-no -1))
    ;; 2sڂ^Cg^CgꗗȂ̂ŏI
    (if (string-match "\\(^[0-9][0-9][0-9]  \\[[0-9][0-9]/\\|^HP>\\)" nextline)
	nil
      ;; current-subjectHPłȂ"hp.unknown"ɐݒ
      (if (not (string-match "^hp\\." glog-current-subject))
	  (setq glog-current-subject "hp.unknown"))
      ;; ԍ
      (setq art-no (string-to-int linebuf))
      ;; tN␳date('38'ȑOȂ1900N)
      (setq foo (string-to-int (substring linebuf 6)))
      (setq date (format "%4d%s" (+ foo (if (> foo 39) 1900 2000))
			 (substring linebuf 8 20))) ; "yy/mm/dd HH:MM"
      ;; ID擾
      (nif-id-match linebuf)
      (setq id (substring linebuf (match-beginning 0)(match-end 0)))
      ;; ^Cg擾(IDIʒű󔒈ȍ~s[܂)
      (setq foo (substring linebuf (match-end 0)))
      (string-match " +" foo)
      (setq title (substring foo (match-end 0)))
      ;; Rg擾('Res:---'or 'A:---'-1)
      (setq com-no (glog-search-comment-root title))
      ;; s (Nifty͍s\̂őOȂƂȂ(T_T))
      (setq lines (glog-get-article-end-nifty-dlm-off pos 200 -1))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (list art-no ?  title id author date com-no pos lines 1 'board))))

(defun glog-get-article-info-nifty-inet (pos &optional linebuf nextline)
  ;; Nifty`inetnews̏𓾂.
  (let ((foo)(limit)(board-no -1) (art-no)(com-no -1)
	(ngroup nil)(subject "")(mesid nil)(addr "")(name "")(replyto nil)
	(idate nil)(gdate "")(lines 0)(hlines 0))
    ;; inetnews炵̂Ő`FbN
    (if (not (string-match
	      "^([ 0-9][0-9]) +[0-9][0-9]/[01][0-9]/[0-3][0-9] [012][0-9]:[0-5][0-9]" nextline))
	;; 2sڂp^[Ƀ}b`ȂnilԂ
	nil
      ;; ǂ琳炵
      ;; ԍ
      (setq art-no (string-to-int linebuf))
      ;; 2sڕ
      ;; {[hԍ(p`FbNɎgp)
      (setq board-no (string-to-int (substring nextline 1)))
      ;; t
      ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
      ;;  (ĕŔr)
      (setq foo (string-to-int (substring nextline 7)))
      ;; N␳date('38'ȑOȂ1900N)
      (setq gdate (format "%4d%s" (+ foo (if (> foo 39) 1900 2000))
			 (substring nextline 9 21)))   ; "yy/mm/dd HH:MM"
      ;; {̂܂ŋs΂
      (forward-line)
      (glog-foward-empty-line)
      (setq hlines (- (count-lines pos (point)) 1))
      ;; wb_擾
      (glog-get-inethead-info)
      ;; Rg ('Re:---'-1 / ł͌Ȃ)
      (if (> (length subject) 0)
	  (setq com-no (glog-search-comment-root subject nil t)))
      ;; s
      (if (and (> lines 0) (> hlines 0))
	  (setq lines (+ 1 hlines 1 lines)))
      ;; OʂƔr
      (save-excursion
	(setq foo (glog-get-article-end-nifty pos 3001 board-no)))
      ;; "LINES:"ꍇOʂZꍇ
      (if (> foo lines)
	  (setq lines foo))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s  mesid replyto idate)
      (list art-no ?  subject addr name gdate com-no pos lines
	    hlines 'inews mesid replyto idate))))

(defun glog-get-mail-info-nifty ()
  ;; Nifty`MAIL̏𓾂.
  (let ((linebuf)(foo)(bar)(limit) (kind 'mail)
	(art-no)(pos)(id-s 0)(yy)(mon)(day)(hour)
	(ngroup nil)(subject "")(mesid nil)(addr "")(name "")(replyto nil)
	(idate nil)(gdate "")(lines 0)(hlines 0))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; ԍ
    (setq art-no (string-to-int linebuf))
    ;; ID擾
    (if (setq id-s (nif-mailid-match linebuf))
	(setq addr (substring linebuf id-s (match-end 0))))
    ;; O擾
    (setq foo (if (string-match "^[ 0-9#]+" linebuf) (match-end 0) 4))
    (setq bar (substring linebuf foo id-s))
    ;; ʏmailȂnh̋󔒂폜
    (setq name (substring bar 0 (string-match "[ @]+$" bar)))
    ;; obt@nhJnʒus[܂łɕύX
    (if (nif-mailidend-match linebuf)
	(setq linebuf (substring linebuf (match-end 0))))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕŔr)
    ;; 93/10/01 Niftỹwb_dlύXΉ
    (if (setq foo
	      (string-match
	       "[0-9][0-9]/[01][0-9]/[0123][0-9] [012][0-9]:[0-5][0-9]$"
	       linebuf))
	;; t擾 "yy/mm/dd HH:MM"
	(setq gdate (substring linebuf foo (match-end 0)))
      ;; Â^Cṽwb_Ȃ_~[̔N("93/")ǉ
      (setq foo (string-match
		 "[01][0-9]/[0123][0-9] [012][0-9]:[0-5][0-9]$" linebuf))
      (setq gdate (concat "93/" (substring linebuf foo (match-end 0)))))
    ;; ԍuniqɂׂɌǉ(search-groupuniqɒ)
    (setq mon  (* (string-to-int (substring gdate 3  5)) 7440))
    (setq day  (* (string-to-int (substring gdate 6  8))  240))
    (setq hour (* (string-to-int (substring gdate 9 11))   10))
    (setq art-no (+ mon day hour art-no))
    ;; sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; ^Cg擾
    (if (not (string-match (glog-nif-regexp-mail2) linebuf))
	;; ̍s"^ +薼F"łȂmailwb_̈pƂ݂ȂnilԂ
	nil
      ;; ǂ琳炵
      (setq subject (substring linebuf (match-end 0)))
      ;; {̂܂ŋs΂
      (forward-line)
      (glog-foward-empty-line)
      (setq hlines (count-lines pos (point)))
      ;; InterNetMailcheck(WIDE GATEΉ)
      ;; ("INET GATE"܂Niftydl\ȂɕύX(T_T) '94.2.10)
      (if (not (string-match "\\(INET\\|WIDE\\) GATE" name))
	  ()
	;; InetMailȂ
	(setq kind 'imail)
	;; wb_擾
	(glog-get-inethead-info))
      ;; s (Nifty͍s\̂őOȂƂȂ(T_T))
      (forward-line)
      (setq lines (glog-get-mail-end-nifty pos 3100))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (if (eq kind 'imail)
	  (list art-no ?  subject addr name gdate -1 pos lines hlines kind
		mesid replyto idate)
	(list art-no ?  subject addr name gdate -1 pos lines hlines kind)))))

(defun glog-nifty-del-rerere (&optional title)
  ;; ^CǵuRe:Re:Re:v΍. ReReReRe^3 ̂悤ɏlԂ.
  (let ((foo)(bar)(tl))
    (if (not title)
	nil
      (setq tl (downcase title))
      (cond
       ;; ResւResւ̎1("Re:Re:...""Re^2:")
       ((string-match "^\\(res*:\\)+" tl)
	(progn
	  (setq foo 1)
	  (while (string-match "^[Rr][Ee][Ss]*:" title)
	    (setq title (substring title (match-end 0)))
	    (inc foo))
	  (format "Re^%d:%s" foo title)))
       ;; ResւResւ̎2("Re^x:...""Re^y":))
       ((string-match "^res*[\\^\\*][0-9]+:" tl)
	(progn
	  (setq foo (substring title (match-end 0)))
	  (string-match "[0-9]+:" title)
	  (setq bar (string-to-int (substring title (match-beginning 0))))
	  (format "Re^%d:%s" (+ bar 1) foo)))
       ;; ŏRes̎
       (t
	(concat "Re:" title))))))

(defun glog-set-post-header-nifty (&optional postmode)
  ;; PostBufferNifty`̔wb_}.
  ;; 'notitlew肷title}Ȃ.
  ;; ̎wlistΕZ߂Đݒł.
  ;; ex.
  ;;     (defun my-glog-set-post-header ()
  ;;       (glog-set-post-header (list 'notitle 'noauthor)))
  ;; 
  ;; Ȃ݂ɂ̊֐́Aʊ֐̃XR[v id,title,author,newfile 
  ;; QƂĂ
  (let ((hp nil)(tl "")(re))
    ;; postmodenilłȂ΋Ilistɂ(̕]̈)
    (setq postmode (glog-force-list postmode))
    (goto-char (point-min))
    (if title (setq tl (glog-nifty-del-rerere title)))  ;; ReReRe΍
    (if (and glog-current-subject (string-match "^hp\\." glog-current-subject))
	;; HPȂ^Cgs(+"1(CR)")
	(setq hp t))
    (if (and mesno (> mesno 0)
	     (eq (glog-assoc-list 'openmode glog-post-data) 'article))
	(setq re (format "RE:%d%s" mesno (if hp "  " "\n")))
      (setq re (if hp "" "RE:NONE\n")))
    (if (and newfile (not (memq 'notitle postmode)))
	(insert (format "%s%s%s%s\n"
			re (if hp "" "SUB:") tl (if hp "\n1" "")))))
  t)

(defun glog-set-post-terminator-nifty (&optional postmode)
  ;; PostBufferNifty`̔I\"/E\"}.
  ;; 'post w肷\"/POST\"𖖔ɉ.
  ;; 'noendmark w肷ΉȂ.
  ;; ex.
  ;;     (defun my-glog-set-post-terminator ()
  ;;       (if (eq glog-bbs-mode 'nifty)         ;; nifty̎"/POST"}
  ;;           (glog-set-post-terminator 'post)
  ;;         (glog-set-post-terminator)))

  ;; postmodenilłȂ΋Ilistɂ(̕]̈)
  (setq postmode (glog-force-list postmode))
  (goto-char (point-max))
  (if (re-search-backward "^\\(\/[eE]$\\|\/[pP][oO][sS][tT]$\\)" nil t)
      ()  ;; obt@Ɋ"/E"tĂ̂ŉȂ
    ;; I[
    (if (not (bolp))
	(insert "\n"))
    (cond
     ((memq 'noendmark postmode) ())  ;; 'noendmark͉̎Ȃ
     ((memq 'post postmode)           ;; 'post ̎"/POST"}
      (insert "/POST\n"))
     (t (insert "/E\n"))))            ;; "/E"}
  t)

(defun glog-set-mail-header-nifty (&optional postmode)
  ;; PostBufferNifty`[̔wb_}.
  ;; 'notitle Ȃ^Cgs}Ȃ 'noauthor ȂMlւ̈AȂ
  ;; ̎wlistΕZ߂Đݒł.
  ;; ex.
  ;;     (defun my-glog-set-mail-header ()
  ;;       (glog-set-mail-header (list 'notitle 'noauthor)))
  ;; 
  ;; Ȃ݂ɂ̊֐́Aʊ֐̃XR[v id,title,author,newfile 
  ;; QƂĂ

  ;; postmodenilłȂ΋Ilistɂ(̕]̈)
  (setq postmode (glog-force-list postmode))
  (setq title (glog-nifty-del-rerere title))  ;; ReReRe΍
  ;; VKۂcheck
  (if (not newfile)
      ;; VKłȂΑ}ȊO܂pointړ
      (progn
	(goto-char (point-min))
	(re-search-forward "^\\(\/[eE]\\|[pP][oO][sS][tT]\\)" nil t))
    ;; wb_}
    (goto-char (point-min))
    ;; MIDs('nosendidwȂ}Ȃ)
    (if (and (> (length id) 0)
	     (not (memq 'nosendid postmode)))
	(insert (format "TO:%s%s\n"
			;; WIDEoRȂ"INET:"t ('94.1.13)
			(if (string-match "@" id) "INET:" "")
			;; Reply-To: ΂mail '95.3.29
			(if replyto replyto id))))
    ;; titles('notitlew肷Α}Ȃ)
    (if (not (memq 'notitle postmode))
	(insert (format "SUB:%s\n"
			(if (> (length title) 0) title ""))))
    ;; Ml('noauthorw肷Α}Ȃ)
    (if (and (> (length author) 0)
	     (not (memq 'noauthor postmode)))
	(insert (format "  %s l\n\n" author))))
  t)

(defun glog-set-mail-terminator-nifty (&optional postmode)
  ;; PostBufferNifty`̔I}.
  (glog-set-post-terminator-nifty postmode)
  t)

(provide 'glog_nif)

;;; glog_nif.el ends here
