;; glog_pc.el: PC-VAN mode functions for GLOG.         -*-Emacs-Lisp-*-
;; Copyright (C) 1993-95 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
;; Thank's for `glog-match-string-forum' to Mr.Hurusawa.
;;
(defconst glog_pc "$Header: glog_pc.elv  1.28  95/08/04 00:11:32  Nam  Exp $")

(require 'glog)

(defun view-pcvan-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing PC-VAN's log.
  (fset 'glog-get-forum-name        (function glog-get-forum-name-pcvan))
  (fset 'glog-get-board-name        (function glog-get-board-name-pcvan))
  (fset 'glog-get-article-info      (function glog-get-article-info-pcvan))
  (fset 'glog-get-mail-info         (function glog-get-mail-info-pcvan))
  (fset 'glog-set-post-header       (function glog-set-post-header-pcvan))
  (fset 'glog-set-post-terminator   (function glog-set-post-terminator-pcvan))
  (fset 'glog-set-mail-header       (function glog-set-mail-header-pcvan))
  (fset 'glog-set-mail-terminator   (function glog-set-mail-terminator-pcvan))
  (fset 'glog-check-post            (function glog-undefined-function))
  (fset 'glog-correct-article       (function glog-undefined-function))
  (setq glog-match-string-forum
        "^\\(SIG \\)*[^ 0-9A-Z]+  \([0-9A-Z][ ,0-9A-Z]+\)$")
  (setq glog-match-string-board
	(concat "\\(" "^@[^ ]+@$"
		;; VINETNEWS(Ȃ󔒂pȂ T^T)
		"\\|" "^  [^ ]+  $"
		;; INETNEWS
		"\\|" "^[0-9a-z\\.]+j[XO[v \\[LF[ 0-9]+\\]$"
		"\\)"))
  (setq glog-match-string-article
	(concat "\\(" "^#[0-9]+/[0-9]+@"
		;; VINETNEWS
		"\\|" "^Article [0-9]+ ([0-9]+/[0-9]+) in [^ ]+:$"
		;; INETNEWS
		"\\|" "^From: [^ ]+"
		"\\)"))
  (setq glog-match-string-mail
        (concat "^#[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]         "
		"[0-9][0-9]/[0-9][0-9]/[0-9][0-9]    "
		"[0-9][0-9]:[0-9][0-9]:[0-9][0-9]$"))
  (setq glog-match-string-skip
        (concat "\\(" "^ [ 1-9][0-9]/ [ 1-9][0-9]$"
		"\\|" "^ [ 1-9][0-9]/ [ 1-9][0-9] .+ \([0-9]+\)"
;;		"\\|" "^ԍ܂̓R}h" "\\|" "^R}h="
		"\\)"))
  (setq glog-match-string-article-end
        (concat "\\(^ԍ܂̓R}h[<=(]"
		"\\|" glog-match-string-forum   "\\|" glog-match-string-board
		"\\|" glog-match-string-article "\\|" glog-match-string-mail
		"\\)"))
  (setq glog-match-string-mail-end
        (concat "\\(^ԍ܂̓R}h[<=(]"
		"\\|" glog-match-string-forum   "\\|" glog-match-string-board
		"\\|" "^#[0-9]+/[0-9]+@"       "\\|" glog-match-string-mail
		"\\)"))
  (setq glog-search-regexp
        (concat
	 "\\(" glog-match-string-forum   "\\|" glog-match-string-board
	 "\\|" glog-match-string-article "\\|" glog-match-string-mail
	 "\\)"))
  (setq glog-pcvan-inet-count 0)
  (run-hooks 'view-pcvan-mode-hook))


(defun glog-pcvan-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_pc)

(defun glog-get-forum-name-pcvan ()
  ;; JgsPC-VAN`̃tH[𓾂.
  (let ((linebuf (glog-get-current-line)))
    ;; " "match-endɂȂƁAptH[鎞Ɍ듮 '94.2.7
    (if (string-match "([0-9A-Z]+" linebuf)
	(substring linebuf (+ (match-beginning 0) 1) (match-end 0))
      nil)))

(defun glog-get-board-name-pcvan ()
  ;; JgsPC-VAN`̃{[h𓾂.
  (let ((linebuf (glog-get-current-line))(board nil)(foo)(bar))
    (cond
     ;; PC-VAÑ{[h̏ꍇ
     ((string-match "@" linebuf)
      (progn
	(setq foo (match-end 0))
	(if (setq bar (string-match "@" linebuf))
	    (setq board (substring linebuf foo bar)))))
     ;; VINETNEWS̏ꍇ(Ȃł킴킴󔒂𔼊pɕς>VAN)
     ((string-match "  " linebuf)
      (progn
	(setq foo (match-end 0))
	(if (setq bar (string-match "  " linebuf))
	    (setq board (substring linebuf foo bar)))))
     ;; InternetNews̏ꍇ
     ((string-match "^[0-9a-z\\.]+j[XO[v \\[LF[ 0-9]+\\]$"
		    linebuf)
      (progn
	(string-match "^[0-9a-z\\.]+" linebuf)
	(setq glog-current-subject (substring linebuf 0 (match-end 0)))))
     ;; Ɏsꍇ
     (t nil))
    board))

(defun glog-get-article-end-pcvan (lines)
  ;; 蓮ANZX̍s␳(O[n/m]Ε␳Jn)
  (save-excursion
    (let ((linebuf)(limit)(foo)(bar)(mpos)(blkno)(blkmax)(adplines)
	  (kanji-flag)(mc-flag))
      (setq adplines lines)  ;; ␳̍s
      ;; "^e$"̎̍s
      (setq mpos (point))
      (setq limit (glog-get-forward-line-position 19))
      (if (and (> lines 17)
	       (re-search-forward glog-match-string-skip limit 1))
	  ;; 17sȏŊ[n/m]RBmodeł͖̂ŕ␳Jn
	  (progn
	    ;; ܂Sŉł𒲂ׂ
	    (setq linebuf (glog-get-current-line))
	    (setq blkno   (string-to-int linebuf))
	    (setq blkmax  (string-to-int (substring linebuf 5)))
	    (if (and (= blkno 1) (< blkmax 20))
	        ;; ŏIł܂ŒT
		(progn 
		  (while (< blkno blkmax)
		    ;; ̍sƃR}hsǂmF
		    (forward-line)
		    (setq foo (glog-get-current-line))
		    (forward-line)
		    (setq bar (glog-get-current-line))
		    (if (or (> (length foo) 0)
			    (not (string-match "^ԍ܂̓R}h.*=$" bar)))
			;; ̍ssŖ,̎̃R}hs̓͂
			;; (CR)ȊOȂ, ̔͏ÎƂ
			(setq blkno blkmax)
		      ;; ̎[n/m]T
		      (setq limit (glog-get-forward-line-position 30))
		      (if (not
			   (re-search-forward glog-match-string-skip limit 1))
			  ;; TȂ,IƂ
			  (setq blkno blkmax)
			;; ܂Ŗڂ𒲂,AĖΔIƂ
			(setq linebuf (glog-get-current-line))
			(setq foo     (string-to-int linebuf))
			(setq bar     (string-to-int (substring linebuf 5)))
			(if (and (= foo (+ blkno 1)) (= bar blkmax))
			    ;; łAĂ, ݂̕łi߂Ď
			    (setq blkno foo)
			  ;; łAĖΈpƌȂđs邪,
			  ;; 啝ɍs𒴂Ăꍇ͋I
			  (if (> (+ lines 40) (count-lines mpos (point)))
			      (setq blkno blkmax))))))
		  ;; ␳̍sJEg
		  (setq adplines (- (count-lines mpos (point)) 1))))))
      ;; ␳̍sԂ
      adplines)))

(defun glog-get-article-info-pcvan ()
  ;; PC-VAN`mes̏𓾂.
  (let ((linebuf)(nextline)(pos)))
    (beginning-of-line)
    ;; Jnʒu
    (setq pos (point))
    ;; ܂2sobt@
    (setq linebuf (glog-get-current-line))
    (forward-line)
    (setq nextline (glog-get-current-line))
    ;; PC-VAÑ{[hINTERNETŏς
    (if (string-match "^#[0-9]+/[0-9]+@" linebuf)
	;; PC-VAÑ{[h̏ꍇ
	(glog-get-article-info-pcvan-sig pos linebuf nextline)
      ;; INTERNET`̏ꍇ
      (if (string-match "^Article" linebuf)
	  ;; VINETNEWS`
	  (glog-get-article-info-pcvan-inet pos linebuf nextline)
	;; INETNEWS`
	(glog-get-article-info-pcvan-inet-old pos linebuf nextline))))

(defun glog-get-article-info-pcvan-sig (pos &optional linebuf nextline)
  ;; PC-VAN`mes̏𓾂.
  (let ((yy)(ym)(dt)(foo)(bar)(date)(art-no)(com-no)(lines)(hlines)(id)(title))
    ;; ̐`FbN(2sڂp^[Ƀ}b`邩ۂ)
    (if (not (string-match
	      "^^Cg ([ 0-9A-Z]+)  [0-9][0-9]/[ 0-9][0-9]/[ 0-9][0-9]  [ 0-9][0-9]:[ 0-9][0-9]  ([ 0-9][ 0-9][0-9])$"
	      nextline))
	;; ǂpۂȂ
	nil
      ;; ǂ琳炵̂
      ;; ԍ
      (setq art-no (string-to-int (substring linebuf 1)))
      ;; {[h̊mF
      (string-match "^#[0-9]+/[0-9]+@" linebuf)
      (setq foo (substring linebuf (match-end 0)))
      (if (string-match " + \\*\\*\\* " foo)
	  ;; `*** Rg ***'Ă͂
	  (setq bar (substring foo 0 (match-beginning 0)))
	(setq bar foo))
      (setq foo (string-match "\\.[^.]+$" glog-current-subject))
      (if (equal bar (substring glog-current-subject (+ foo 1)))
	  ()
	;; current-subjectƈC
	(setq glog-current-subject
	      (concat (substring glog-current-subject 0 foo) "." bar)))
      ;; 2sڕ
      ;; ID擾
      (string-match "([0-9A-Z]+" nextline)
      (setq id (substring nextline
			  (+ (match-beginning 0) 1)(match-end 0)))
      ;; s
      (string-match "[0-9]+)$" nextline)
      (setq lines (string-to-int(substring nextline (match-beginning 0))))
      ;; t
      ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
      ;;  (ĕɎdĂ)
      (string-match ")  [ 0-9]+/" nextline)
      (setq yy (string-to-int
		(substring nextline (+ (match-beginning 0) 3)
			   (- (match-end 0) 1))))
      (string-match "/[ 0-9][0-9]/[ 0-9][0-9] " nextline)
      (setq ym (substring nextline (match-beginning 0)(match-end 0)))
      (string-match "[ 0-9][0-9]:[ 0-9][0-9]" nextline)
      (setq dt (substring nextline (match-beginning 0)(match-end 0)))
      ;; N␳date('38'ȑOȂ1900N)
      (setq date (format "%4d%s%s" (+ yy (if (> yy 39) 1900 2000)) ym dt))
      ;; ^Cg
      (forward-line)
      (setq title (glog-get-current-line))
      ;; Rg ('Res:---'-1)
      (setq com-no (glog-search-comment-root title))
      ;; "^e$"̎̍s
      (forward-line 2)
      ;; {̂܂ł̍swb_sƂ
      (save-excursion
	(glog-foward-empty-line)
	(setq hlines (count-lines pos (point))))
      ;; 蓮ANZX̍s␳
      (setq lines (glog-get-article-end-pcvan lines))
      (if (> lines 0) (forward-line lines))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (list art-no ?  title id "" date com-no pos (+ lines 4)
	    hlines 'board))))

(defun glog-get-article-info-pcvan-inet (pos &optional linebuf nextline)
  ;; PC-VAN`̐VInternetNews̏𓾂.
  (let ((foo)(bar) (art-no 0)(com-no -1)
	(ngroup nil)(subject "")(mesid nil)(addr "")(name "")(replyto nil)
	(idate nil)(gdate "")(lines 0)(hlines 0))
    ;; ̐`FbN(2sڂp^[Ƀ}b`邩ۂ)
    (if (not (string-match "^[A-Z][^ ]+: " nextline))
	;; ǂpۂȂ
	nil
      ;; ǂ琳炵̂ŁA܂ԍ擾
      (if (string-match " (" linebuf)
	  (setq art-no (string-to-int (substring linebuf (match-end 0)))))
      ;; newsgroup擾
      (if (string-match "[0-9]) in [^:]+:" linebuf)
	  (progn
	    (setq ngroup (substring linebuf (+ (match-beginning 0) 6)
				    (- (match-end 0) 1)))
	    ;; current-subjectƈC
	    (if (string= ngroup glog-current-subject)
		()
	      (setq glog-current-subject ngroup))))
      ;; wb_擾
      (glog-get-inethead-info)
      ;; Rg ('Re:---'-1 / ł͌Ȃ)
      (if (> (length subject) 0)
	  (setq com-no (glog-search-comment-root subject nil t)))
      ;; s
      (if (and (> lines 0) (> hlines 0))
	  (setq lines (+ 1 hlines 1 lines))
	;; "LINES:"ꍇ͑O
	(save-excursion
	  (forward-line)
	  (setq foo (glog-get-forward-line-position 500))
	  (re-search-forward glog-match-string-article-end foo 1)
	  (beginning-of-line)
	  (setq lines (count-lines pos (point)))))
      ;; {̂܂ł̍swb_sƂ
      (forward-line hlines)
      (glog-foward-empty-line)
      (setq hlines (count-lines pos (point)))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s  mesid replyto idate)
      (list art-no ?  subject addr name gdate com-no pos lines
	    hlines 'inews mesid replyto idate))))

(defun glog-get-article-info-pcvan-inet-old (pos &optional linebuf nextline)
  ;; PC-VAN`̋InternetNews̏𓾂.
  (let ((foo)(bar) (art-no 0)(com-no -1)
	(ngroup nil)(subject "")(mesid nil)(addr "")(name "")(replyto nil)
	(idate nil)(gdate "")(lines 0)(hlines 0))
    ;; ̐`FbN(2sڂp^[Ƀ}b`邩ۂ)
    (if (not (string-match "^Date: [ 0-9A-Za-z,:]+" nextline))
	;; ǂpۂȂ
	nil
      ;; ǂ琳炵As߂ăwb_̉
      (forward-line -1)
      (glog-get-inethead-info)
      ;; Rg ('Re:---'-1 / ł͌Ȃ)
      (if (> (length subject) 0)
	  (setq com-no (glog-search-comment-root subject nil t)))
      ;; ԍ͏d͖̂ƂĘAԂ
      (setq art-no
	    (setq glog-pcvan-inet-count (+ glog-pcvan-inet-count 1)))
      ;; s (ł"LINES:"̂őOȂƂȂ(T_T))
      (forward-line hlines)
      (setq foo (glog-get-forward-line-position 500))
      (re-search-forward glog-match-string-article-end foo 1)
      (beginning-of-line)
      (setq lines (count-lines pos (point)))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s  mesid replyto idate headerlines)
      (list art-no ?  subject addr name gdate com-no pos lines
	    hlines 'inews mesid nil idate))))

(defun glog-get-mail-info-pcvan ()
  ;; PC-VAN`MAIL̏𓾂.
  (let ((res nil) (linebuf) (foo)(limit) (yy)(ym)(dt) (pos)(art-no)(kind 'mail)
	(ngroup nil)(subject "")(mesid nil)(addr "")(name "")(replyto nil)
	(idate nil)(gdate "")(lines 0)(hlines 0))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; ԍ(5ɂȂ悤ɏ3͖. search-groupuniqɒ)
    (setq art-no (string-to-int (substring linebuf 4)))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕɎdĂ)
    (string-match "[0-9]+/" linebuf)
    (setq yy (string-to-int
	      (substring linebuf (match-beginning 0)(- (match-end 0) 1))))
    (string-match "/[ 0-9][0-9]/[ 0-9][0-9] " linebuf)
    (setq ym (substring linebuf (match-beginning 0)(match-end 0)))
    (string-match "[ 0-9][0-9]:[ 0-9][0-9]" linebuf)
    (setq dt (substring linebuf (match-beginning 0)(match-end 0)))
    ;; N␳date('38'ȑOȂ1900N)
    (setq gdate (format "%4d%s%s"
			(if (> yy 39) (+ yy 1900) (+ yy 2000)) ym dt))
    ;; MID
    (forward-line 2)
    (setq linebuf (glog-get-current-line))
    (if (string-match "^MҁF" linebuf)
	(progn
	  (string-match "[0-9A-Z]+" linebuf)
	  (setq foo (match-end 0)) ; idJnʒu
	  (setq addr (substring linebuf
				(match-beginning 0)(match-end 0)))
	  ;; obt@nhJnʒus[܂łɕύX
	  (setq linebuf (substring linebuf foo))
	  (if (string-match " +" linebuf)
	      (progn
		(setq name (substring linebuf (match-end 0)))
		;; nh΃VXe̕(^mail)ł͂Ȃ
		(setq res t)))))
    (if (not res)
	;; nĥŃVXe̕(^mail)|C
	nil
      ;; ^Cgs܂Ői߂
      (setq foo (glog-get-forward-line-position 200))
      (if (re-search-forward "^F" foo 1)
	  (progn
	    (setq linebuf (glog-get-current-line))
	    (string-match "^F" linebuf)
	    (setq subject (substring linebuf (match-end 0)))
	    (forward-line)))
      ;; {̂܂ŋs΂
      (forward-line)
      (glog-foward-empty-line)
      (setq hlines (count-lines pos (point)))
      ;; InterNetMailcheck(WIDE GATEΉ)
      (if (not (string-match "MHSX400" addr))
	  ;; InetMailȂ"F"܂łwb_sƂ
	  ()
	;; wb_擾
	(glog-get-inethead-info)
	(if (> hlines 0)
	    ;; {̂܂ł̍swb_sƂ
	    (save-excursion
	      (forward-line hlines)
	      (glog-foward-empty-line)
	      (setq hlines (count-lines pos (point)))))
	(if (string-match "@" addr)
	    ()
	  ;; AhX`"`(a)`"VANtoVAN"<`>"̏ꍇ
	  (save-excursion
	    (setq name "")
	    (setq limit (glog-get-forward-line-position 50))
	    (if (re-search-forward "^From:[ \t].*$" limit 1)
		(progn
		  (setq foo (buffer-substring
			     (+ (match-beginning 0) 6) (match-end 0)))
		  ;; `(a)'`@'(pc-vañ_TdlȂ̂)
		  (if (string-match "(a)" foo)
		      (setq addr (concat
				  (substring foo 0 (match-beginning 0))
				  "@"
				  (substring foo (match-end 0))))
		    (setq addr foo))
		  (if (not (string-match "<[^ ]+>" addr))
		      ()
		    (setq foo (+ (match-end 0) 2))
		    (if (< foo (length addr))
			(setq name (substring addr foo)))
		    (setq addr (substring addr (+ (match-beginning 0) 1)
					  (- (match-end 0) 1) )))))))
	;; "From:"s擪"INET#"폜
	(if (string-match "^INET#" addr)
	    (progn
	      (setq addr (substring addr (match-end 0)))
	      ;; InetMailȂ̂IMAIL(MHX400łNIFTY̏ꍇ̂)
	      (setq kind 'imail)))
	;; "Reply-To:"s擪"INET#"폜
	(if (and replyto (string-match "^INET#" replyto))
	    (setq replyto (substring replyto (match-end 0)))))
      ;; s (MAIL͍s\̂őOȂƂȂ(T_T))
      (setq foo (glog-get-forward-line-position 3000))
      (re-search-forward glog-match-string-mail-end foo 1)
      (beginning-of-line)
      (setq lines (count-lines pos (point)))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (if (eq kind 'imail)
	  (list art-no ?  subject addr name gdate -1 pos lines hlines kind
		mesid replyto idate)
	(list art-no ?  subject addr name gdate -1 pos lines hlines kind)))))

(defun glog-set-post-header-pcvan (&optional postmode)
  ;; PostBufferPC-VAN`̔wb_}.
  ;; 'notitle Ȃ^Cgs}Ȃ.
  ;; ex.
  ;;     (defun my-glog-set-post-header ()
  ;;       (glog-set-post-header 'notitle))
  ;;
  ;; ̊֐͏ʊ֐̃XR[v id,title,author,newfile QƂĂ

  ;; postmodenilłȂ΋Ilistɂ(̕]̈)
  (setq postmode (glog-force-list postmode))
  (goto-char (point-min))
  (if (and newfile (> (length title) 0) (not (memq 'notitle postmode)))
      (if (and mesno (> mesno 0)
	       (equal (glog-assoc-list 'openmode glog-post-data) 'article))
	  (insert (format "Re:%d>%s\n" mesno title))
	(insert (format "Re:%s\n" title)))))

(defun glog-set-post-terminator-pcvan (&optional postmode)
  ;; PostBufferPC-VAN`̔I\"..\"}.
  ;; 'noendmark w肷ΉȂ.
  ;; ex.
  ;;     (defun my-glog-set-post-terminator ()
  ;;       (if (eq glog-bbs-mode 'pcvan)         ;; pcvan̎Ȃ
  ;;           (glog-set-post-terminator 'noendmark)
  ;;         (glog-set-post-terminator)))

  ;; postmodenilłȂ΋Ilistɂ(̕]̈)
  (setq postmode (glog-force-list postmode))
  (goto-char (point-max))
  (if (re-search-backward "^\.\." nil t)
      ()  ;; obt@Ɋ".."tĂ̂ŉȂ
    ;; I[
    (if (not (bolp))
	(insert "\n"))
    (if (not (memq 'noendmark postmode))  ;; 'noendmark͉̎Ȃ
        (insert "..\n")))           ;; ".."}
  t)

(defun glog-set-mail-header-pcvan (&optional postmode)
  ;; PostBufferPC-VAN`[̔wb_}.
  ;; 'notitle Ȃ^Cgs}Ȃ 'noauthor ȂMlւ̈AȂ
  ;; ܂ 'cct98 ƂCCT-98̃}N\"atvan\"ɑΉ`ɂȂ.
  ;;
  ;; ̎wlistΕZ߂Đݒł.
  ;; ex.
  ;;     (defun my-glog-set-mail-header ()
  ;;       (glog-set-mail-header (list 'notitle 'noauthor)))
  ;;
  ;; ̊֐́Aʊ֐̃XR[v id,title,author,newfile QƂĂ
  (let ((sendid)(foo))
    ;; postmodenilłȂ΋Ilistɂ(̕]̈)
    (setq postmode (glog-force-list postmode))
    ;; WIDEoRȂIDoύX
    (setq sendid (if (not (string-match "@" id))
		     id
		   ;; Reply-To: ΂mail悤 '95.3.29
		   (concat "INET#" (if replyto replyto id))))
    ;; VKۂcheck
    (if (not newfile)
	;; VKłȂΑ}ȊO܂pointړ
	(progn
	  (goto-char (point-min))
	  (re-search-forward "^\.\." nil t))
      ;; wb_}
      (goto-char (point-min))
      ;; oid}('nosendidw肷Α}Ȃ)
      (if (> (length id) 0)
	  (cond
	   ((memq 'nosendid postmode)()) ;; 'nosendid Ȃ牽Ȃ
	   ((memq 'cct98 postmode)       ;; 'cct98 ȂIDs+"//"s}
	    (insert (format "%s\n//\n" sendid)))
	   (t	                         ;; ̑̏ꍇIDs+s}
	    (insert (format "%s\n\n" sendid)))))
      ;; titles('notitlew肷Α}Ȃ)
      (if (not (memq 'notitle postmode))
	  (insert (format "%s\n"
			  (if (> (length title) 0) (concat "Re:" title) ""))))
      ;; Ml('noauthorw肷Α}Ȃ)
      (if (and (> (length author) 0) (not (memq 'noauthor postmode)))
	  (insert (format "  %s l\n\n" author))))))

(defun glog-set-mail-terminator-pcvan (&optional postmode)
  ;; PostBufferPC-VAN`̔I}.
  (glog-set-post-terminator-pcvan postmode)
  t)

(provide 'glog_pc)

;;; glog_pc.el ends here
