;; glog_sun.el: Sunday-Net mode functions for GLOG.    -*-Emacs-Lisp-*-
;; Copyright (C) 1993-95 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
(defconst glog_sun "$Header: glog_sun.elv  1.16  95/07/26 22:29:58  Nam  Exp $")

(require 'glog)

(defun view-sunday-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing SundayNet's log.
  (fset 'glog-get-forum-name        (function glog-get-forum-name-sunday))
  (fset 'glog-get-board-name        (function glog-get-forum-name-sunday))
  (fset 'glog-get-article-info      (function glog-get-article-info-sunday))
  (fset 'glog-get-mail-info         (function glog-get-mail-info-sunday))
  (fset 'glog-set-post-header       (function glog-undefined-function))
  (fset 'glog-set-post-terminator   (function glog-set-post-terminator-sunday))
  (fset 'glog-set-mail-header       (function glog-set-mail-header-sunday))
  (fset 'glog-set-mail-terminator   (function glog-set-mail-terminator-sunday))
  (fset 'glog-check-post            (function glog-undefined-function))
  (setq glog-match-string-forum     "^BBS\-[0-9A-Z]+\-[^ \-]+ ")
  (setq glog-match-string-board     nil)
  (setq glog-match-string-article
	(concat "^[ 0-9][ 0-9][ 0-9][0-9]"      ;; VK{[h"   1"Ȃ̂
		" [a-z][a-z][a-z][0-9][0-9][0-9][0-9] .*"
		" [0-9][0-9]\/[01][0-9]\/[0123][0-9] [012][0-9]:[01-5][0-9] .*"
		" [0-9]+$"))
  (setq glog-match-string-mail
	(concat "^ [ \*][ 0-9]+ [a-z][a-z][a-z][0-9][0-9][0-9][0-9] .*"
		" [0-9][0-9]\/[01][0-9]\/[0123][0-9] "
		"[012][0-9]:[01-5][0-9]:[01-5][0-9] .*$"))
  (setq glog-match-string-skip      nil)
  (setq glog-match-string-article-end
        (concat "\\(" "^Break.."
		"\\|" "^< f̃Xg >$"
		"\\|" "^Vf[^͂܂B$"
		"\\|" "^MAIL\(\/7\) \(Write\,"
		"\\)"))
  (setq glog-search-regexp
        (concat "\\(" glog-match-string-forum
		"\\|" glog-match-string-article "\\|" glog-match-string-mail
		"\\)"))
  (run-hooks 'view-sunday-mode-hook))


(defun glog-sunday-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_sun)

(defun glog-get-forum-name-sunday ()
  ;; SundayNet`̃tH[𓾂.
  (let ((linebuf (glog-get-current-line))(board "misc")(forum "unknown"))
    (if (string-match "^BBS\-[0-9A-Z]+\-" linebuf)
	(setq forum
	      (substring linebuf (+(match-beginning 0)4) (-(match-end 0)1))))
    (if (string-match "\-[^ \-]+ " linebuf)
	(setq board
	      (substring linebuf (+(match-beginning 0)1) (-(match-end 0)1))))
    (setq glog-current-subject (downcase (concat forum "." board)))
    nil))

(defun glog-get-article-info-sunday ()
  ;; SundayNet`mes̏𓾂.
  (let ((art-no)(date)(lines)(id)(author)(title "")(com-no -1)
	(linebuf)(pos)(foo)(bar -1))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; ԍ
    (setq art-no (string-to-int linebuf))
    ;; ID擾
    (setq id (substring linebuf 5 12))
    ;; O擾
    (string-match "[0-9][0-9]/[01][0-9]/[0123][0-9] " linebuf)
    (setq author (substring linebuf 13 (match-beginning 0)))
    ;; s[̋󔒂菜
    (setq author (glog-delete-line-end-space author))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕŔr)
    (setq foo (string-to-int (substring linebuf (match-beginning 0))))
    (string-match "\/[ 0-9][0-9]\/[ 0-9][0-9] [ 0-9][0-9]:[ 0-9][0-9]"
		  linebuf)
    (setq date (substring linebuf (match-beginning 0)(match-end 0)))
    ;; N␳date('38'ȑOȂ1900N)
    (setq date (format "%4d%s" (+ foo (if (> foo 39) 1900 2000))
		       (substring linebuf (match-beginning 0)(match-end 0))))
    ;; ^CgJnʒufooɕۑ
    (setq foo (+ (match-end 0) 1))
    ;; s
    (if (string-match "[ ]+[0-9]+$" linebuf)
	(progn
	  (setq bar (match-beginning 0))
	  (setq lines (+ (string-to-int (substring linebuf bar)) 1))))
    ;; ^Cg
    (if (< foo bar) (setq title (substring linebuf foo bar)))
    ;; Rg ('xxxւ̃Rg'-1)
    (if (string-match "Re[0-9]+:" title)
	(setq com-no (string-to-int (substring title 2))))
    ;; `f̃Xg'ǂ`FbNAȂnilԂ
    (forward-line)
    (setq foo (glog-get-current-line))
    (if (string-match (concat "\\(^Vf[^͂܂B\\|"
			      glog-match-string-article "\\)") foo)
	;; s^Cgor"Vf[^..."Ȃ^Cgꗗ
	nil
      ;; fᖳ̂ŃXgɓZ߂
      (if (> lines 0) (forward-line lines))
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (list art-no ?  title id author date com-no pos lines 1 'board))))

(defun glog-get-mail-info-sunday ()
  ;; SundayNet`mail̏𓾂.
  (let ((art-no)(date "??/??/?? ??:??")(lines)(id)(author "unknown")(title "")
	(linebuf)(pos)(limit)(foo)(bar)(yy)(mm))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    ;; ܂1sobt@
    (setq linebuf (glog-get-current-line))
    ;; ԍ
    (setq art-no (string-to-int (substring linebuf 2)))
    ;; id擾
    (setq id (substring linebuf 6 13))
    ;; nh擾
    (if (string-match "[ ]+[0-9][0-9]\/[01][0-9]\/[0123][0-9] " linebuf)
	(setq author (glog-delete-line-end-space
		      (substring linebuf 14 (match-beginning 0)))))
    ;; NɃobt@ύX
    (if (string-match "[0-9][0-9]\/[01][0-9]\/[0123][0-9] " linebuf)
	(setq linebuf (substring linebuf (match-beginning 0))))
    ;; t
    ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
    ;;  (ĕŔr)
    (setq yy (string-to-int linebuf))
    (if (string-match
	 "[01][0-9]\/[0123][0-9] [012][0-9]:[01-5][0-9]:[01-5][0-9] "
	 linebuf)
	;; N␳date('38'ȑOȂ1900N)
	(setq date (format "%4d/%s" (+ yy (if (> yy 39) 1900 2000))
			   (substring linebuf (match-beginning 0)
				      (- (match-end 0) 1)))))
    ;; ^Cg
    (setq title (glog-delete-line-end-space (substring linebuf (match-end 0))))
    ;; sobt@
    (forward-line)
    (setq linebuf (glog-get-current-line))
    ;; `mail̃Xg'ǂ`FbNAȂnilԂ
    (if (string-match (concat "\\(" glog-match-string-mail
			      "\\|" "^MAIL\(\/7\) \(W" "\\)" ) linebuf)
	nil
      ;; XgɓZ߂
      ;; s (mail͍s\)
      (setq limit (glog-get-forward-line-position 4000)) ; search end point
      (re-search-forward glog-match-string-article-end limit 1)
      (forward-line -1)
      (setq lines (count-lines pos (point)))
      ;; XgɓZ߂
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (list art-no ?  title id author date -1 pos lines 1 'mail))))

(defun glog-set-post-terminator-sunday ()
  ;; PostBufferSundayNet`̔I}.
  (let ((p1 (progn (goto-char (point-max))(point)))
	(p2 (progn (beginning-of-line)(point))))
    (goto-char (point-max))
    (if (re-search-backward "^\.\.$" nil t)
        ()  ;; obt@Ɋ"."tĂ̂ŉȂ
      (if (/= p1 p2)
	  (progn
	    (goto-char (point-max))
	    (insert "\n")))
      (insert "..\n"))
    t))

(defun glog-set-mail-header-sunday ()
  ;; PostBufferSundayNet`̃[̔wb_}.
  ;; ͏ʂ̊֐̃XR[v, id,title,author,newfileQƂĂ
  (goto-char (point-min))
  (if newfile
      (progn
        (if (> (length author) 0)
	    (insert (format "  %s l\n\n" author))))))

(defun glog-set-mail-terminator-sunday ()
  ;; PostBufferSundayNet`̔I}.
  (glog-set-post-terminator-sunday)
  t)

(provide 'glog_sun)

;;; glog_sun.el ends here
