;; glog_tbs.el: Tokyo-BBS mode functions for GLOG.     -*-Emacs-Lisp-*-
;; Copyright (C) 1995 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
(defconst glog_tbs "$Header: glog_tbs.elv  1.1  95/08/23 22:08:02  Nam  Exp $")

(require 'glog)

(defun view-tbs-mode (&optional view-return-to-buffer)
  ;; Major mode for viewing Tokyo-BBS.
  (fset 'glog-get-forum-name        (function glog-undefined-function))
  (fset 'glog-get-board-name        (function glog-get-board-name-tbs))
  (fset 'glog-get-article-info      (function glog-get-article-info-tbs))
  (fset 'glog-get-mail-info         (function glog-undefined-function))
  (fset 'glog-set-post-header       (function glog-undefined-function))
  (fset 'glog-set-post-terminator   (function glog-undefined-function))
  (fset 'glog-set-mail-header       (function glog-undefined-function))
  (fset 'glog-set-mail-terminator   (function glog-undefined-function))
  (fset 'glog-check-post            (function glog-undefined-function))
  (setq glog-match-string-forum     nil)
  (setq glog-match-string-board
;;	"Sig[\-]*Name[ @\t]+[\\]*[0-9A-Z]+[\\][0-9A-Z\\]+")
	"Direct[\-]*Jump[ @\t:F]+@[0-9A-Z]+")
  (setq glog-match-string-article   "^No.==  Date==== Time== ")
  (setq glog-match-string-mail nil)
  (setq glog-match-string-skip      nil)
  (setq glog-match-string-article-end
	(concat "\\(" "^\033\\[m$" "\\|" "^\\^ LAST DATA \\^$" "\\)"))
  (setq glog-search-regexp
	(concat "\\(" glog-match-string-board
		"\\|" glog-match-string-article "\\)"))
  (run-hooks 'view-tbs-mode-hook))


(defun glog-tbs-version ()
  ;; elispversion(RCSwb_)Ԃ.
  glog_tbs)

(defun glog-get-board-name-tbs ()
  ;; Tokyo-BBS`SIG𓾂.
    (let ((linebuf (glog-get-current-line)))
;;      (if (string-match "[\\]*[0-9A-Z]+[\\]+[0-9A-Z\\]+" linebuf)
      (if (string-match "@[0-9A-Z]+" linebuf)
	  (setq glog-current-subject
		(substring linebuf (match-beginning 0) (match-end 0)))
	(setq glog-current-subject "Unknown.misc"))
      nil))

(defun glog-get-article-info-tbs ()
  "Tokyo-BBS`̃wb_𓾂."
  (let ((art-no)(date "")(lines)(id "")(author "")(title "")(hline 2)(art)
	(linebuf)(nline)(pos)(limit)(bbs nil)(btype "")(foo)(bar)(count 0))
    ;; Jnʒu
    (beginning-of-line)
    (setq pos (point))
    (forward-line)
    ;; ܂2sobt@
    (setq linebuf (glog-get-current-line))
    (forward-line)
    (setq nline (glog-get-current-line))
    ;; 
    (if (or
	 ;; sp^[Ėꍇ
	 (not (string-match
	       "^.*[0-9]+  [0-9][0-9]-[0-9][0-9]-[0-9][0-9] [0-9][0-9]:"
	       linebuf))
	 ;; V݂͖ꍇ
	 (string-match "^\\^ LAST DATA \\^$" linebuf)
	 ;; 폜̏ꍇ(2sڂArticlewb_)
	 (string-match glog-match-string-article nline)
	 ;; ^CgXgꍇ
	 (string-match
	  "^.*[0-9]+  [0-9][0-9]-[0-9][0-9]-[0-9][0-9] [0-9][0-9]:" nline))
	nil
      ;; ԍ
      (if (setq foo (string-match "[0-9]+ " linebuf))
	  (setq art-no (string-to-int (substring linebuf foo))))
      ;; ID & ^Cg
      (if (string-match "[0-9]:[0-9][0-9][ \*]+" linebuf)
	  (progn
	    (setq nline (substring linebuf (match-end 0)))
	    (if (string-match "[^ ]+ +" nline)
		(progn
		  (setq foo (match-end 0))
		  (setq id (glog-delete-line-end-space
			    (substring nline 0 foo)))
		  (setq title (glog-delete-line-end-space
			       (substring nline foo)))))))
      ;; t
      ;;  (emacs-lispint-max8388607Ȃ̂Őlł͔rȂ)
      ;;  (ĕŔr)
      (if (string-match
	   "[0-9][0-9]-[0-9][0-9]-[0-9][0-9] [ 0-2][0-9]:[0-9][0-9]"
	   linebuf)
	  (progn
	    ;; obt@(j)ttB[hJnʒuɕύX
	    ;; "95-07-27 15:13"Ȃ
	    (setq linebuf (substring linebuf (match-beginning 0)(match-end 0)))
	    ;; tN␳date('38'ȑOȂ1900N)
	    (setq foo (string-to-int linebuf))
	    (setq date
		  (format "%4d\/%2d\/%2d %5s"
			  (+ foo (if (> foo 39) 1900 2000))           ;; N
			  (string-to-int (substring linebuf 3))       ;; 
			  (string-to-int (substring linebuf 6))       ;; 
			  (substring linebuf 9 14)))))                ;; 
      ;; {̂܂ł̍swb_sƂ
      (save-excursion
	(glog-foward-empty-line)
	(setq hline (count-lines pos (point))))
      ;; s擾
      (setq limit (glog-get-forward-line-position 5000)) ; get search end point
      (save-excursion
	(re-search-forward glog-match-string-article-end limit 1)
	(beginning-of-line)
	(setq lines (- (count-lines pos (setq limit (point))) 1)))
      ;; (ԍ unread title id nh  Rg ʒu s
      ;;  wb_s )
      (list art-no ?  title id author date -1 pos lines hline 'board))))

(provide 'glog_tbs)

;;; glog_tbs.el ends here
