;; glog_utl.el: misc functions for GLOG.               -*-Emacs-Lisp-*-
;; Copyright (C) 1995 Namiki Seiko (Nam)
;; (E-mail: CAF58901@pcvan.or.jp, RGE01545@niftyserve.or.jp)
;;
;; Everyone is granted permission to copy, modify and redistribute,
;; but WITHOUT ANY WARRANTY.
;;
(defconst glog_utl "$Header: glog_utl.elv  1.4  95/06/07 12:14:34  Rel $")

(require 'glog)

;;
;;  Misc
;;

(defun glog-search-and-append-list (sexp &optional symbol)
  ;; Jgobt@ŎwSTÅJnʒuɃ|CgZbg.
  ;; Ȃꍇ̓obt@̍ŌɂSǉ.
  (let ((regexp)(s)(e))
    ;; ܂"(setq ...."T
    (setq regexp (format "^\[ \t]*([ \t]*setq[ \t]+%s" sexp))
    (goto-char (point-min))
    (if (re-search-forward regexp (point-max) t)
	()
      (goto-char (point-max))
      (insert (concat "\n(setq " sexp "\n      (list\n"
		      "       (list '" symbol "\n\t)\n       ))\n"))
      (goto-char (point-min))
      (re-search-forward regexp (point-max) t))
    ;; narrowing
    (beginning-of-line)
    (setq s (point))
    (forward-list 1)
    (beginning-of-line)
    (setq e (point))
    (narrow-to-region s e)
    ;; "  (list '..."T
    (setq regexp (format "^[ \t]*\([ \t]*list[ \t]+'%s" symbol))
    (goto-char (point-min))
    (if (re-search-forward regexp (point-max) t)
	()
      (goto-char (point-max))
      (insert (concat "       (list '" symbol "\n\t     )\n"))
      (goto-char (point-min))
      (re-search-forward regexp (point-max) t))
    ;; narrowing
    (beginning-of-line)
    (if (re-search-forward "\([ \t]*list" (glog-get-forward-line-position 1) t)
	(progn
	  (goto-char (match-beginning 0))
	  (setq s (point))
	  (forward-list 1)
	  (beginning-of-line)    
	  (setq e (point))
	  (goto-char s)
	  (forward-line)
	  (beginning-of-line)
	  (setq s (point))
	  (narrow-to-region s e)))))

(defun glog-add-cons-list (mode &optional liststr promptstr handle)
  ;; Get data and add to `_glogrc'
  (let ((cbuf (current-buffer))(confbuf)(prompt)(bbstype)(comment)(cancel nil)
	(mesno)(title)(id "")(author "")(com-no)(date)
	(mesid)(kind)(replyto)(idate))
     ;; .glogrc̃obt@擾
    (if (not (setq confbuf (glog-read-config-file)))
	;; .glogrc݂܂
	(progn
	  (message (format "There is no `%s'!" glog-config-file))
	  (ding))
      ;; .glogrcJg
      (set-buffer confbuf)
      (widen)
      ;; ftHgRgo^NɂĂ
      (setq date (current-time-string))
      (setq comment (format "'%s.%2d.%s"
			  (substring date 20 24)
			  (glog-month-to-int (substring date 4 7))
			  (substring date 8 10)))
      ;; BBSʂ`Ȃ͂
      (setq bbstype (if glog-bbs-type
			(symbol-name glog-bbs-type)
		      (setq prompt (format "%s BBS type: " promptstr))
		      (read-string prompt bbstype)))
      (if (or (eq mode 'id)(eq mode 'ML))
	  ;; ݕ\̔ԍ擾ԍɑΉLAzzŌ
	  (if (and glog-current-subject (setq mesno glog-current-article))
	      (glog-search-article-data mesno)))
      ;; ML̏ꍇ"Reply-To:"idƂ݂Ȃ
      (if (and (eq mode 'ML) (> (length replyto) 0))
	  (setq id replyto))
      ;; ID('board̎̓{[h)`Ȃ͂
      (if (> (length id) 0)
	  ()
	;; (IDo^ȊOȂ)ݕ\subject擾
	(setq id (if glog-current-subject
		     glog-current-subject
		   (glog-Group-get-subject-name)))
	(setq prompt (format "%s %s: " promptstr
			     (if (or (eq mode 'id)(eq mode 'ML))
				 "ID" "Subject")))
	(setq id (read-string prompt id)))
      ;; ̕ϐST[`
      (glog-search-and-append-list liststr bbstype)
      ;; wido^ۂcheck
      (goto-char (point-min))
      (if (not (re-search-forward (format "\"%s\"" id) (point-max) t))
	  (goto-char (point-max))
	;; Ɏwidœo^ςȂAw肵Ȃۂ₢킹
	(setq prompt (format "[%s] already registed. Re-do it?" id))
	(if (not (y-or-n-p prompt))
	    (setq cancel t)
	  ;; ܂Ânh擾
	  (save-excursion
	    (if (re-search-forward "\"[^\"]+\""
				   (glog-get-forward-line-position 1) t)
		(setq author (buffer-substring
			      (+ (match-beginning 0) 1) (- (match-end 0) 1)))))
	  ;; ɌÂRg擾
	  (save-excursion
	    (if (re-search-forward ";; .*$"
				   (glog-get-forward-line-position 1) t)
		(setq comment (buffer-substring
			       (+ (match-beginning 0) 2) (match-end 0)))))))
      ;; LZȂΎs
      (if cancel
	  ;; LZꂽ烁bZ[WsďI
	  (message "")
	;; cdr(nh/{[h/...)͂
	(cond
	 ((eq mode 'id)
	  (setq prompt (format "%s[%s]'s handle name: " promptstr id)))
	 ((eq mode 'ML)
	  (setq prompt (format "%s ML name: " promptstr)))
	 (t
	  (setq prompt "String: ")))
	(if (and (not handle) (not (eq mode 'ML)))
	    (setq handle (if (string-equal id author) "" author)))
	(if (not (eq mode 'fname))
	    (setq handle (read-string prompt handle))
	  ;; 'fnameȂt@C
	  (setq handle (glog-require-file-name "Save file name" handle
					       glog-save-directory nil nil)))
	;; Rg͂
	(if (or (eq mode 'id)(eq mode 'ML)(eq mode 'fname))
	    (setq comment (read-string "Input comment: " comment))
	  (setq comment ""))
	;; obt@ɏ
	(glog-delete-current-line)      ;; o^s폜
	(insert (concat "\t     '(\"" id "\" . \"" handle "\")"
			(if (> (length comment) 0) (concat "\t;; " comment))
			"\n"))
	(widen)
	(eval-current-buffer)))
    ;; e|obt@j
    (set-buffer cbuf)))

(defun glog-add-handle-list (&optional handle)
  "Get handle name and add to `_glogrc'"
  (interactive)
  (glog-add-cons-list 'id "glog-handle-list" "*nho^*" handle))

(defun glog-add-purge-list (&optional handle)
  "Get handle name and add to `_glogrc'"
  (interactive)
  (glog-add-cons-list 'id "glog-purge-id-list" "*\IDo^*" handle))

(defun glog-add-search-regexp-list (&optional str)
  "Get handle name and add to `_glogrc'"
  (interactive)
  (glog-add-cons-list 'board "glog-search-regexp-list" "*o^*" str))

(defun glog-add-purge-subject-list (&optional str)
  "Get subject name and add to `_glogrc'"
  (interactive)
  (glog-add-cons-list 'board "glog-purge-subject-list" "*\{[ho^*" str))

(defun glog-add-savearticle-list (&optional str)
  "Get save file-name and add to `_glogrc'"
  (interactive)
  (glog-add-cons-list 'fname "glog-savearticle-list" "*ۑt@Co^*" str))

(defun glog-add-ML-list (&optional str)
  "Get ML name and add to `_glogrc'"
  (interactive)
  (glog-add-cons-list 'ML "glog-ML-list" "*MLo^*" str))

(defun glog-Info-find-node ()
  "Function of GLOG. Find documentation of GLOG and show page."
  (interactive)
  (let (inode)
    (if (setq inode (assq major-mode glog-Info-nodes))
	(progn
	  (glog-pause 'save)  ;; resumeł悤window-listZ[u܂
	  (select-window (get-largest-window))
	  (require 'info)
	  (Info-goto-node (cdr inode))
	  (message "[M-x glog-resume] to return GLOG.")))))

(defun glog-require-bbs-type (&optional msg)
  ;; BBSʂ̑SXg\Ďw肳. BBSʂstrԂ.
  ;; 'msg'ݒ肳Ă΃XgEBhD̍ŏɕ\.
  (let ((cbuf (current-buffer))(tmpbuf)(clist nil)(count 0)(bbs)(name)(type))
    ;; `glog-init'ĂȂ΃obt@
    (glog-init)
    (setq tmpbuf (generate-new-buffer "*BBS LIST*"))
    (set-buffer tmpbuf)
    (if msg (insert (format "%s\n" msg)))
    (insert "  ---type---    ------ BBS NAME ------\n")
    ;; alist쐬 (`glog-bbs-list'ɓo^ꂽJԂ)
    (while (setq bbs (nth count glog-bbs-list))
      (setq name (symbol-name (nth 0 bbs)))
      (insert (format "  %10s    %s\n" name (nth 1 bbs)))
      (setq clist (nconc clist (list (cons name count))))
      (inc count))
    ;; BBS̓(⊮L)
    (save-window-excursion
      (pop-to-buffer tmpbuf)
      (set-window-start (selected-window) 0)
      (setq name (completing-read "Input BBS type: " clist nil t ""))
      ;; e|j
      (delete-windows-on tmpbuf)
      (buffer-flush-undo (current-buffer))
      (kill-buffer tmpbuf))
    (set-buffer cbuf)
    (if (and (> (length name) 0)
	     (setq type (intern name))
	     (setq glog-bbs-type
		   (glog-set-bbs-function type (format "Force to %s" type))))
	name
      (setq glog-bbs-type nil))))

(defun glog-force-bbs (&optional buf)
  "IɓBBSݒ肷"
  (interactive)
  (let ((msg nil)(name nil))
    (if (not (interactive-p))
	(setq msg (concat "** ςFɎs܂ ^^;  "
			  "x蓮BBStype͂ĉ **")))
    (if (setq name (glog-require-bbs-type msg))
	(progn
	  (glog-message (format "GLOG: `%s'Ƃčĉ͒" name))
	  (if glog-refer-buffer             ; LOGǂݍ񂾃obt@
	      (set-buffer glog-refer-buffer)
	    (setq glog-refer-buffer (current-buffer)))
	  (setq glog-subject-list nil)      ; ^CgXg
	  (glog-Group-show-info "Searching title list"
				(nth 1 (assoc glog-bbs-type glog-bbs-list)))
	  (glog-Group-search-group)         ; ^Cg
	  (if glog-sort-subject
	      (glog-Group-sort-group))      ; O[vXg̃\[g
	  (glog-Group-make-group)))         ; O[vXg̍쐬
    (if glog-subject-list
	(glog-Group-describe-briefly) ; show help
      ;; ⃁[̂view-modeN
      (if buf
	  (progn
	    (glog-kill)
	    (switch-to-buffer buf))
	(glog-kill glog-read-buffer)
	(switch-to-buffer glog-read-buffer)
	(setq buffer-read-only t))
      (message "GLOG: No articles. Use view mode.")
      (view-mode))))

(defun glog-save-all-article ()
  "ݓǂłLOĜ, glog-savearticle-listɓo^Ăsubject
ۑ.(//\ɂ炸)"
  (interactive)
  (let ((cwin (selected-window)) (i 0) (sub) (res) (resbuf)(res2)(pos)(posend))
    (if (not glog-subject-list)
	(progn
	  (glog-message "GLOG: LOGX")
	  nil)
      ;; ʂ\buffer쐬
      (if (interactive-p)
	  (progn
	    (setq resbuf (get-buffer-create "*Help*"))
	    (set-buffer resbuf)
	    (setq buffer-read-only nil)
	    (erase-buffer)
	    (insert "*** Saved articles ***\n")
	    (setq res2 (generate-new-buffer "*GLOG: not saved*"))
	    (set-buffer res2)
	    (insert "\n*** Not saved articles ***\n")))
      (while (setq sub (car (nth i glog-subject-list)))
	(setq res (glog-Subject-save-all-article sub))
	(if (interactive-p)
	    (if (> res 0)
		(progn
		  (set-buffer resbuf)
		  (insert (format "%s\t-> %d\n" sub res)))
	      (set-buffer res2)
	      (insert (format "%s\n" sub))))
	(inc i))
      ;; ʂ\
      (if (interactive-p)
	  (progn
	    (set-buffer res2)
	    (setq pos (point-min))
	    (setq posend (point-max))
	    (set-buffer resbuf)
	    (insert-buffer-substring res2 pos posend)
	    (setq pos (point-min))
	    (pop-to-buffer resbuf)
	    (set-window-start (selected-window) pos)
	    (kill-buffer res2)
	    (glog-message "GLOG: Type C-x 1 to remove help window.")
	    (select-window cwin)))
      t)))

(defun glog-batch-view ()
  ;; R}hCŎw肳ꂽLOG𕪐͂\. IEmacskill.
  ;; ex.
  ;;     # mule -f glog-batch-view ~/log/sugekoma.log
  (let ((fname (car command-line-args-left)))
    ;; make buffers and init variables
    (glog-init)
    (setq glog-batch-flag t)
    ;; show title
    (if (and (not glog-quiet-mode) glog-startup-message)
	(glog-startup-message))
    (if (file-exists-p fname)
	(progn
	  (glog-view-file-mode fname)
	  (recursive-edit))
      (glog-message (format "`%s'Ȃăt@CX(;;)" fname))
      (sit-for 3)
      (kill-emacs 0))))

(defun glog-batch-save ()
  ;; R}hCŎw肳ꂽLOG, _glogrcŒ`ꂽ{[hZ[u.
  ;; IEmacskill.
  ;; ex.
  ;;     # mule -f glog-batch-save ~/log/sugekoma.log ~/log/matuzawa.log
  (let ((i 0)(foo)(fname))
    (glog-init)
    (while (setq foo (nth i command-line-args-left))
      (setq fname (expand-file-name foo))
      (if (not (file-exists-p fname))
	  (glog-message (format "`%s'Ȃăt@CX(;;)" foo))
	(glog-kill)
	(glog-view-file-mode fname)
	(glog-save-all-article))
      (inc i))
    (if (not (interactive-p))
	(kill-emacs 0))))

;;
;;  Group mode
;;

(defun glog-Group-catch-up (&optional subject)
  "wsubjectǗɐݒ肷"
  (interactive)
  (let ((cbuf (current-buffer))(subcons)(subcdr)(art)(count 0))
    (if (glog-set-buffer glog-Group-buffer)
	(progn
	  ;; interactiveɌĂ΂ꂽȂsėǂmF
	  (if (and (interactive-p)
		   (y-or-n-p "Do you really want to catch up this subject? "))
	      (setq subject (glog-Group-get-subject-name)))
	  ;; wsubject݂
	  (if (and subject
		   (setq subcons (assoc subject glog-subject-list))
		   (setq subcdr (cdr subcons)))
	      (progn
		(while (setq art (nth count subcdr))
		  ;; XgɓǗ}[Nt
		  (glog-article-set-unread art ?d)
		  (inc count))
		(glog-Group-update-group subject)))
	  (set-buffer cbuf)))
    (glog-message "")))

(defun glog-Group-catch-up-all ()
  "SsubjectǗɐݒ肷"
  (interactive)
  (let ((i 0)(subject))
    ;; interactiveɌĂ΂ꂽȂsėǂmF
    (if (or (not (interactive-p))
	    (y-or-n-p "Do you really want to catch up all subject? "))
	(progn
	  (while (setq subject (car (nth i glog-subject-list)))
	    (glog-message subject)
	    (glog-Group-catch-up subject)
	    (inc i))
	  (message "Done."))
      (message ""))))

(defun glog-Group-save-all-article (&optional subject)
  "JgTuWFNg̑SĂ̔ۑ.(//\ɂ炸)
`subject'w肳Ă, ̃TuWFNg̑S.
  Z[uԂ."
  (interactive)
  (let ((cbuf (current-buffer))(res 0))
    ;; Jgssubject擾
    (glog-set-buffer glog-Group-buffer)
    (setq subject (glog-Group-get-subject-name))
    (setq res (glog-Subject-save-all-article subject t))
    (if (interactive-p)
	(glog-message (format "GLOG: %s ... %d saved." subject res)))
    (set-buffer cbuf)
    res))

(defun glog-Group-reset-unread-subject (subject)
  ;; Internal Function of `glog-Group-find-regexp'.
  ;; wsubject̑SL𖢓ǂɍĐݒ. (SLԂ.)
  (let ((sub)(sub-list)(art)(count 0))
    ;; search assoc by `subject' to getting pair's cdr
    (if (and (listp glog-subject-list)
	     (setq sub (assoc subject glog-subject-list))
	     (consp sub))
	;; check subject
	(progn
	  (setq sub-list (cdr sub))
	  ;; loop subject to end
	  (while (setq art (elt sub-list count))
	    (if (eq (glog-article-info-unread art) ?d)
		(glog-article-set-unread art ? ))
	    (inc count))
	  count)
      nil)))

(defun glog-Group-find-regexp (str)
  "K\Ŏw肳ꂽŋL, hitgroup݂̂\.
(\ꂽgroup̑SL͖ǂɍĐݒ肳. ܂\ݒ.)
`glog-search-regexp-list'Ă܂̂Œӂ邱."
  (interactive "sFind string :")
  (let ((count 0)(sub))
    (if (not (listp glog-subject-list))
	;; No unread news
	(glog-message "No news.")
      ;; get empty buffer
      (set-buffer glog-Group-buffer)
      (setq truncate-lines t)               ; stop line folding
      (setq buffer-read-only nil)
      (erase-buffer)
      ;; list
      (setq glog-search-regexp-list
	    (list (list glog-bbs-type (cons "all" str))))
      ;; insert board names
      (while (setq sub (car (nth count glog-subject-list)))
	;; Ε\
	(if (glog-Group-search-regexp-subject sub)
	    (insert (format "%7d:*%s\n"
			    (glog-Group-reset-unread-subject sub) sub)))
	(inc count))
      ;; Adjust cursor point.
      (goto-char (point-min))
      (re-search-forward glog-regexp-group-line nil t)
      (setq buffer-read-only t)
      (set-buffer-modified-p nil)
      ;; GroupEBhD\
      (glog-configure-windows '(1 0 0 0) glog-Group-buffer)
      (glog-message "`M-x glog-Group-make-group' to show all group."))))

;;
;;  Subject mode
;;

(defun glog-Subject-yax-article (&optional article)
  "Function of GLOG. run `yax' with current Article."
  (interactive)
  (require 'yax)
  (let ((c-art glog-current-article)(count 0)(marklist)(sub)(mesno))
    ;; ܂}[N邩ۂׂ
    (setq marklist (glog-Subject-make-marklist (glog-mark-char 'mark)))
    (if (not marklist)
	;; }[N΃Jg̋Lĕ\Ayax
	(progn
	  (glog-Subject-show-page (if article
				      article
				    glog-current-article))
	  (yax-buffer glog-Article-buffer))
      ;; }[NꂽLyax
      (setq mesno (assoc glog-current-subject glog-subject-list))
      (setq sub (cdr mesno))
      (while (setq mesno (nth count marklist))
	(if (not (assq mesno sub))	;; vԍ̋L
	    ()
	  (glog-Subject-show-page mesno)
	  (yax-buffer glog-Article-buffer))
	(inc count))
      ;; }[NNA
      (glog-Subject-clear-marks (glog-mark-char 'mark))
      ;; Ōglog-current-articleĕ\
      (setq glog-current-article c-art)
      (glog-Article-show-article glog-current-article))))

(defun glog-Subject-save-all-article (&optional subject fnamep)
  "JgTuWFNg̑SĂ̔ۑ.(//\ɂ炸)
`subject'w肳Ă, ̃TuWFNg̑S.
  Z[uԂ.
  `fnamep'`t'Ȃ, interactivełȂƂt@C̖₢킹.

  ̕⏕ׂ̈`glog-Subject-save-all-article-fname-hook'
`glog-Subject-save-all-article-show-hook'."
  (interactive)
  (let ((cbuf (current-buffer))
	(csub glog-current-subject)(cart glog-current-article)
	(sub nil) (savename nil) (i 0) (res 0)
	(art)(pos)(posend)(lines) (foo)(bar) (tart)(tartp))
    (save-window-excursion
      ;; articleobt@̕ی
      (set-buffer glog-Article-buffer)
      (setq tartp (point))
      (setq tart (generate-new-buffer "*org article*"))
      (copy-to-buffer tart (point-min) (point-max))
      ;; subjectw肳Ă, ̃TuWFNg
      (if (not subject)
	  (setq subject glog-current-subject))
      (glog-Subject-sort-article subject)
      ;; 'subject'ŘAzzAΉsubjectlist(yAcdr)擾
      (if (setq foo (assoc subject glog-subject-list))
	  (setq sub (cdr foo)))
      ;; ǂ߂Lꍇ
      (if (and (not sub) (interactive-p))
	      (message (format "GLOG: No readable article.")))
      ;; Z[uXg, Z[ut@C擾
      (setq foo (glog-assoc-list glog-bbs-type
				 glog-savearticle-list (list (list nil))))
      (if (setq bar (assoc subject foo))
	  (setq savename (cdr bar)))
      ;; run save article hook
      (setq glog-current-subject subject)
      (run-hooks 'glog-Subject-save-all-article-fname-hook)
      ;; Z[uo^Ė, interactive-pȂZ[u
      (if (and sub (not savename) (or (interactive-p) fnamep))
	  (setq savename (glog-require-file-name
			  "Save file name" nil glog-save-directory nil nil)))
      ;; ǂ߂LL, Z[uw肳ĂΏJn
      (if (not (and sub savename))
	  ()
	(while (setq art (nth i sub))
	  (setq pos   (glog-article-info-pos   art))
	  (setq lines (glog-article-info-lines art))
	  ;; check
	  (if (or (< lines 0) (not (glog-set-buffer glog-refer-buffer)))
	      ()
	    ;; read from refer-buffer
	    (save-excursion
	      (goto-char pos)
	      (forward-line lines)
	      (setq posend (point)))
	    ;; write to article-buffer
	    (glog-set-article-buffer)
	    (setq buffer-read-only nil)
	    (erase-buffer)
	    (glog-set-buffer glog-refer-buffer)
	    (copy-to-buffer glog-Article-buffer pos posend)
	    ;; run save article show hook
	    (setq glog-current-article art)
	    (run-hooks 'glog-Subject-save-all-article-show-hook)
	    ;; LZ[u
	    (glog-Subject-save-article savename t)
	    (inc res))
	  (inc i)))
      (if (interactive-p)
	  (glog-message (format "GLOG: %d saved." res)))
      ;; articleobt@𕜋A
      (setq glog-current-article cart)
      (set-buffer glog-Article-buffer)
      (setq buffer-read-only nil)
      (erase-buffer)
      (set-buffer tart)
      (copy-to-buffer glog-Article-buffer (point-min) (point-max))
      (kill-buffer (current-buffer))
      (set-buffer glog-Article-buffer)
      (set-buffer-modified-p nil)
      (buffer-flush-undo (current-buffer))
      (goto-char tartp))
    (setq glog-current-subject csub)
    (set-buffer cbuf)
    res))

;;
;;  Post mode
;;

(defun glog-make-Post-mode-keymap ()
  ;; Make local key map for Post mode in GLOG.
  (if glog-Post-mode-map
      ()
    (setq glog-Post-mode-map (make-keymap))
  (define-key glog-Post-mode-map "\C-cW"    'glog-Post-widen-buffer)
  (define-key glog-Post-mode-map "\C-cR"    'glog-Post-show-reference)
  (define-key glog-Post-mode-map "\C-cy"    'glog-Post-quote-from-article)
  (define-key glog-Post-mode-map "\C-cY"    'glog-Post-copy-from-article)
  (define-key glog-Post-mode-map "\C-c\C-y" 'glog-Post-set-quote-string)
  (define-key glog-Post-mode-map "\C-ch"    'glog-add-handle-list)
  (define-key glog-Post-mode-map "\C-c\C-h" 'glog-add-purge-list)
  (define-key glog-Post-mode-map "\C-cs"    'glog-add-search-regexp-list)
  (define-key glog-Post-mode-map "\C-cp"    'glog-Post-set-signature)
  (define-key glog-Post-mode-map "\C-xk"    'glog-kill-buffer)
  (define-key glog-Post-mode-map "\C-c\C-q" 'glog-Post-quit)
  (define-key glog-Post-mode-map "\C-x\C-s" 'glog-Post-save-article)
  (define-key glog-Post-mode-map "\C-c\C-c" 'glog-Post-exit)
  (define-key glog-Post-mode-map "\C-c!"    'glog-pause)
  (define-key glog-Post-mode-map "\C-c="    'glog-Post-show-ruler)
  (define-key glog-Post-mode-map "\C-c?"    'glog-Post-describe-briefly)
  (define-key glog-Post-mode-map "\C-c\C-i" 'glog-Info-find-node)
))

(defun glog-Post-mode ()
  "Function of GLOG.
\\{glog-Post-mode-map}"
  (interactive)
  (set-buffer glog-Post-buffer)
  (setq buffer-read-only nil)
  (buffer-enable-undo)
  (setq major-mode 'glog-Post-mode)
  (setq mode-name "Post")
  (setq mode-line-buffer-identification "GLOG")
  (setq mode-line-process nil)
  (glog-make-Post-mode-keymap)
  (use-local-map glog-Post-mode-map)
  (make-local-variable 'glog-post-data)
  (setq parse-sexp-ignore-comments t)
  ;; hookΎs
  (run-hooks 'glog-Post-mode-hook))

(defun glog-Post-set-mode-line (&optional title)
  ;; post-buffermode-lineɏݒ
  (let ((cbuf (current-buffer)))
    (if (glog-set-buffer glog-Post-buffer)
	(setq mode-line-buffer-identification (concat "GLOG: " title)))
    (set-buffer cbuf)))

(defun glog-Post-set-post-buffer (&optional mode reply)
  "Function of GLOG. Set post buffer.
Ăяo̊֐̃XR[v(mesno)(title)(id)(author)(com-no)(date)Q.

mailing-listΉ(kind)(mesid)(replyto)(iidate)Q  '95.3.31"
  (interactive)
  (let ((c)(tmpbuf)(longname)(newfile t))
    ;; PƂpostꍇBBSʂݒ肵AΉ̐ݒǂݍ
    (if glog-bbs-type
	()
      (glog-require-bbs-type "*** POSTBBSʂ͂Ă ***"))
    ;; post-buffer͂?
    (if (not (get-buffer glog-Post-buffer))
	(glog-set-post-buffer))
    ;; post-buffer̓Z[uĂ?
    (if (buffer-modified-p (get-buffer glog-Post-buffer))
	;; post-bufferZ[uĂȂ
	(progn
	  (setq c 1)
	  (while (and (setq tmpbuf (format "%s.%02d" glog-Post-buffer c))
		      (get-buffer tmpbuf))
	    (inc c))
	  (set-buffer glog-Post-buffer)
	  (buffer-flush-undo (current-buffer))
	  (condition-case ()    ;; driveύXĂۂerror-trap
	      (progn
		(rename-buffer tmpbuf)
		(buffer-enable-undo tmpbuf))
	    (error (message "")))
	  (glog-set-post-buffer)))
    ;; post-buffer
    (set-buffer glog-Post-buffer)
    (setq buffer-read-only nil)
    (erase-buffer)
    (set-buffer-modified-p nil)
    (buffer-flush-undo (current-buffer))
    (buffer-enable-undo (current-buffer))
    (setq buffer-file-name nil)
    ;; I[v̌`ۑ
    (setq glog-post-data
	  (list (cons 'subject  glog-current-subject)
		(cons 'mesno    mesno)
		(cons 'title    title)
		(cons 'id       id)
		(cons 'author   author)
		(cons 'com-no   com-no)
		(cons 'date     date)
		(cons 'newfile  t)
		(cons 'mesid    mesid)
		(cons 'kind     kind)    ;; L('board/'mail/'inews/'imail)
		(cons 'replyto  replyto)
		(cons 'idate    idate)
		(cons 'openmode mode)))  ;; 'signaturenilȂ̂ŕtȂ
    ;; glog-interactive-post-namenin-nilȂ
    ;; ŏpostt@C͂
    ;; ꂪt@CȂobt@ɓǂݍ
    (if glog-interactive-post-name
	(progn
	  ;; postt@C₢킹
	  (setq glog-post-file-name (glog-require-file-name
				     "Post file" glog-post-file-name
				     glog-post-directory nil nil))
	  (setq longname (expand-file-name glog-post-file-name))
	  (if (file-readable-p longname)
	      (progn
		(insert-file-contents longname)
		;; signature͊ɗL镨ƂĎǉȂ
		(setq glog-post-data
		      (glog-set-list (cons 'signature t) glog-post-data))
		(setq glog-post-data
		      (glog-set-list 'newfile glog-post-data))
		(setq newfile nil)))
	  ;; buffervisitglog-post-file-nameɕύX
	  ;; set-visited-file-nameg,Ȃʃobt@ɂĂ܂
	  ;;   buffer-file-nameɒڃt@CĂ܂(T-T)
	  (setq buffer-file-name glog-post-file-name)
	  (set-buffer-modified-p nil)))
    ;; window ݒ
    (if glog-current-subject
	(glog-configure-windows 'PostNews glog-Post-buffer)
      ;; current-subjectΒPƏƂ݂ȂPostBuffer݂̂\
      (glog-configure-windows 'PostNewsNoReference glog-Post-buffer))
    (glog-Post-describe-briefly)
    ;; title ݒ
    (if (not title)
	(glog-Post-set-mode-line "Post")
      (setq c (glog-delete-long-space title))
      (glog-Post-set-mode-line (format "Reply for [%s]" c)))
    ;; L̓eptŃy[Xg
    (if (eq reply 'with-original)
	(glog-Post-copy-from-article-and-paste 'all t))
    ;; 
    (set-buffer glog-Post-buffer)
    (goto-char (point-min))
    ;; mode'articleŁALinetmail̎
    ;; mailing-listƌȂmode'mailɂ
    (if (and (eq mode 'article) (eq kind 'imail))
	(setq mode 'mail))
    ;; LmailȂALԍNA
    (if (eq kind 'mail)
	(setq mesno 0))
    ;; modeɉăwb_t
    (cond
     ((eq mode 'article)
      (if (fboundp 'my-glog-set-post-header)
	  ;; [U[`̃wb_t֐L΂s
	  (my-glog-set-post-header)
	(glog-set-post-header)))
     ((eq mode 'mail)
      (if (fboundp 'my-glog-set-mail-header)
	  ;; [U[`̃[wb_t֐L΂s
	  (my-glog-set-mail-header)
	(glog-set-mail-header)))
     (t
      ()))
    ;; ܂ł̕񑀍autosaveȂ悤ɂ
    (set-buffer-modified-p nil)))

(defun glog-set-post-buffer ()
  ;; Post-buffer݂ȂΏA݂΃Jgobt@ɃZbg
  (if (get-buffer glog-Post-buffer)
      (set-buffer glog-Post-buffer)
    (progn
      (get-buffer-create glog-Post-buffer)
      (set-buffer glog-Post-buffer)
      ;; o͂銿R[hݒ
      (if (and (boundp 'MULE)
	       (boundp 'glog-file-coding-system-for-post))
	  (set-file-coding-system glog-file-coding-system-for-post)))
    (glog-Post-mode)))

(defun glog-Post-set-quote-string (str)
  "pύX"
  (interactive "sQuote string :")
  (if (> (length str) 0)
      (setq glog-quote-string str)))

(defun glog-Post-insert-quote (pbuf &optional ps pe)
  ;; Function of GLOG. insert quoted-string.
  ;; ȉ͂̕ꂼꌳ̑Ήf[^ɒu.
  ;; `#MESNO#'ԍ, `#COMNO#'Rgԍ,
  ;; `#TITLE#'^Cg, `#ID#'id, #AUTHOR#Җ(nh),
  ;; `#MESID#'MessageId:tB[h,      `#IDATE#'Date:tB[h
  (let ((mesno)(title)(id)(author)(com-no)(date)(mesid)(kind)(replyto)(idate)
	(rs)(re)(quote nil))
    ;; ݕ\articleԍ擾ł, ΉLAzzŌ
    (glog-search-article-data)
    ;; [̏ꍇ͔ԍ͖
    (if (string= glog-current-subject ".mail") (setq mesno nil))
    ;; [U[`̈pt֐LΎs
    (if (fboundp 'my-glog-quote-header)
	(my-glog-quote-header))
    ;; pasteJn
    (setq rs (point))                           ;; Jn_oĂ
    (insert-buffer-substring pbuf ps pe)        ;; pbufpaste
    (save-excursion
      (if (and (bolp) (> (count-lines rs (point)) 0))
	  (progn
	    (previous-line 1)
	    (end-of-line)))                     ;; (s[␳)
      (setq re (point)))                        ;; I_o܂
    ;; pݒ肳Ă
    (if glog-quote-string
	(progn
	  ;; pݒ
	  (setq quote glog-quote-string)
	  ;; p̓̕L̏ɒu
	  (setq quote (glog-replace-symbol
		       quote "#MESNO#"
		       (if mesid
			   mesid  ;; Message-IdL΂g
			 (if mesno (int-to-string mesno) nil))))
	  (setq quote (glog-replace-symbol quote "#TITLE#"  title))
	  (setq quote (glog-replace-symbol quote "#ID#"     id))
	  (setq quote (glog-replace-symbol quote "#AUTHOR#" author))
	  (setq quote (glog-replace-symbol quote "#COMNO#"  com-no))
	  (setq quote (glog-replace-symbol quote "#MESID#"  mesid))
	  (setq quote (glog-replace-symbol quote "#IDATE#"  idate))
	  ;; p}
	  (save-excursion
	    (save-restriction
	      (narrow-to-region rs re)
	      (beginning-of-buffer)
	      (replace-regexp "^" quote)
	      (end-of-buffer)))))
    ;; [U[`̈pt֐LΎs
    (if (fboundp 'my-glog-quote-terminator)
	(my-glog-quote-terminator))))

(defun glog-Post-copy-from-article-and-paste (&optional all quote)
  ;; article-buffer̃[WRs[ptŃJgɃy[Xg.
  ;; `all'non-nilȂobt@SRs[.
  ;; `quote'non-nilȂpt.
  (let ((cbuf (current-buffer))(rs 0)(re 0))
    (if (glog-set-buffer glog-Article-buffer)
	(progn
	  (save-excursion
	    (if all
		(progn (setq rs (point-min))
		       (setq re (point-max)))
	      ;; [W𓾂([Wݒ肵ĖΑSobt@Ώ)
	      (condition-case ()
		  (progn (setq rs (region-beginning))
			 (setq re (region-end)))
		(error (progn (setq rs (point-min))
			      (setq re (point-max)))))))))
    ;; paste it!
    (set-buffer cbuf)
    (if (> (- re rs) 0)
	(if (not quote)
	    (insert-buffer-substring glog-Article-buffer rs re)
	  ;; insert quote string
	  (glog-Post-insert-quote glog-Article-buffer rs re)))))

(defun glog-Post-quote-from-article ()
  "article-buffer̃[WptŃy[Xg"
  (interactive)
  (glog-Post-copy-from-article-and-paste nil t))

(defun glog-Post-quote-from-article-all ()
  "article-buffeȓSeptŃy[Xg"
  (interactive)
  (glog-Post-copy-from-article-and-paste 'all t))

(defun glog-Post-copy-from-article ()
  "article-buffer̃[Wy[Xg"
  (interactive)
  (glog-Post-copy-from-article-and-paste nil nil))

(defun glog-Post-widen-buffer ()
  "Function of GLOG. Widen post buffer."
  (interactive)
  (glog-configure-windows '(0 0 0 1) glog-Post-buffer)
  (message
   (concat
    (substitute-command-keys "\\[glog-Post-show-reference]:Show reference  ")
    (substitute-command-keys "\\[glog-Post-describe-briefly]:help"))))

(defun glog-Post-show-reference ()
  "Function of GLOG. Show subject buffer."
  (interactive)
  (if glog-current-subject
      (glog-configure-windows 'PostNewsWithReference glog-Post-buffer))
  (message
   (concat
    (substitute-command-keys "\\[glog-Post-widen-buffer]:Widen buffer  ")
    (substitute-command-keys "\\[glog-Post-describe-briefly]:help"))))

(defun glog-Post-show-ruler ()
  "Postobt@̃[hC؂ւĒK\(gO)"
  (interactive)
  (let ((foo glog-ruler-string))
    (if (eq (selected-window) (get-buffer-window glog-Post-buffer))
	(progn
	  (setq glog-ruler-string mode-line-format)
	  (setq mode-line-format foo)
	  (recenter)))))

(defun glog-set-signature (&optional intflag)
  ;; post-buffersignaturet
  (let ((longname)(result nil))
    ;; signature-fileݒ肳ĂāAt@Cǂ߂Ȃ
    ;; tėǂ(A`glog-quiet-mode'tȂ牽ɕt)
    (if (and glog-signature-file
	     (setq longname (expand-file-name glog-signature-file))
	     (file-readable-p longname)
	     (or glog-quiet-mode
		 (or intflag (y-or-n-p "Shall I append your signature? "))))
	(progn
	  ;; t@Cǂݍ
	  (save-excursion
	    (insert-file-contents longname)
	    (setq result t))
	  ;; `#current-time-string#'Όݎɒu
	  (if (re-search-forward
	       "#current-time-string#" (point-max) t)
	      (replace-match (current-time-string) t t))))
    ;; Erase "y or n"
    (message "")
    result))

(defun glog-Post-set-signature ()
  "post-buffersignaturet. 
`my-glog-set-signature'ݒ肵ėL΂s."
  (interactive)
  (let ((intflag (interactive-p)))
    (save-excursion
      (if (fboundp 'my-glog-set-signature)
	  ;; [U[`̏ݒ֐L΂s
	  (if (my-glog-set-signature intflag)
	      (setq glog-post-data
		    (glog-set-list (cons 'signature t) glog-post-data)))
	(if (glog-set-signature intflag)
	    (setq glog-post-data
		  (glog-set-list (cons 'signature t) glog-post-data)))))))

(defun glog-Post-save-article ()
  "Jgpost-bufferƂ݂ȂēeZ[u"
  (interactive)
  (let ((fname)(cbuf)(result nil))
    ;; ܂signature
    (if (glog-assoc-list 'signature glog-post-data)
	()  ;; łsignatureĂpasteȂ
      (save-excursion
	(goto-char (point-max))
	(if (not (bolp))
	    (progn
	      (insert "\n")   ;; I[␳
	      (goto-char (point-max))))
	(glog-Post-set-signature)))
    ;; savefilename܂Ă邩?
    (if (setq fname buffer-file-name)
	(setq result t)
      ;; postt@C₢킹.
      (setq fname (expand-file-name (glog-require-file-name
				     "Post file" glog-post-file-name
				     glog-post-directory nil nil)))
      ;; ̃t@CɗLꍇ͏㏑ėǂ₢킹
      (if (or (not (file-readable-p fname))
	      glog-quiet-mode
	      (setq result (y-or-n-p "file exists. overwrite? ")))
	  (progn
	    (setq cbuf (buffer-name))
	    (set-visited-file-name fname) ;; buffervisitĂfile
	    (if (not (eq cbuf (buffer-name)))
		(rename-buffer cbuf))
	    (setq result t))))
    (if result
	(save-excursion
	  ;; BBS̏I(/E)
	  (if (fboundp 'my-glog-set-post-terminator)
	      ;; [U[`̏I֐L΂s
	      (my-glog-set-post-terminator)
	    (glog-set-post-terminator))
	  ;; Abv[h`FbN
	  (setq result (if (fboundp 'my-glog-check-post)
			   (my-glog-check-post)
			 (glog-check-post)))))
    ;; saveĂOKȂ
    (if result
	(condition-case ()
	    (progn
	      (save-buffer)
	      (setq glog-post-file-name buffer-file-name)
	      (setq result t))
	  (error (setq result nil)))
      (message "canseled."))
    result))

(defun glog-Post-exit ()
  "post-buffer̓eZ[uexit"
  (interactive)
  (let ((cbuf (current-buffer)))
    (if (glog-Post-save-article)
	(progn
	  (if glog-current-subject
	      (glog-configure-windows 'SelectArticle glog-Subject-buffer)
	    (delete-windows-on glog-Post-buffer))
	  ;; post-bufferZ[uĂkillĂCC?
	  (if (not (buffer-modified-p cbuf))
	      (kill-buffer cbuf))))))

(defun glog-Post-quit ()
  "post-buffer̓eZ[uexit"
  (interactive)
  ;; Z[uȂėǂ(A`glog-quiet-mode'tȂ牽ɏI)
  (if (or (not (buffer-modified-p))
	  glog-quiet-mode
	  (y-or-n-p "Do you really quit without save? "))
      (progn
	(setq glog-post-file-name nil)
	(if glog-current-subject
	    (glog-configure-windows 'SelectArticle glog-Subject-buffer)
	  (delete-windows-on glog-Post-buffer))))
  ;; Erase "y or n"
  (message ""))

(defun glog-Post-describe-briefly ()
  "Describe Post mode commands briefly."
  (interactive)
  (message
   (concat
    (substitute-command-keys "\\[glog-Post-exit]:Save and Exit  ")
    (substitute-command-keys "\\[glog-Post-quit]:Quit  ")
    (substitute-command-keys "\\[glog-pause]:Pause  ")
    (substitute-command-keys "\\[glog-Info-find-node]:Run Info  ")
    (substitute-command-keys "\\[glog-Post-describe-briefly]:This help")
    )))

(provide 'glog_utl)

;;; glog_utl.el ends here
